package tools.descartes.dql.lang.ui;

import java.util.Iterator;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.xtext.ide.editor.syntaxcoloring.IHighlightedPositionAcceptor;
import org.eclipse.xtext.ide.editor.syntaxcoloring.ISemanticHighlightingCalculator;
import org.eclipse.xtext.nodemodel.INode;
import org.eclipse.xtext.nodemodel.util.NodeModelUtils;
import org.eclipse.xtext.resource.XtextResource;
import org.eclipse.xtext.ui.editor.syntaxcoloring.DefaultHighlightingConfiguration;
import org.eclipse.xtext.util.CancelIndicator;

import tools.descartes.dql.lang.descartesQL.DescartesQLPackage;
import tools.descartes.dql.lang.descartesQL.EntityReference;

public class SyntaxHighlighting implements ISemanticHighlightingCalculator {

	@Override
	public void provideHighlightingFor(XtextResource arg0, IHighlightedPositionAcceptor arg1, CancelIndicator arg2) {
		for (Iterator<EObject> contents = arg0.getAllContents(); contents.hasNext();) {
			EObject element = contents.next();
			if (element instanceof EntityReference)
				highlightAsDataType(element, DescartesQLPackage.Literals.ENTITY_REFERENCE__TYPE, arg1);
		}
	}

	protected void highlightAsDataType(EObject element, EStructuralFeature feature,
			IHighlightedPositionAcceptor acceptor) {
		for (INode node : NodeModelUtils.findNodesForFeature(element, feature))
			acceptor.addPosition(node.getOffset(), node.getLength(), DefaultHighlightingConfiguration.KEYWORD_ID);
	}

}