/**
 * ==============================================
 *  DQL : Descartes Query Language
 * ==============================================
 * 
 * (c) Copyright 2014-2016, by Juergen Walter, Fabian Gorsler, Fabian Brosig and other contributors.
 * 
 * Project Info:   http://descartes.tools/dql
 * 
 * All rights reserved. This software is made available under the terms of the 
 * Eclipse Public License (EPL) v1.0 as published by the Eclipse Foundation
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * This software is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License (EPL)
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License (EPL)
 * along with this software; if not visit http://www.eclipse.org or write to
 * Eclipse Foundation, Inc., 308 SW First Avenue, Suite 110, Portland, 97204 USA
 * Email: license (at) eclipse.org 
 * 
 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
 * in the United States and other countries.]
 */
package tools.descartes.dql.lang.descartesQL;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Metric Reference</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.MetricReference#getEntityReference <em>Entity Reference</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.MetricReference#getSeparator <em>Separator</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.MetricReference#getMetricReference <em>Metric Reference</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.MetricReference#getSeparatorv <em>Separatorv</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.MetricReference#getStatTypeReference <em>Stat Type Reference</em>}</li>
 * </ul>
 *
 * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getMetricReference()
 * @model
 * @generated
 */
public interface MetricReference extends EObject
{
  /**
   * Returns the value of the '<em><b>Entity Reference</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Entity Reference</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Entity Reference</em>' attribute.
   * @see #setEntityReference(String)
   * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getMetricReference_EntityReference()
   * @model
   * @generated
   */
  String getEntityReference();

  /**
   * Sets the value of the '{@link tools.descartes.dql.lang.descartesQL.MetricReference#getEntityReference <em>Entity Reference</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Entity Reference</em>' attribute.
   * @see #getEntityReference()
   * @generated
   */
  void setEntityReference(String value);

  /**
   * Returns the value of the '<em><b>Separator</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Separator</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Separator</em>' attribute.
   * @see #setSeparator(String)
   * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getMetricReference_Separator()
   * @model
   * @generated
   */
  String getSeparator();

  /**
   * Sets the value of the '{@link tools.descartes.dql.lang.descartesQL.MetricReference#getSeparator <em>Separator</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Separator</em>' attribute.
   * @see #getSeparator()
   * @generated
   */
  void setSeparator(String value);

  /**
   * Returns the value of the '<em><b>Metric Reference</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Metric Reference</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Metric Reference</em>' attribute.
   * @see #setMetricReference(String)
   * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getMetricReference_MetricReference()
   * @model
   * @generated
   */
  String getMetricReference();

  /**
   * Sets the value of the '{@link tools.descartes.dql.lang.descartesQL.MetricReference#getMetricReference <em>Metric Reference</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Metric Reference</em>' attribute.
   * @see #getMetricReference()
   * @generated
   */
  void setMetricReference(String value);

  /**
   * Returns the value of the '<em><b>Separatorv</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Separatorv</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Separatorv</em>' attribute.
   * @see #setSeparatorv(String)
   * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getMetricReference_Separatorv()
   * @model
   * @generated
   */
  String getSeparatorv();

  /**
   * Sets the value of the '{@link tools.descartes.dql.lang.descartesQL.MetricReference#getSeparatorv <em>Separatorv</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Separatorv</em>' attribute.
   * @see #getSeparatorv()
   * @generated
   */
  void setSeparatorv(String value);

  /**
   * Returns the value of the '<em><b>Stat Type Reference</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Stat Type Reference</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Stat Type Reference</em>' attribute.
   * @see #setStatTypeReference(String)
   * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getMetricReference_StatTypeReference()
   * @model
   * @generated
   */
  String getStatTypeReference();

  /**
   * Sets the value of the '{@link tools.descartes.dql.lang.descartesQL.MetricReference#getStatTypeReference <em>Stat Type Reference</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Stat Type Reference</em>' attribute.
   * @see #getStatTypeReference()
   * @generated
   */
  void setStatTypeReference(String value);

} // MetricReference
