/**
 * ==============================================
 *  DQL : Descartes Query Language
 * ==============================================
 * 
 * (c) Copyright 2014-2016, by Juergen Walter, Fabian Gorsler, Fabian Brosig and other contributors.
 * 
 * Project Info:   http://descartes.tools/dql
 * 
 * All rights reserved. This software is made available under the terms of the 
 * Eclipse Public License (EPL) v1.0 as published by the Eclipse Foundation
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * This software is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License (EPL)
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License (EPL)
 * along with this software; if not visit http://www.eclipse.org or write to
 * Eclipse Foundation, Inc., 308 SW First Avenue, Suite 110, Portland, 97204 USA
 * Email: license (at) eclipse.org 
 * 
 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
 * in the United States and other countries.]
 */
package tools.descartes.dql.lang.descartesQL;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>What If Query</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.WhatIfQuery#getWhatIfVariation <em>What If Variation</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.WhatIfQuery#getMetricReferenceClauses <em>Metric Reference Clauses</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.WhatIfQuery#getForClause <em>For Clause</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.WhatIfQuery#getFilteringClause <em>Filtering Clause</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.WhatIfQuery#getDeltaClause <em>Delta Clause</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.WhatIfQuery#getUsingClause <em>Using Clause</em>}</li>
 * </ul>
 *
 * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getWhatIfQuery()
 * @model
 * @generated
 */
public interface WhatIfQuery extends EObject
{
  /**
   * Returns the value of the '<em><b>What If Variation</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>What If Variation</em>' containment reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>What If Variation</em>' containment reference.
   * @see #setWhatIfVariation(WhatIfVariation)
   * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getWhatIfQuery_WhatIfVariation()
   * @model containment="true"
   * @generated
   */
  WhatIfVariation getWhatIfVariation();

  /**
   * Sets the value of the '{@link tools.descartes.dql.lang.descartesQL.WhatIfQuery#getWhatIfVariation <em>What If Variation</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>What If Variation</em>' containment reference.
   * @see #getWhatIfVariation()
   * @generated
   */
  void setWhatIfVariation(WhatIfVariation value);

  /**
   * Returns the value of the '<em><b>Metric Reference Clauses</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Metric Reference Clauses</em>' containment reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Metric Reference Clauses</em>' containment reference.
   * @see #setMetricReferenceClauses(MetricReferenceClauses)
   * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getWhatIfQuery_MetricReferenceClauses()
   * @model containment="true"
   * @generated
   */
  MetricReferenceClauses getMetricReferenceClauses();

  /**
   * Sets the value of the '{@link tools.descartes.dql.lang.descartesQL.WhatIfQuery#getMetricReferenceClauses <em>Metric Reference Clauses</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Metric Reference Clauses</em>' containment reference.
   * @see #getMetricReferenceClauses()
   * @generated
   */
  void setMetricReferenceClauses(MetricReferenceClauses value);

  /**
   * Returns the value of the '<em><b>For Clause</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>For Clause</em>' containment reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>For Clause</em>' containment reference.
   * @see #setForClause(ForClause)
   * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getWhatIfQuery_ForClause()
   * @model containment="true"
   * @generated
   */
  ForClause getForClause();

  /**
   * Sets the value of the '{@link tools.descartes.dql.lang.descartesQL.WhatIfQuery#getForClause <em>For Clause</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>For Clause</em>' containment reference.
   * @see #getForClause()
   * @generated
   */
  void setForClause(ForClause value);

  /**
   * Returns the value of the '<em><b>Filtering Clause</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Filtering Clause</em>' containment reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Filtering Clause</em>' containment reference.
   * @see #setFilteringClause(FilteringClause)
   * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getWhatIfQuery_FilteringClause()
   * @model containment="true"
   * @generated
   */
  FilteringClause getFilteringClause();

  /**
   * Sets the value of the '{@link tools.descartes.dql.lang.descartesQL.WhatIfQuery#getFilteringClause <em>Filtering Clause</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Filtering Clause</em>' containment reference.
   * @see #getFilteringClause()
   * @generated
   */
  void setFilteringClause(FilteringClause value);

  /**
   * Returns the value of the '<em><b>Delta Clause</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Delta Clause</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Delta Clause</em>' attribute.
   * @see #setDeltaClause(String)
   * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getWhatIfQuery_DeltaClause()
   * @model
   * @generated
   */
  String getDeltaClause();

  /**
   * Sets the value of the '{@link tools.descartes.dql.lang.descartesQL.WhatIfQuery#getDeltaClause <em>Delta Clause</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Delta Clause</em>' attribute.
   * @see #getDeltaClause()
   * @generated
   */
  void setDeltaClause(String value);

  /**
   * Returns the value of the '<em><b>Using Clause</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Using Clause</em>' containment reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Using Clause</em>' containment reference.
   * @see #setUsingClause(UsingClause)
   * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getWhatIfQuery_UsingClause()
   * @model containment="true"
   * @generated
   */
  UsingClause getUsingClause();

  /**
   * Sets the value of the '{@link tools.descartes.dql.lang.descartesQL.WhatIfQuery#getUsingClause <em>Using Clause</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Using Clause</em>' containment reference.
   * @see #getUsingClause()
   * @generated
   */
  void setUsingClause(UsingClause value);

} // WhatIfQuery
