/**
 * ==============================================
 *  DQL : Descartes Query Language
 * ==============================================
 * 
 * (c) Copyright 2014-2016, by Juergen Walter, Fabian Gorsler, Fabian Brosig and other contributors.
 * 
 * Project Info:   http://descartes.tools/dql
 * 
 * All rights reserved. This software is made available under the terms of the 
 * Eclipse Public License (EPL) v1.0 as published by the Eclipse Foundation
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * This software is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License (EPL)
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License (EPL)
 * along with this software; if not visit http://www.eclipse.org or write to
 * Eclipse Foundation, Inc., 308 SW First Avenue, Suite 110, Portland, 97204 USA
 * Email: license (at) eclipse.org 
 * 
 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
 * in the United States and other countries.]
 */
package tools.descartes.dql.lang.descartesQL;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>What If Value Variation Clause</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.WhatIfValueVariationClause#getDofVariationClause <em>Dof Variation Clause</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.WhatIfValueVariationClause#getMultipleArithmethicClause <em>Multiple Arithmethic Clause</em>}</li>
 * </ul>
 *
 * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getWhatIfValueVariationClause()
 * @model
 * @generated
 */
public interface WhatIfValueVariationClause extends EObject
{
  /**
   * Returns the value of the '<em><b>Dof Variation Clause</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Dof Variation Clause</em>' containment reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Dof Variation Clause</em>' containment reference.
   * @see #setDofVariationClause(DoFVariationClause)
   * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getWhatIfValueVariationClause_DofVariationClause()
   * @model containment="true"
   * @generated
   */
  DoFVariationClause getDofVariationClause();

  /**
   * Sets the value of the '{@link tools.descartes.dql.lang.descartesQL.WhatIfValueVariationClause#getDofVariationClause <em>Dof Variation Clause</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Dof Variation Clause</em>' containment reference.
   * @see #getDofVariationClause()
   * @generated
   */
  void setDofVariationClause(DoFVariationClause value);

  /**
   * Returns the value of the '<em><b>Multiple Arithmethic Clause</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Multiple Arithmethic Clause</em>' containment reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Multiple Arithmethic Clause</em>' containment reference.
   * @see #setMultipleArithmethicClause(MultipleArithmeticClause)
   * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getWhatIfValueVariationClause_MultipleArithmethicClause()
   * @model containment="true"
   * @generated
   */
  MultipleArithmeticClause getMultipleArithmethicClause();

  /**
   * Sets the value of the '{@link tools.descartes.dql.lang.descartesQL.WhatIfValueVariationClause#getMultipleArithmethicClause <em>Multiple Arithmethic Clause</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Multiple Arithmethic Clause</em>' containment reference.
   * @see #getMultipleArithmethicClause()
   * @generated
   */
  void setMultipleArithmethicClause(MultipleArithmeticClause value);

} // WhatIfValueVariationClause
