/**
 * ==============================================
 *  DQL : Descartes Query Language
 * ==============================================
 * 
 * (c) Copyright 2014-2016, by Juergen Walter, Fabian Gorsler, Fabian Brosig and other contributors.
 * 
 * Project Info:   http://descartes.tools/dql
 * 
 * All rights reserved. This software is made available under the terms of the 
 * Eclipse Public License (EPL) v1.0 as published by the Eclipse Foundation
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * This software is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License (EPL)
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License (EPL)
 * along with this software; if not visit http://www.eclipse.org or write to
 * Eclipse Foundation, Inc., 308 SW First Avenue, Suite 110, Portland, 97204 USA
 * Email: license (at) eclipse.org 
 * 
 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
 * in the United States and other countries.]
 */
package tools.descartes.dql.lang.descartesQL.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

import tools.descartes.dql.lang.descartesQL.ConstraintClause;
import tools.descartes.dql.lang.descartesQL.DescartesQLPackage;
import tools.descartes.dql.lang.descartesQL.DoFClause;
import tools.descartes.dql.lang.descartesQL.ExplorationStrategyClause;
import tools.descartes.dql.lang.descartesQL.VaryingClause;
import tools.descartes.dql.lang.descartesQL.WithClause;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Do FClause</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.impl.DoFClauseImpl#getMode <em>Mode</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.impl.DoFClauseImpl#getVaryingClause <em>Varying Clause</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.impl.DoFClauseImpl#getExplorationStrategy <em>Exploration Strategy</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.impl.DoFClauseImpl#getConstraintClause <em>Constraint Clause</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.impl.DoFClauseImpl#getWithClause <em>With Clause</em>}</li>
 * </ul>
 *
 * @generated
 */
public class DoFClauseImpl extends MinimalEObjectImpl.Container implements DoFClause
{
  /**
   * The default value of the '{@link #getMode() <em>Mode</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getMode()
   * @generated
   * @ordered
   */
  protected static final String MODE_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getMode() <em>Mode</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getMode()
   * @generated
   * @ordered
   */
  protected String mode = MODE_EDEFAULT;

  /**
   * The cached value of the '{@link #getVaryingClause() <em>Varying Clause</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getVaryingClause()
   * @generated
   * @ordered
   */
  protected VaryingClause varyingClause;

  /**
   * The cached value of the '{@link #getExplorationStrategy() <em>Exploration Strategy</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getExplorationStrategy()
   * @generated
   * @ordered
   */
  protected ExplorationStrategyClause explorationStrategy;

  /**
   * The cached value of the '{@link #getConstraintClause() <em>Constraint Clause</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getConstraintClause()
   * @generated
   * @ordered
   */
  protected ConstraintClause constraintClause;

  /**
   * The cached value of the '{@link #getWithClause() <em>With Clause</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getWithClause()
   * @generated
   * @ordered
   */
  protected WithClause withClause;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected DoFClauseImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return DescartesQLPackage.Literals.DO_FCLAUSE;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getMode()
  {
    return mode;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setMode(String newMode)
  {
    String oldMode = mode;
    mode = newMode;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, DescartesQLPackage.DO_FCLAUSE__MODE, oldMode, mode));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public VaryingClause getVaryingClause()
  {
    return varyingClause;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetVaryingClause(VaryingClause newVaryingClause, NotificationChain msgs)
  {
    VaryingClause oldVaryingClause = varyingClause;
    varyingClause = newVaryingClause;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, DescartesQLPackage.DO_FCLAUSE__VARYING_CLAUSE, oldVaryingClause, newVaryingClause);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setVaryingClause(VaryingClause newVaryingClause)
  {
    if (newVaryingClause != varyingClause)
    {
      NotificationChain msgs = null;
      if (varyingClause != null)
        msgs = ((InternalEObject)varyingClause).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - DescartesQLPackage.DO_FCLAUSE__VARYING_CLAUSE, null, msgs);
      if (newVaryingClause != null)
        msgs = ((InternalEObject)newVaryingClause).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - DescartesQLPackage.DO_FCLAUSE__VARYING_CLAUSE, null, msgs);
      msgs = basicSetVaryingClause(newVaryingClause, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, DescartesQLPackage.DO_FCLAUSE__VARYING_CLAUSE, newVaryingClause, newVaryingClause));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ExplorationStrategyClause getExplorationStrategy()
  {
    return explorationStrategy;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetExplorationStrategy(ExplorationStrategyClause newExplorationStrategy, NotificationChain msgs)
  {
    ExplorationStrategyClause oldExplorationStrategy = explorationStrategy;
    explorationStrategy = newExplorationStrategy;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, DescartesQLPackage.DO_FCLAUSE__EXPLORATION_STRATEGY, oldExplorationStrategy, newExplorationStrategy);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setExplorationStrategy(ExplorationStrategyClause newExplorationStrategy)
  {
    if (newExplorationStrategy != explorationStrategy)
    {
      NotificationChain msgs = null;
      if (explorationStrategy != null)
        msgs = ((InternalEObject)explorationStrategy).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - DescartesQLPackage.DO_FCLAUSE__EXPLORATION_STRATEGY, null, msgs);
      if (newExplorationStrategy != null)
        msgs = ((InternalEObject)newExplorationStrategy).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - DescartesQLPackage.DO_FCLAUSE__EXPLORATION_STRATEGY, null, msgs);
      msgs = basicSetExplorationStrategy(newExplorationStrategy, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, DescartesQLPackage.DO_FCLAUSE__EXPLORATION_STRATEGY, newExplorationStrategy, newExplorationStrategy));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ConstraintClause getConstraintClause()
  {
    return constraintClause;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetConstraintClause(ConstraintClause newConstraintClause, NotificationChain msgs)
  {
    ConstraintClause oldConstraintClause = constraintClause;
    constraintClause = newConstraintClause;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, DescartesQLPackage.DO_FCLAUSE__CONSTRAINT_CLAUSE, oldConstraintClause, newConstraintClause);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setConstraintClause(ConstraintClause newConstraintClause)
  {
    if (newConstraintClause != constraintClause)
    {
      NotificationChain msgs = null;
      if (constraintClause != null)
        msgs = ((InternalEObject)constraintClause).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - DescartesQLPackage.DO_FCLAUSE__CONSTRAINT_CLAUSE, null, msgs);
      if (newConstraintClause != null)
        msgs = ((InternalEObject)newConstraintClause).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - DescartesQLPackage.DO_FCLAUSE__CONSTRAINT_CLAUSE, null, msgs);
      msgs = basicSetConstraintClause(newConstraintClause, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, DescartesQLPackage.DO_FCLAUSE__CONSTRAINT_CLAUSE, newConstraintClause, newConstraintClause));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public WithClause getWithClause()
  {
    return withClause;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetWithClause(WithClause newWithClause, NotificationChain msgs)
  {
    WithClause oldWithClause = withClause;
    withClause = newWithClause;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, DescartesQLPackage.DO_FCLAUSE__WITH_CLAUSE, oldWithClause, newWithClause);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setWithClause(WithClause newWithClause)
  {
    if (newWithClause != withClause)
    {
      NotificationChain msgs = null;
      if (withClause != null)
        msgs = ((InternalEObject)withClause).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - DescartesQLPackage.DO_FCLAUSE__WITH_CLAUSE, null, msgs);
      if (newWithClause != null)
        msgs = ((InternalEObject)newWithClause).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - DescartesQLPackage.DO_FCLAUSE__WITH_CLAUSE, null, msgs);
      msgs = basicSetWithClause(newWithClause, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, DescartesQLPackage.DO_FCLAUSE__WITH_CLAUSE, newWithClause, newWithClause));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case DescartesQLPackage.DO_FCLAUSE__VARYING_CLAUSE:
        return basicSetVaryingClause(null, msgs);
      case DescartesQLPackage.DO_FCLAUSE__EXPLORATION_STRATEGY:
        return basicSetExplorationStrategy(null, msgs);
      case DescartesQLPackage.DO_FCLAUSE__CONSTRAINT_CLAUSE:
        return basicSetConstraintClause(null, msgs);
      case DescartesQLPackage.DO_FCLAUSE__WITH_CLAUSE:
        return basicSetWithClause(null, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case DescartesQLPackage.DO_FCLAUSE__MODE:
        return getMode();
      case DescartesQLPackage.DO_FCLAUSE__VARYING_CLAUSE:
        return getVaryingClause();
      case DescartesQLPackage.DO_FCLAUSE__EXPLORATION_STRATEGY:
        return getExplorationStrategy();
      case DescartesQLPackage.DO_FCLAUSE__CONSTRAINT_CLAUSE:
        return getConstraintClause();
      case DescartesQLPackage.DO_FCLAUSE__WITH_CLAUSE:
        return getWithClause();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case DescartesQLPackage.DO_FCLAUSE__MODE:
        setMode((String)newValue);
        return;
      case DescartesQLPackage.DO_FCLAUSE__VARYING_CLAUSE:
        setVaryingClause((VaryingClause)newValue);
        return;
      case DescartesQLPackage.DO_FCLAUSE__EXPLORATION_STRATEGY:
        setExplorationStrategy((ExplorationStrategyClause)newValue);
        return;
      case DescartesQLPackage.DO_FCLAUSE__CONSTRAINT_CLAUSE:
        setConstraintClause((ConstraintClause)newValue);
        return;
      case DescartesQLPackage.DO_FCLAUSE__WITH_CLAUSE:
        setWithClause((WithClause)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case DescartesQLPackage.DO_FCLAUSE__MODE:
        setMode(MODE_EDEFAULT);
        return;
      case DescartesQLPackage.DO_FCLAUSE__VARYING_CLAUSE:
        setVaryingClause((VaryingClause)null);
        return;
      case DescartesQLPackage.DO_FCLAUSE__EXPLORATION_STRATEGY:
        setExplorationStrategy((ExplorationStrategyClause)null);
        return;
      case DescartesQLPackage.DO_FCLAUSE__CONSTRAINT_CLAUSE:
        setConstraintClause((ConstraintClause)null);
        return;
      case DescartesQLPackage.DO_FCLAUSE__WITH_CLAUSE:
        setWithClause((WithClause)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case DescartesQLPackage.DO_FCLAUSE__MODE:
        return MODE_EDEFAULT == null ? mode != null : !MODE_EDEFAULT.equals(mode);
      case DescartesQLPackage.DO_FCLAUSE__VARYING_CLAUSE:
        return varyingClause != null;
      case DescartesQLPackage.DO_FCLAUSE__EXPLORATION_STRATEGY:
        return explorationStrategy != null;
      case DescartesQLPackage.DO_FCLAUSE__CONSTRAINT_CLAUSE:
        return constraintClause != null;
      case DescartesQLPackage.DO_FCLAUSE__WITH_CLAUSE:
        return withClause != null;
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (mode: ");
    result.append(mode);
    result.append(')');
    return result.toString();
  }

} //DoFClauseImpl
