/**
 * ==============================================
 *  DQL : Descartes Query Language
 * ==============================================
 * 
 * (c) Copyright 2014-2016, by Juergen Walter, Fabian Gorsler, Fabian Brosig and other contributors.
 * 
 * Project Info:   http://descartes.tools/dql
 * 
 * All rights reserved. This software is made available under the terms of the 
 * Eclipse Public License (EPL) v1.0 as published by the Eclipse Foundation
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * This software is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License (EPL)
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License (EPL)
 * along with this software; if not visit http://www.eclipse.org or write to
 * Eclipse Foundation, Inc., 308 SW First Avenue, Suite 110, Portland, 97204 USA
 * Email: license (at) eclipse.org 
 * 
 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
 * in the United States and other countries.]
 */
package tools.descartes.dql.lang.descartesQL.impl;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

import tools.descartes.dql.lang.descartesQL.DescartesQLPackage;
import tools.descartes.dql.lang.descartesQL.MetricReference;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Metric Reference</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.impl.MetricReferenceImpl#getEntityReference <em>Entity Reference</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.impl.MetricReferenceImpl#getSeparator <em>Separator</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.impl.MetricReferenceImpl#getMetricReference <em>Metric Reference</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.impl.MetricReferenceImpl#getSeparatorv <em>Separatorv</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.impl.MetricReferenceImpl#getStatTypeReference <em>Stat Type Reference</em>}</li>
 * </ul>
 *
 * @generated
 */
public class MetricReferenceImpl extends MinimalEObjectImpl.Container implements MetricReference
{
  /**
   * The default value of the '{@link #getEntityReference() <em>Entity Reference</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getEntityReference()
   * @generated
   * @ordered
   */
  protected static final String ENTITY_REFERENCE_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getEntityReference() <em>Entity Reference</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getEntityReference()
   * @generated
   * @ordered
   */
  protected String entityReference = ENTITY_REFERENCE_EDEFAULT;

  /**
   * The default value of the '{@link #getSeparator() <em>Separator</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getSeparator()
   * @generated
   * @ordered
   */
  protected static final String SEPARATOR_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getSeparator() <em>Separator</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getSeparator()
   * @generated
   * @ordered
   */
  protected String separator = SEPARATOR_EDEFAULT;

  /**
   * The default value of the '{@link #getMetricReference() <em>Metric Reference</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getMetricReference()
   * @generated
   * @ordered
   */
  protected static final String METRIC_REFERENCE_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getMetricReference() <em>Metric Reference</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getMetricReference()
   * @generated
   * @ordered
   */
  protected String metricReference = METRIC_REFERENCE_EDEFAULT;

  /**
   * The default value of the '{@link #getSeparatorv() <em>Separatorv</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getSeparatorv()
   * @generated
   * @ordered
   */
  protected static final String SEPARATORV_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getSeparatorv() <em>Separatorv</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getSeparatorv()
   * @generated
   * @ordered
   */
  protected String separatorv = SEPARATORV_EDEFAULT;

  /**
   * The default value of the '{@link #getStatTypeReference() <em>Stat Type Reference</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getStatTypeReference()
   * @generated
   * @ordered
   */
  protected static final String STAT_TYPE_REFERENCE_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getStatTypeReference() <em>Stat Type Reference</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getStatTypeReference()
   * @generated
   * @ordered
   */
  protected String statTypeReference = STAT_TYPE_REFERENCE_EDEFAULT;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected MetricReferenceImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return DescartesQLPackage.Literals.METRIC_REFERENCE;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getEntityReference()
  {
    return entityReference;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setEntityReference(String newEntityReference)
  {
    String oldEntityReference = entityReference;
    entityReference = newEntityReference;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, DescartesQLPackage.METRIC_REFERENCE__ENTITY_REFERENCE, oldEntityReference, entityReference));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getSeparator()
  {
    return separator;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setSeparator(String newSeparator)
  {
    String oldSeparator = separator;
    separator = newSeparator;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, DescartesQLPackage.METRIC_REFERENCE__SEPARATOR, oldSeparator, separator));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getMetricReference()
  {
    return metricReference;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setMetricReference(String newMetricReference)
  {
    String oldMetricReference = metricReference;
    metricReference = newMetricReference;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, DescartesQLPackage.METRIC_REFERENCE__METRIC_REFERENCE, oldMetricReference, metricReference));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getSeparatorv()
  {
    return separatorv;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setSeparatorv(String newSeparatorv)
  {
    String oldSeparatorv = separatorv;
    separatorv = newSeparatorv;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, DescartesQLPackage.METRIC_REFERENCE__SEPARATORV, oldSeparatorv, separatorv));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getStatTypeReference()
  {
    return statTypeReference;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setStatTypeReference(String newStatTypeReference)
  {
    String oldStatTypeReference = statTypeReference;
    statTypeReference = newStatTypeReference;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, DescartesQLPackage.METRIC_REFERENCE__STAT_TYPE_REFERENCE, oldStatTypeReference, statTypeReference));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case DescartesQLPackage.METRIC_REFERENCE__ENTITY_REFERENCE:
        return getEntityReference();
      case DescartesQLPackage.METRIC_REFERENCE__SEPARATOR:
        return getSeparator();
      case DescartesQLPackage.METRIC_REFERENCE__METRIC_REFERENCE:
        return getMetricReference();
      case DescartesQLPackage.METRIC_REFERENCE__SEPARATORV:
        return getSeparatorv();
      case DescartesQLPackage.METRIC_REFERENCE__STAT_TYPE_REFERENCE:
        return getStatTypeReference();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case DescartesQLPackage.METRIC_REFERENCE__ENTITY_REFERENCE:
        setEntityReference((String)newValue);
        return;
      case DescartesQLPackage.METRIC_REFERENCE__SEPARATOR:
        setSeparator((String)newValue);
        return;
      case DescartesQLPackage.METRIC_REFERENCE__METRIC_REFERENCE:
        setMetricReference((String)newValue);
        return;
      case DescartesQLPackage.METRIC_REFERENCE__SEPARATORV:
        setSeparatorv((String)newValue);
        return;
      case DescartesQLPackage.METRIC_REFERENCE__STAT_TYPE_REFERENCE:
        setStatTypeReference((String)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case DescartesQLPackage.METRIC_REFERENCE__ENTITY_REFERENCE:
        setEntityReference(ENTITY_REFERENCE_EDEFAULT);
        return;
      case DescartesQLPackage.METRIC_REFERENCE__SEPARATOR:
        setSeparator(SEPARATOR_EDEFAULT);
        return;
      case DescartesQLPackage.METRIC_REFERENCE__METRIC_REFERENCE:
        setMetricReference(METRIC_REFERENCE_EDEFAULT);
        return;
      case DescartesQLPackage.METRIC_REFERENCE__SEPARATORV:
        setSeparatorv(SEPARATORV_EDEFAULT);
        return;
      case DescartesQLPackage.METRIC_REFERENCE__STAT_TYPE_REFERENCE:
        setStatTypeReference(STAT_TYPE_REFERENCE_EDEFAULT);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case DescartesQLPackage.METRIC_REFERENCE__ENTITY_REFERENCE:
        return ENTITY_REFERENCE_EDEFAULT == null ? entityReference != null : !ENTITY_REFERENCE_EDEFAULT.equals(entityReference);
      case DescartesQLPackage.METRIC_REFERENCE__SEPARATOR:
        return SEPARATOR_EDEFAULT == null ? separator != null : !SEPARATOR_EDEFAULT.equals(separator);
      case DescartesQLPackage.METRIC_REFERENCE__METRIC_REFERENCE:
        return METRIC_REFERENCE_EDEFAULT == null ? metricReference != null : !METRIC_REFERENCE_EDEFAULT.equals(metricReference);
      case DescartesQLPackage.METRIC_REFERENCE__SEPARATORV:
        return SEPARATORV_EDEFAULT == null ? separatorv != null : !SEPARATORV_EDEFAULT.equals(separatorv);
      case DescartesQLPackage.METRIC_REFERENCE__STAT_TYPE_REFERENCE:
        return STAT_TYPE_REFERENCE_EDEFAULT == null ? statTypeReference != null : !STAT_TYPE_REFERENCE_EDEFAULT.equals(statTypeReference);
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (entityReference: ");
    result.append(entityReference);
    result.append(", separator: ");
    result.append(separator);
    result.append(", metricReference: ");
    result.append(metricReference);
    result.append(", separatorv: ");
    result.append(separatorv);
    result.append(", statTypeReference: ");
    result.append(statTypeReference);
    result.append(')');
    return result.toString();
  }

} //MetricReferenceImpl
