/**
 * ==============================================
 *  DQL : Descartes Query Language
 * ==============================================
 * 
 * (c) Copyright 2014-2016, by Juergen Walter, Fabian Gorsler, Fabian Brosig and other contributors.
 * 
 * Project Info:   http://descartes.tools/dql
 * 
 * All rights reserved. This software is made available under the terms of the 
 * Eclipse Public License (EPL) v1.0 as published by the Eclipse Foundation
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * This software is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License (EPL)
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License (EPL)
 * along with this software; if not visit http://www.eclipse.org or write to
 * Eclipse Foundation, Inc., 308 SW First Avenue, Suite 110, Portland, 97204 USA
 * Email: license (at) eclipse.org 
 * 
 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
 * in the United States and other countries.]
 */
package tools.descartes.dql.lang.descartesQL.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

import tools.descartes.dql.lang.descartesQL.DescartesQLPackage;
import tools.descartes.dql.lang.descartesQL.DoFVariationClause;
import tools.descartes.dql.lang.descartesQL.MultipleArithmeticClause;
import tools.descartes.dql.lang.descartesQL.WhatIfValueVariationClause;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>What If Value Variation Clause</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.impl.WhatIfValueVariationClauseImpl#getDofVariationClause <em>Dof Variation Clause</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.impl.WhatIfValueVariationClauseImpl#getMultipleArithmethicClause <em>Multiple Arithmethic Clause</em>}</li>
 * </ul>
 *
 * @generated
 */
public class WhatIfValueVariationClauseImpl extends MinimalEObjectImpl.Container implements WhatIfValueVariationClause
{
  /**
   * The cached value of the '{@link #getDofVariationClause() <em>Dof Variation Clause</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getDofVariationClause()
   * @generated
   * @ordered
   */
  protected DoFVariationClause dofVariationClause;

  /**
   * The cached value of the '{@link #getMultipleArithmethicClause() <em>Multiple Arithmethic Clause</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getMultipleArithmethicClause()
   * @generated
   * @ordered
   */
  protected MultipleArithmeticClause multipleArithmethicClause;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected WhatIfValueVariationClauseImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return DescartesQLPackage.Literals.WHAT_IF_VALUE_VARIATION_CLAUSE;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public DoFVariationClause getDofVariationClause()
  {
    return dofVariationClause;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetDofVariationClause(DoFVariationClause newDofVariationClause, NotificationChain msgs)
  {
    DoFVariationClause oldDofVariationClause = dofVariationClause;
    dofVariationClause = newDofVariationClause;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, DescartesQLPackage.WHAT_IF_VALUE_VARIATION_CLAUSE__DOF_VARIATION_CLAUSE, oldDofVariationClause, newDofVariationClause);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setDofVariationClause(DoFVariationClause newDofVariationClause)
  {
    if (newDofVariationClause != dofVariationClause)
    {
      NotificationChain msgs = null;
      if (dofVariationClause != null)
        msgs = ((InternalEObject)dofVariationClause).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - DescartesQLPackage.WHAT_IF_VALUE_VARIATION_CLAUSE__DOF_VARIATION_CLAUSE, null, msgs);
      if (newDofVariationClause != null)
        msgs = ((InternalEObject)newDofVariationClause).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - DescartesQLPackage.WHAT_IF_VALUE_VARIATION_CLAUSE__DOF_VARIATION_CLAUSE, null, msgs);
      msgs = basicSetDofVariationClause(newDofVariationClause, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, DescartesQLPackage.WHAT_IF_VALUE_VARIATION_CLAUSE__DOF_VARIATION_CLAUSE, newDofVariationClause, newDofVariationClause));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public MultipleArithmeticClause getMultipleArithmethicClause()
  {
    return multipleArithmethicClause;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetMultipleArithmethicClause(MultipleArithmeticClause newMultipleArithmethicClause, NotificationChain msgs)
  {
    MultipleArithmeticClause oldMultipleArithmethicClause = multipleArithmethicClause;
    multipleArithmethicClause = newMultipleArithmethicClause;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, DescartesQLPackage.WHAT_IF_VALUE_VARIATION_CLAUSE__MULTIPLE_ARITHMETHIC_CLAUSE, oldMultipleArithmethicClause, newMultipleArithmethicClause);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setMultipleArithmethicClause(MultipleArithmeticClause newMultipleArithmethicClause)
  {
    if (newMultipleArithmethicClause != multipleArithmethicClause)
    {
      NotificationChain msgs = null;
      if (multipleArithmethicClause != null)
        msgs = ((InternalEObject)multipleArithmethicClause).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - DescartesQLPackage.WHAT_IF_VALUE_VARIATION_CLAUSE__MULTIPLE_ARITHMETHIC_CLAUSE, null, msgs);
      if (newMultipleArithmethicClause != null)
        msgs = ((InternalEObject)newMultipleArithmethicClause).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - DescartesQLPackage.WHAT_IF_VALUE_VARIATION_CLAUSE__MULTIPLE_ARITHMETHIC_CLAUSE, null, msgs);
      msgs = basicSetMultipleArithmethicClause(newMultipleArithmethicClause, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, DescartesQLPackage.WHAT_IF_VALUE_VARIATION_CLAUSE__MULTIPLE_ARITHMETHIC_CLAUSE, newMultipleArithmethicClause, newMultipleArithmethicClause));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case DescartesQLPackage.WHAT_IF_VALUE_VARIATION_CLAUSE__DOF_VARIATION_CLAUSE:
        return basicSetDofVariationClause(null, msgs);
      case DescartesQLPackage.WHAT_IF_VALUE_VARIATION_CLAUSE__MULTIPLE_ARITHMETHIC_CLAUSE:
        return basicSetMultipleArithmethicClause(null, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case DescartesQLPackage.WHAT_IF_VALUE_VARIATION_CLAUSE__DOF_VARIATION_CLAUSE:
        return getDofVariationClause();
      case DescartesQLPackage.WHAT_IF_VALUE_VARIATION_CLAUSE__MULTIPLE_ARITHMETHIC_CLAUSE:
        return getMultipleArithmethicClause();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case DescartesQLPackage.WHAT_IF_VALUE_VARIATION_CLAUSE__DOF_VARIATION_CLAUSE:
        setDofVariationClause((DoFVariationClause)newValue);
        return;
      case DescartesQLPackage.WHAT_IF_VALUE_VARIATION_CLAUSE__MULTIPLE_ARITHMETHIC_CLAUSE:
        setMultipleArithmethicClause((MultipleArithmeticClause)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case DescartesQLPackage.WHAT_IF_VALUE_VARIATION_CLAUSE__DOF_VARIATION_CLAUSE:
        setDofVariationClause((DoFVariationClause)null);
        return;
      case DescartesQLPackage.WHAT_IF_VALUE_VARIATION_CLAUSE__MULTIPLE_ARITHMETHIC_CLAUSE:
        setMultipleArithmethicClause((MultipleArithmeticClause)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case DescartesQLPackage.WHAT_IF_VALUE_VARIATION_CLAUSE__DOF_VARIATION_CLAUSE:
        return dofVariationClause != null;
      case DescartesQLPackage.WHAT_IF_VALUE_VARIATION_CLAUSE__MULTIPLE_ARITHMETHIC_CLAUSE:
        return multipleArithmethicClause != null;
    }
    return super.eIsSet(featureID);
  }

} //WhatIfValueVariationClauseImpl
