/**
 * ==============================================
 *  DQL : Descartes Query Language
 * ==============================================
 *
 * (c) Copyright 2014-2016, by Juergen Walter, Fabian Gorsler, Fabian Brosig and other contributors.
 *
 * Project Info:   http://descartes.tools/dql
 *
 * All rights reserved. This software is made available under the terms of the
 * Eclipse Public License (EPL) v1.0 as published by the Eclipse Foundation
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * This software is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License (EPL)
 * for more details.
 *
 * You should have received a copy of the Eclipse Public License (EPL)
 * along with this software; if not visit http://www.eclipse.org or write to
 * Eclipse Foundation, Inc., 308 SW First Avenue, Suite 110, Portland, 97204 USA
 * Email: license (at) eclipse.org
 *
 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
 * in the United States and other countries.]
 */
/**
 */
package tools.descartes.dql.models.mapping.domain.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.EObjectResolvingEList;

import org.eclipse.emf.ecore.util.InternalEList;
import tools.descartes.dql.models.mapping.domain.AbstractSeriesResult;
import tools.descartes.dql.models.mapping.domain.DomainPackage;
import tools.descartes.dql.models.mapping.domain.SeriesResultElement;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Abstract Series Result</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link tools.descartes.dql.models.mapping.domain.impl.AbstractSeriesResultImpl#getXAxisDescription <em>XAxis Description</em>}</li>
 *   <li>{@link tools.descartes.dql.models.mapping.domain.impl.AbstractSeriesResultImpl#getYAxisDescription <em>YAxis Description</em>}</li>
 *   <li>{@link tools.descartes.dql.models.mapping.domain.impl.AbstractSeriesResultImpl#getElements <em>Elements</em>}</li>
 * </ul>
 *
 * @generated
 */
public abstract class AbstractSeriesResultImpl extends ResultImpl implements AbstractSeriesResult {
	/**
	 * The default value of the '{@link #getXAxisDescription() <em>XAxis Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getXAxisDescription()
	 * @generated
	 * @ordered
	 */
	protected static final String XAXIS_DESCRIPTION_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getXAxisDescription() <em>XAxis Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getXAxisDescription()
	 * @generated
	 * @ordered
	 */
	protected String xAxisDescription = XAXIS_DESCRIPTION_EDEFAULT;

	/**
	 * The default value of the '{@link #getYAxisDescription() <em>YAxis Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getYAxisDescription()
	 * @generated
	 * @ordered
	 */
	protected static final String YAXIS_DESCRIPTION_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getYAxisDescription() <em>YAxis Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getYAxisDescription()
	 * @generated
	 * @ordered
	 */
	protected String yAxisDescription = YAXIS_DESCRIPTION_EDEFAULT;

	/**
	 * The cached value of the '{@link #getElements() <em>Elements</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getElements()
	 * @generated
	 * @ordered
	 */
	protected EList<SeriesResultElement> elements;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected AbstractSeriesResultImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return DomainPackage.Literals.ABSTRACT_SERIES_RESULT;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getXAxisDescription() {
		return xAxisDescription;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setXAxisDescription(String newXAxisDescription) {
		String oldXAxisDescription = xAxisDescription;
		xAxisDescription = newXAxisDescription;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, DomainPackage.ABSTRACT_SERIES_RESULT__XAXIS_DESCRIPTION, oldXAxisDescription, xAxisDescription));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getYAxisDescription() {
		return yAxisDescription;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setYAxisDescription(String newYAxisDescription) {
		String oldYAxisDescription = yAxisDescription;
		yAxisDescription = newYAxisDescription;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, DomainPackage.ABSTRACT_SERIES_RESULT__YAXIS_DESCRIPTION, oldYAxisDescription, yAxisDescription));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<SeriesResultElement> getElements() {
		if (elements == null) {
			elements = new EObjectContainmentEList<SeriesResultElement>(SeriesResultElement.class, this, DomainPackage.ABSTRACT_SERIES_RESULT__ELEMENTS);
		}
		return elements;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case DomainPackage.ABSTRACT_SERIES_RESULT__ELEMENTS:
				return ((InternalEList<?>)getElements()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case DomainPackage.ABSTRACT_SERIES_RESULT__XAXIS_DESCRIPTION:
				return getXAxisDescription();
			case DomainPackage.ABSTRACT_SERIES_RESULT__YAXIS_DESCRIPTION:
				return getYAxisDescription();
			case DomainPackage.ABSTRACT_SERIES_RESULT__ELEMENTS:
				return getElements();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case DomainPackage.ABSTRACT_SERIES_RESULT__XAXIS_DESCRIPTION:
				setXAxisDescription((String)newValue);
				return;
			case DomainPackage.ABSTRACT_SERIES_RESULT__YAXIS_DESCRIPTION:
				setYAxisDescription((String)newValue);
				return;
			case DomainPackage.ABSTRACT_SERIES_RESULT__ELEMENTS:
				getElements().clear();
				getElements().addAll((Collection<? extends SeriesResultElement>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case DomainPackage.ABSTRACT_SERIES_RESULT__XAXIS_DESCRIPTION:
				setXAxisDescription(XAXIS_DESCRIPTION_EDEFAULT);
				return;
			case DomainPackage.ABSTRACT_SERIES_RESULT__YAXIS_DESCRIPTION:
				setYAxisDescription(YAXIS_DESCRIPTION_EDEFAULT);
				return;
			case DomainPackage.ABSTRACT_SERIES_RESULT__ELEMENTS:
				getElements().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case DomainPackage.ABSTRACT_SERIES_RESULT__XAXIS_DESCRIPTION:
				return XAXIS_DESCRIPTION_EDEFAULT == null ? xAxisDescription != null : !XAXIS_DESCRIPTION_EDEFAULT.equals(xAxisDescription);
			case DomainPackage.ABSTRACT_SERIES_RESULT__YAXIS_DESCRIPTION:
				return YAXIS_DESCRIPTION_EDEFAULT == null ? yAxisDescription != null : !YAXIS_DESCRIPTION_EDEFAULT.equals(yAxisDescription);
			case DomainPackage.ABSTRACT_SERIES_RESULT__ELEMENTS:
				return elements != null && !elements.isEmpty();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (xAxisDescription: ");
		result.append(xAxisDescription);
		result.append(", yAxisDescription: ");
		result.append(yAxisDescription);
		result.append(')');
		return result.toString();
	}

} //AbstractSeriesResultImpl
