/**
 * ==============================================
 *  DQL : Descartes Query Language
 * ==============================================
 *
 * (c) Copyright 2014-2016, by Juergen Walter, Fabian Gorsler, Fabian Brosig and other contributors.
 *
 * Project Info:   http://descartes.tools/dql
 *
 * All rights reserved. This software is made available under the terms of the
 * Eclipse Public License (EPL) v1.0 as published by the Eclipse Foundation
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * This software is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License (EPL)
 * for more details.
 *
 * You should have received a copy of the Eclipse Public License (EPL)
 * along with this software; if not visit http://www.eclipse.org or write to
 * Eclipse Foundation, Inc., 308 SW First Avenue, Suite 110, Portland, 97204 USA
 * Email: license (at) eclipse.org
 *
 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
 * in the United States and other countries.]
 */
/**
 */
package tools.descartes.dql.models.mapping.mapping;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see tools.descartes.dql.models.mapping.mapping.MappingFactory
 * @model kind="package"
 * @generated
 */
public interface MappingPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "mapping";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://descartes.tools/dql/models/mapping/mapping/1.0";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "mapping";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	MappingPackage eINSTANCE = tools.descartes.dql.models.mapping.mapping.impl.MappingPackageImpl.init();

	/**
	 * The meta object id for the '{@link tools.descartes.dql.models.mapping.mapping.impl.MappingImpl <em>Mapping</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dql.models.mapping.mapping.impl.MappingImpl
	 * @see tools.descartes.dql.models.mapping.mapping.impl.MappingPackageImpl#getMapping()
	 * @generated
	 */
	int MAPPING = 1;

	/**
	 * The feature id for the '<em><b>Model Location</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAPPING__MODEL_LOCATION = 0;

	/**
	 * The number of structural features of the '<em>Mapping</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAPPING_FEATURE_COUNT = 1;

	/**
	 * The meta object id for the '{@link tools.descartes.dql.models.mapping.mapping.impl.EntityMappingImpl <em>Entity Mapping</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dql.models.mapping.mapping.impl.EntityMappingImpl
	 * @see tools.descartes.dql.models.mapping.mapping.impl.MappingPackageImpl#getEntityMapping()
	 * @generated
	 */
	int ENTITY_MAPPING = 0;

	/**
	 * The feature id for the '<em><b>Model Location</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENTITY_MAPPING__MODEL_LOCATION = MAPPING__MODEL_LOCATION;

	/**
	 * The feature id for the '<em><b>Do FModel Location</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENTITY_MAPPING__DO_FMODEL_LOCATION = MAPPING_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Filter</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENTITY_MAPPING__FILTER = MAPPING_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Aggregates</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENTITY_MAPPING__AGGREGATES = MAPPING_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Do F</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENTITY_MAPPING__DO_F = MAPPING_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Entities</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENTITY_MAPPING__ENTITIES = MAPPING_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Query As String</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENTITY_MAPPING__QUERY_AS_STRING = MAPPING_FEATURE_COUNT + 5;

	/**
	 * The number of structural features of the '<em>Entity Mapping</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENTITY_MAPPING_FEATURE_COUNT = MAPPING_FEATURE_COUNT + 6;


	/**
	 * Returns the meta object for class '{@link tools.descartes.dql.models.mapping.mapping.EntityMapping <em>Entity Mapping</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Entity Mapping</em>'.
	 * @see tools.descartes.dql.models.mapping.mapping.EntityMapping
	 * @generated
	 */
	EClass getEntityMapping();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dql.models.mapping.mapping.EntityMapping#getDoFModelLocation <em>Do FModel Location</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Do FModel Location</em>'.
	 * @see tools.descartes.dql.models.mapping.mapping.EntityMapping#getDoFModelLocation()
	 * @see #getEntityMapping()
	 * @generated
	 */
	EAttribute getEntityMapping_DoFModelLocation();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dql.models.mapping.mapping.EntityMapping#getFilter <em>Filter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Filter</em>'.
	 * @see tools.descartes.dql.models.mapping.mapping.EntityMapping#getFilter()
	 * @see #getEntityMapping()
	 * @generated
	 */
	EReference getEntityMapping_Filter();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dql.models.mapping.mapping.EntityMapping#getAggregates <em>Aggregates</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Aggregates</em>'.
	 * @see tools.descartes.dql.models.mapping.mapping.EntityMapping#getAggregates()
	 * @see #getEntityMapping()
	 * @generated
	 */
	EReference getEntityMapping_Aggregates();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dql.models.mapping.mapping.EntityMapping#getDoF <em>Do F</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Do F</em>'.
	 * @see tools.descartes.dql.models.mapping.mapping.EntityMapping#getDoF()
	 * @see #getEntityMapping()
	 * @generated
	 */
	EReference getEntityMapping_DoF();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dql.models.mapping.mapping.EntityMapping#getEntities <em>Entities</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Entities</em>'.
	 * @see tools.descartes.dql.models.mapping.mapping.EntityMapping#getEntities()
	 * @see #getEntityMapping()
	 * @generated
	 */
	EReference getEntityMapping_Entities();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dql.models.mapping.mapping.EntityMapping#getQueryAsString <em>Query As String</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Query As String</em>'.
	 * @see tools.descartes.dql.models.mapping.mapping.EntityMapping#getQueryAsString()
	 * @see #getEntityMapping()
	 * @generated
	 */
	EAttribute getEntityMapping_QueryAsString();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dql.models.mapping.mapping.Mapping <em>Mapping</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Mapping</em>'.
	 * @see tools.descartes.dql.models.mapping.mapping.Mapping
	 * @generated
	 */
	EClass getMapping();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dql.models.mapping.mapping.Mapping#getModelLocation <em>Model Location</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Model Location</em>'.
	 * @see tools.descartes.dql.models.mapping.mapping.Mapping#getModelLocation()
	 * @see #getMapping()
	 * @generated
	 */
	EAttribute getMapping_ModelLocation();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	MappingFactory getMappingFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link tools.descartes.dql.models.mapping.mapping.impl.EntityMappingImpl <em>Entity Mapping</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dql.models.mapping.mapping.impl.EntityMappingImpl
		 * @see tools.descartes.dql.models.mapping.mapping.impl.MappingPackageImpl#getEntityMapping()
		 * @generated
		 */
		EClass ENTITY_MAPPING = eINSTANCE.getEntityMapping();

		/**
		 * The meta object literal for the '<em><b>Do FModel Location</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ENTITY_MAPPING__DO_FMODEL_LOCATION = eINSTANCE.getEntityMapping_DoFModelLocation();

		/**
		 * The meta object literal for the '<em><b>Filter</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ENTITY_MAPPING__FILTER = eINSTANCE.getEntityMapping_Filter();

		/**
		 * The meta object literal for the '<em><b>Aggregates</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ENTITY_MAPPING__AGGREGATES = eINSTANCE.getEntityMapping_Aggregates();

		/**
		 * The meta object literal for the '<em><b>Do F</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ENTITY_MAPPING__DO_F = eINSTANCE.getEntityMapping_DoF();

		/**
		 * The meta object literal for the '<em><b>Entities</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ENTITY_MAPPING__ENTITIES = eINSTANCE.getEntityMapping_Entities();

		/**
		 * The meta object literal for the '<em><b>Query As String</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ENTITY_MAPPING__QUERY_AS_STRING = eINSTANCE.getEntityMapping_QueryAsString();

		/**
		 * The meta object literal for the '{@link tools.descartes.dql.models.mapping.mapping.impl.MappingImpl <em>Mapping</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dql.models.mapping.mapping.impl.MappingImpl
		 * @see tools.descartes.dql.models.mapping.mapping.impl.MappingPackageImpl#getMapping()
		 * @generated
		 */
		EClass MAPPING = eINSTANCE.getMapping();

		/**
		 * The meta object literal for the '<em><b>Model Location</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MAPPING__MODEL_LOCATION = eINSTANCE.getMapping_ModelLocation();

	}

} //MappingPackage
