/**
 * ==============================================
 *  DQL : Descartes Query Language
 * ==============================================
 *
 * (c) Copyright 2014-2016, by Juergen Walter, Fabian Gorsler, Fabian Brosig and other contributors.
 *
 * Project Info:   http://descartes.tools/dql
 *
 * All rights reserved. This software is made available under the terms of the
 * Eclipse Public License (EPL) v1.0 as published by the Eclipse Foundation
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * This software is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License (EPL)
 * for more details.
 *
 * You should have received a copy of the Eclipse Public License (EPL)
 * along with this software; if not visit http://www.eclipse.org or write to
 * Eclipse Foundation, Inc., 308 SW First Avenue, Suite 110, Portland, 97204 USA
 * Email: license (at) eclipse.org
 *
 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
 * in the United States and other countries.]
 */
package tools.descartes.pavo.result;

import java.util.List;

import org.jfree.data.time.TimeSeries;

import tools.descartes.dql.models.mapping.domain.ConfidenceInterval;

public class OnlineResultPavo extends AbstractQuantitativeResult {

	
	// List<Double> values; //list of Double pairs
	private List<Double> xvalues;
	private List<Double> yvalues;
	private Boolean isContinous;
	private String xScale; // unit; // e.g., seconds, minutes, hours <-- templates
	private String yScale;

	
	public OnlineResultPavo(String queryableElementN, String metricN, String statisticTypeN, String scaleN, List<Double> xValueN, List<Double> yValueN, boolean isContnousN, String xScaleN, String yScaleN) {
		super(queryableElementN, metricN, statisticTypeN, scaleN);
		xvalues = xValueN;
		yvalues = yValueN;
		isContinous = isContnousN;
		xScale = xScaleN;
		yScale = yScaleN;
	}


	/**
	 * @return the xvalues
	 */
	public List<Double> getXvalues() {
		return xvalues;
	}


	/**
	 * @param xvalues the xvalues to set
	 */
	public void setXvalues(List<Double> xvalues) {
		this.xvalues = xvalues;
	}


	/**
	 * @return the yvalues
	 */
	public List<Double> getYvalues() {
		return yvalues;
	}


	/**
	 * @param yvalues the yvalues to set
	 */
	public void setYvalues(List<Double> yvalues) {
		this.yvalues = yvalues;
	}


	/**
	 * @return the isContinous
	 */
	public Boolean getIsContinous() {
		return isContinous;
	}


	/**
	 * @param isContinous the isContinous to set
	 */
	public void setIsContinous(Boolean isContinous) {
		this.isContinous = isContinous;
	}


	/**
	 * @return the xScale
	 */
	public String getxScale() {
		return xScale;
	}


	/**
	 * @param xScale the xScale to set
	 */
	public void setxScale(String xScale) {
		this.xScale = xScale;
	}


	/**
	 * @return the yScale
	 */
	public String getyScale() {
		return yScale;
	}


	/**
	 * @param yScale the yScale to set
	 */
	public void setyScale(String yScale) {
		this.yScale = yScale;
	}
	
	
	
	
	
}
