/**
 * ==============================================
 *  DQL : Descartes Query Language
 * ==============================================
 *
 * (c) Copyright 2014-2016, by Juergen Walter, Fabian Gorsler, Fabian Brosig and other contributors.
 *
 * Project Info:   http://descartes.tools/dql
 *
 * All rights reserved. This software is made available under the terms of the
 * Eclipse Public License (EPL) v1.0 as published by the Eclipse Foundation
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * This software is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License (EPL)
 * for more details.
 *
 * You should have received a copy of the Eclipse Public License (EPL)
 * along with this software; if not visit http://www.eclipse.org or write to
 * Eclipse Foundation, Inc., 308 SW First Avenue, Suite 110, Portland, 97204 USA
 * Email: license (at) eclipse.org
 *
 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
 * in the United States and other countries.]
 */
package tools.descartes.pavo.rubbish;


import java.util.ArrayList;
import java.util.List;

import tools.descartes.dql.models.mapping.domain.ConfidenceInterval;

public class ResultClass  {
	
	 private String xAxisLabel;
	 private String yAxisLabel;
	
	 private List<List<Double>> yValues = new ArrayList<List<Double>>();
	 private List<List<Double>> xValues = new ArrayList<List<Double>>();
	 private List<String> seriesNames = new ArrayList<String>();
	 private List<List<ConfidenceInterval>> confidences = new ArrayList<List<ConfidenceInterval>>();
	 
	 private boolean dezMetric = false;
	 private List<String> nameDezMetric = new ArrayList<String>();
	 private double dezValue;
	 
	 private List<String> stringResult;
	
	public double getMin(List<Double> list)
	{
		double min = list.get(0);
		for(double d : list)
		{
			if(d<min)
				min = d;
		}
		return min;
	}
	
	public double getMax(List<Double> list)
	{
		double max = list.get(0);
		for(double d : list)
		{
			if(d>max)
				max = d;
		}
		return max;
	}
	
	public double getMean(List<Double> list)
	{
		double mean = 0;
		int counter = 0;
		for(double d : list)
		{
			mean = mean + d;
			counter ++ ;
		}
		return mean/counter;
	}
	 
	 
	 /**
	 * @return the stringResult
	 */
	public List<String> getStringResult() {
		return stringResult;
	}
	/**
	 * @param stringResult the stringResult to set
	 */
	public void setStringResult(List<String> stringResult) {
		this.stringResult = stringResult;
	}

	/**
	 * @return the xAxisLabel
	 */
	public String getxAxisLabel() {
		return xAxisLabel;
	}
	/**
	 * @param xAxisLabel the xAxisLabel to set
	 */
	public void setxAxisLabel(String xAxisLabel) {
		this.xAxisLabel = xAxisLabel;
	}
	/**
	 * @return the yAxisLabel
	 */
	public String getyAxisLabel() {
		return yAxisLabel;
	}
	/**
	 * @param yAxisLabel the yAxisLabel to set
	 */
	public void setyAxisLabel(String yAxisLabel) {
		this.yAxisLabel = yAxisLabel;
	}
	/**
	 * @return the yValues
	 */
	public List<List<Double>> getyValues() {
		return yValues;
	}
	/**
	 * @param yValues the yValues to set
	 */
	public void setyValues(List<List<Double>> yValues) {
		this.yValues = yValues;
	}
	/**
	 * @return the xValues
	 */
	public List<List<Double>> getxValues() {
		return xValues;
	}
	/**
	 * @param xValues the xValues to set
	 */
	public void setxValues(List<List<Double>> xValues) {
		this.xValues = xValues;
	}
	/**
	 * @return the seriesNames
	 */
	public List<String> getSeriesNames() {
		return seriesNames;
	}
	/**
	 * @param seriesNames the seriesNames to set
	 */
	public void setSeriesNames(List<String> seriesNames) {
		this.seriesNames = seriesNames;
	}
	/**
	 * @return the confidences
	 */
	public List<List<ConfidenceInterval>> getConfidences() {
		return confidences;
	}
	/**
	 * @param confidences the confidences to set
	 */
	public void setConfidences(List<List<ConfidenceInterval>> confidences) {
		this.confidences = confidences;
	}
	/**
	 * @return the dezMetric
	 */
	public boolean isDezMetric() {
		return dezMetric;
	}
	/**
	 * @param dezMetric the dezMetric to set
	 */
	public void setDezMetric(boolean dezMetric) {
		this.dezMetric = dezMetric;
	}
	/**
	 * @return the nameDezMetric
	 */
	public List<String> getNameDezMetric() {
		return nameDezMetric;
	}
	/**
	 * @param nameDezMetric the nameDezMetric to set
	 */
	public void setNameDezMetric(List<String> nameDezMetric) {
		this.nameDezMetric = nameDezMetric;
	}
	/**
	 * @return the dezValue
	 */
	public double getDezValue() {
		return dezValue;
	}
	/**
	 * @param dezValue the dezValue to set
	 */
	public void setDezValue(double dezValue) {
		this.dezValue = dezValue;
	}

	
	
}