/**
 * ==============================================
 *  DQL : Descartes Query Language
 * ==============================================
 * 
 * (c) Copyright 2014-2016, by Juergen Walter, Fabian Gorsler, Fabian Brosig and other contributors.
 * 
 * Project Info:   http://descartes.tools/dql
 * 
 * All rights reserved. This software is made available under the terms of the 
 * Eclipse Public License (EPL) v1.0 as published by the Eclipse Foundation
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * This software is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License (EPL)
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License (EPL)
 * along with this software; if not visit http://www.eclipse.org or write to
 * Eclipse Foundation, Inc., 308 SW First Avenue, Suite 110, Portland, 97204 USA
 * Email: license (at) eclipse.org 
 * 
 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
 * in the United States and other countries.]
 */
package tools.descartes.dql.lang.descartesQL;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see tools.descartes.dql.lang.descartesQL.DescartesQLFactory
 * @model kind="package"
 * @generated
 */
public interface DescartesQLPackage extends EPackage
{
  /**
   * The package name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNAME = "descartesQL";

  /**
   * The package namespace URI.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_URI = "http://www.descartes.tools/dql/lang/DescartesQL";

  /**
   * The package namespace name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_PREFIX = "descartesQL";

  /**
   * The singleton instance of the package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  DescartesQLPackage eINSTANCE = tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl.init();

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.impl.DescartesQLImpl <em>Descartes QL</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLImpl
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getDescartesQL()
   * @generated
   */
  int DESCARTES_QL = 0;

  /**
   * The feature id for the '<em><b>Query</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DESCARTES_QL__QUERY = 0;

  /**
   * The number of structural features of the '<em>Descartes QL</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DESCARTES_QL_FEATURE_COUNT = 1;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.impl.ModelStructureQueryImpl <em>Model Structure Query</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.impl.ModelStructureQueryImpl
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getModelStructureQuery()
   * @generated
   */
  int MODEL_STRUCTURE_QUERY = 1;

  /**
   * The number of structural features of the '<em>Model Structure Query</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MODEL_STRUCTURE_QUERY_FEATURE_COUNT = 0;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.impl.PerformanceMetricsQueryImpl <em>Performance Metrics Query</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.impl.PerformanceMetricsQueryImpl
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getPerformanceMetricsQuery()
   * @generated
   */
  int PERFORMANCE_METRICS_QUERY = 2;

  /**
   * The number of structural features of the '<em>Performance Metrics Query</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PERFORMANCE_METRICS_QUERY_FEATURE_COUNT = 0;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.impl.PerformanceIssueQueryImpl <em>Performance Issue Query</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.impl.PerformanceIssueQueryImpl
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getPerformanceIssueQuery()
   * @generated
   */
  int PERFORMANCE_ISSUE_QUERY = 3;

  /**
   * The number of structural features of the '<em>Performance Issue Query</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PERFORMANCE_ISSUE_QUERY_FEATURE_COUNT = 0;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.impl.ConnectorCapabilityQueryImpl <em>Connector Capability Query</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.impl.ConnectorCapabilityQueryImpl
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getConnectorCapabilityQuery()
   * @generated
   */
  int CONNECTOR_CAPABILITY_QUERY = 4;

  /**
   * The number of structural features of the '<em>Connector Capability Query</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONNECTOR_CAPABILITY_QUERY_FEATURE_COUNT = 0;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.impl.ListQueryImpl <em>List Query</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.impl.ListQueryImpl
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getListQuery()
   * @generated
   */
  int LIST_QUERY = 5;

  /**
   * The feature id for the '<em><b>Query Type</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int LIST_QUERY__QUERY_TYPE = MODEL_STRUCTURE_QUERY_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Filter Clause</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int LIST_QUERY__FILTER_CLAUSE = MODEL_STRUCTURE_QUERY_FEATURE_COUNT + 1;

  /**
   * The feature id for the '<em><b>Using Clause</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int LIST_QUERY__USING_CLAUSE = MODEL_STRUCTURE_QUERY_FEATURE_COUNT + 2;

  /**
   * The number of structural features of the '<em>List Query</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int LIST_QUERY_FEATURE_COUNT = MODEL_STRUCTURE_QUERY_FEATURE_COUNT + 3;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.impl.GetQueryImpl <em>Get Query</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.impl.GetQueryImpl
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getGetQuery()
   * @generated
   */
  int GET_QUERY = 6;

  /**
   * The feature id for the '<em><b>Query Tape</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int GET_QUERY__QUERY_TAPE = CONNECTOR_CAPABILITY_QUERY_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Using Clause</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int GET_QUERY__USING_CLAUSE = CONNECTOR_CAPABILITY_QUERY_FEATURE_COUNT + 1;

  /**
   * The number of structural features of the '<em>Get Query</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int GET_QUERY_FEATURE_COUNT = CONNECTOR_CAPABILITY_QUERY_FEATURE_COUNT + 2;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.impl.GetConstraintsQueryImpl <em>Get Constraints Query</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.impl.GetConstraintsQueryImpl
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getGetConstraintsQuery()
   * @generated
   */
  int GET_CONSTRAINTS_QUERY = 7;

  /**
   * The feature id for the '<em><b>Mode</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int GET_CONSTRAINTS_QUERY__MODE = 0;

  /**
   * The number of structural features of the '<em>Get Constraints Query</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int GET_CONSTRAINTS_QUERY_FEATURE_COUNT = 1;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.impl.GetExplorationStrategiesQueryImpl <em>Get Exploration Strategies Query</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.impl.GetExplorationStrategiesQueryImpl
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getGetExplorationStrategiesQuery()
   * @generated
   */
  int GET_EXPLORATION_STRATEGIES_QUERY = 8;

  /**
   * The feature id for the '<em><b>Mode</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int GET_EXPLORATION_STRATEGIES_QUERY__MODE = 0;

  /**
   * The number of structural features of the '<em>Get Exploration Strategies Query</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int GET_EXPLORATION_STRATEGIES_QUERY_FEATURE_COUNT = 1;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.impl.GetTimeUnitsQueryImpl <em>Get Time Units Query</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.impl.GetTimeUnitsQueryImpl
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getGetTimeUnitsQuery()
   * @generated
   */
  int GET_TIME_UNITS_QUERY = 9;

  /**
   * The feature id for the '<em><b>Mode</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int GET_TIME_UNITS_QUERY__MODE = 0;

  /**
   * The number of structural features of the '<em>Get Time Units Query</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int GET_TIME_UNITS_QUERY_FEATURE_COUNT = 1;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.impl.ListDoFQueryImpl <em>List Do FQuery</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.impl.ListDoFQueryImpl
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getListDoFQuery()
   * @generated
   */
  int LIST_DO_FQUERY = 10;

  /**
   * The feature id for the '<em><b>Mode</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int LIST_DO_FQUERY__MODE = 0;

  /**
   * The feature id for the '<em><b>With Clause</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int LIST_DO_FQUERY__WITH_CLAUSE = 1;

  /**
   * The number of structural features of the '<em>List Do FQuery</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int LIST_DO_FQUERY_FEATURE_COUNT = 2;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.impl.ListEntitiesQueryImpl <em>List Entities Query</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.impl.ListEntitiesQueryImpl
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getListEntitiesQuery()
   * @generated
   */
  int LIST_ENTITIES_QUERY = 11;

  /**
   * The feature id for the '<em><b>Mode</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int LIST_ENTITIES_QUERY__MODE = 0;

  /**
   * The number of structural features of the '<em>List Entities Query</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int LIST_ENTITIES_QUERY_FEATURE_COUNT = 1;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.impl.ListMetricsQueryImpl <em>List Metrics Query</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.impl.ListMetricsQueryImpl
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getListMetricsQuery()
   * @generated
   */
  int LIST_METRICS_QUERY = 12;

  /**
   * The feature id for the '<em><b>Mode</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int LIST_METRICS_QUERY__MODE = 0;

  /**
   * The feature id for the '<em><b>Entity Reference Clause</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int LIST_METRICS_QUERY__ENTITY_REFERENCE_CLAUSE = 1;

  /**
   * The number of structural features of the '<em>List Metrics Query</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int LIST_METRICS_QUERY_FEATURE_COUNT = 2;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.impl.SelectQueryImpl <em>Select Query</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.impl.SelectQueryImpl
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getSelectQuery()
   * @generated
   */
  int SELECT_QUERY = 13;

  /**
   * The feature id for the '<em><b>Metric Reference Clauses</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SELECT_QUERY__METRIC_REFERENCE_CLAUSES = PERFORMANCE_METRICS_QUERY_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Constraint Clause</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SELECT_QUERY__CONSTRAINT_CLAUSE = PERFORMANCE_METRICS_QUERY_FEATURE_COUNT + 1;

  /**
   * The feature id for the '<em><b>Dof Clause</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SELECT_QUERY__DOF_CLAUSE = PERFORMANCE_METRICS_QUERY_FEATURE_COUNT + 2;

  /**
   * The feature id for the '<em><b>For Clause</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SELECT_QUERY__FOR_CLAUSE = PERFORMANCE_METRICS_QUERY_FEATURE_COUNT + 3;

  /**
   * The feature id for the '<em><b>Using Clause</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SELECT_QUERY__USING_CLAUSE = PERFORMANCE_METRICS_QUERY_FEATURE_COUNT + 4;

  /**
   * The feature id for the '<em><b>Observe Clause</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SELECT_QUERY__OBSERVE_CLAUSE = PERFORMANCE_METRICS_QUERY_FEATURE_COUNT + 5;

  /**
   * The number of structural features of the '<em>Select Query</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SELECT_QUERY_FEATURE_COUNT = PERFORMANCE_METRICS_QUERY_FEATURE_COUNT + 6;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.impl.MetricReferenceClausesImpl <em>Metric Reference Clauses</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.impl.MetricReferenceClausesImpl
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getMetricReferenceClauses()
   * @generated
   */
  int METRIC_REFERENCE_CLAUSES = 14;

  /**
   * The feature id for the '<em><b>Metric Clause Types</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int METRIC_REFERENCE_CLAUSES__METRIC_CLAUSE_TYPES = 0;

  /**
   * The number of structural features of the '<em>Metric Reference Clauses</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int METRIC_REFERENCE_CLAUSES_FEATURE_COUNT = 1;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.impl.MetricClauseTypeImpl <em>Metric Clause Type</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.impl.MetricClauseTypeImpl
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getMetricClauseType()
   * @generated
   */
  int METRIC_CLAUSE_TYPE = 15;

  /**
   * The number of structural features of the '<em>Metric Clause Type</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int METRIC_CLAUSE_TYPE_FEATURE_COUNT = 0;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.impl.DetectQueryImpl <em>Detect Query</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.impl.DetectQueryImpl
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getDetectQuery()
   * @generated
   */
  int DETECT_QUERY = 16;

  /**
   * The feature id for the '<em><b>Query Type</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DETECT_QUERY__QUERY_TYPE = PERFORMANCE_ISSUE_QUERY_FEATURE_COUNT + 0;

  /**
   * The number of structural features of the '<em>Detect Query</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DETECT_QUERY_FEATURE_COUNT = PERFORMANCE_ISSUE_QUERY_FEATURE_COUNT + 1;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.impl.DetectBottlenecksQueryImpl <em>Detect Bottlenecks Query</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.impl.DetectBottlenecksQueryImpl
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getDetectBottlenecksQuery()
   * @generated
   */
  int DETECT_BOTTLENECKS_QUERY = 17;

  /**
   * The feature id for the '<em><b>Dof Clause</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DETECT_BOTTLENECKS_QUERY__DOF_CLAUSE = 0;

  /**
   * The feature id for the '<em><b>Using Clause</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DETECT_BOTTLENECKS_QUERY__USING_CLAUSE = 1;

  /**
   * The number of structural features of the '<em>Detect Bottlenecks Query</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DETECT_BOTTLENECKS_QUERY_FEATURE_COUNT = 2;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.impl.ConstraintClauseImpl <em>Constraint Clause</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.impl.ConstraintClauseImpl
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getConstraintClause()
   * @generated
   */
  int CONSTRAINT_CLAUSE = 18;

  /**
   * The feature id for the '<em><b>Type</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONSTRAINT_CLAUSE__TYPE = 0;

  /**
   * The number of structural features of the '<em>Constraint Clause</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONSTRAINT_CLAUSE_FEATURE_COUNT = 1;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.impl.DoFClauseImpl <em>Do FClause</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.impl.DoFClauseImpl
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getDoFClause()
   * @generated
   */
  int DO_FCLAUSE = 19;

  /**
   * The feature id for the '<em><b>Mode</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DO_FCLAUSE__MODE = 0;

  /**
   * The feature id for the '<em><b>Varying Clause</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DO_FCLAUSE__VARYING_CLAUSE = 1;

  /**
   * The feature id for the '<em><b>Exploration Strategy</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DO_FCLAUSE__EXPLORATION_STRATEGY = 2;

  /**
   * The feature id for the '<em><b>Constraint Clause</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DO_FCLAUSE__CONSTRAINT_CLAUSE = 3;

  /**
   * The feature id for the '<em><b>With Clause</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DO_FCLAUSE__WITH_CLAUSE = 4;

  /**
   * The number of structural features of the '<em>Do FClause</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DO_FCLAUSE_FEATURE_COUNT = 5;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.impl.ExplorationStrategyClauseImpl <em>Exploration Strategy Clause</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.impl.ExplorationStrategyClauseImpl
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getExplorationStrategyClause()
   * @generated
   */
  int EXPLORATION_STRATEGY_CLAUSE = 20;

  /**
   * The feature id for the '<em><b>Mode</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int EXPLORATION_STRATEGY_CLAUSE__MODE = 0;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int EXPLORATION_STRATEGY_CLAUSE__NAME = 1;

  /**
   * The feature id for the '<em><b>Parameter Clause</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int EXPLORATION_STRATEGY_CLAUSE__PARAMETER_CLAUSE = 2;

  /**
   * The number of structural features of the '<em>Exploration Strategy Clause</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int EXPLORATION_STRATEGY_CLAUSE_FEATURE_COUNT = 3;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.impl.ConfigurationPropertiesClauseImpl <em>Configuration Properties Clause</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.impl.ConfigurationPropertiesClauseImpl
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getConfigurationPropertiesClause()
   * @generated
   */
  int CONFIGURATION_PROPERTIES_CLAUSE = 21;

  /**
   * The feature id for the '<em><b>Mode1</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONFIGURATION_PROPERTIES_CLAUSE__MODE1 = 0;

  /**
   * The feature id for the '<em><b>Properties</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONFIGURATION_PROPERTIES_CLAUSE__PROPERTIES = 1;

  /**
   * The feature id for the '<em><b>Mode2</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONFIGURATION_PROPERTIES_CLAUSE__MODE2 = 2;

  /**
   * The number of structural features of the '<em>Configuration Properties Clause</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONFIGURATION_PROPERTIES_CLAUSE_FEATURE_COUNT = 3;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.impl.ConfigurationPropertyClauseImpl <em>Configuration Property Clause</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.impl.ConfigurationPropertyClauseImpl
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getConfigurationPropertyClause()
   * @generated
   */
  int CONFIGURATION_PROPERTY_CLAUSE = 22;

  /**
   * The feature id for the '<em><b>Key</b></em>' attribute list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONFIGURATION_PROPERTY_CLAUSE__KEY = 0;

  /**
   * The feature id for the '<em><b>Value</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONFIGURATION_PROPERTY_CLAUSE__VALUE = 1;

  /**
   * The number of structural features of the '<em>Configuration Property Clause</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONFIGURATION_PROPERTY_CLAUSE_FEATURE_COUNT = 2;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.impl.DoFVariationClauseImpl <em>Do FVariation Clause</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.impl.DoFVariationClauseImpl
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getDoFVariationClause()
   * @generated
   */
  int DO_FVARIATION_CLAUSE = 23;

  /**
   * The feature id for the '<em><b>Mode1</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DO_FVARIATION_CLAUSE__MODE1 = 0;

  /**
   * The feature id for the '<em><b>Variation</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DO_FVARIATION_CLAUSE__VARIATION = 1;

  /**
   * The feature id for the '<em><b>Mode2</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DO_FVARIATION_CLAUSE__MODE2 = 2;

  /**
   * The number of structural features of the '<em>Do FVariation Clause</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DO_FVARIATION_CLAUSE_FEATURE_COUNT = 3;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.impl.ValueVariationClauseImpl <em>Value Variation Clause</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.impl.ValueVariationClauseImpl
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getValueVariationClause()
   * @generated
   */
  int VALUE_VARIATION_CLAUSE = 24;

  /**
   * The feature id for the '<em><b>Value</b></em>' attribute list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VALUE_VARIATION_CLAUSE__VALUE = 0;

  /**
   * The number of structural features of the '<em>Value Variation Clause</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VALUE_VARIATION_CLAUSE_FEATURE_COUNT = 1;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.impl.IntervalVariationClauseImpl <em>Interval Variation Clause</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.impl.IntervalVariationClauseImpl
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getIntervalVariationClause()
   * @generated
   */
  int INTERVAL_VARIATION_CLAUSE = 25;

  /**
   * The feature id for the '<em><b>Start</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INTERVAL_VARIATION_CLAUSE__START = 0;

  /**
   * The feature id for the '<em><b>End</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INTERVAL_VARIATION_CLAUSE__END = 1;

  /**
   * The feature id for the '<em><b>Step</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INTERVAL_VARIATION_CLAUSE__STEP = 2;

  /**
   * The number of structural features of the '<em>Interval Variation Clause</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INTERVAL_VARIATION_CLAUSE_FEATURE_COUNT = 3;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.impl.VaryingClauseImpl <em>Varying Clause</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.impl.VaryingClauseImpl
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getVaryingClause()
   * @generated
   */
  int VARYING_CLAUSE = 26;

  /**
   * The feature id for the '<em><b>Mode</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VARYING_CLAUSE__MODE = 0;

  /**
   * The feature id for the '<em><b>Dof References</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VARYING_CLAUSE__DOF_REFERENCES = 1;

  /**
   * The number of structural features of the '<em>Varying Clause</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VARYING_CLAUSE_FEATURE_COUNT = 2;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.impl.DoFReferenceImpl <em>Do FReference</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.impl.DoFReferenceImpl
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getDoFReference()
   * @generated
   */
  int DO_FREFERENCE = 27;

  /**
   * The feature id for the '<em><b>Do FIdentifier</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DO_FREFERENCE__DO_FIDENTIFIER = 0;

  /**
   * The feature id for the '<em><b>Do FAlias Clause</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DO_FREFERENCE__DO_FALIAS_CLAUSE = 1;

  /**
   * The feature id for the '<em><b>Do FVariation Clause</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DO_FREFERENCE__DO_FVARIATION_CLAUSE = 2;

  /**
   * The number of structural features of the '<em>Do FReference</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DO_FREFERENCE_FEATURE_COUNT = 3;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.impl.MetricClauseImpl <em>Metric Clause</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.impl.MetricClauseImpl
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getMetricClause()
   * @generated
   */
  int METRIC_CLAUSE = 28;

  /**
   * The feature id for the '<em><b>Metric Reference</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int METRIC_CLAUSE__METRIC_REFERENCE = METRIC_CLAUSE_TYPE_FEATURE_COUNT + 0;

  /**
   * The number of structural features of the '<em>Metric Clause</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int METRIC_CLAUSE_FEATURE_COUNT = METRIC_CLAUSE_TYPE_FEATURE_COUNT + 1;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.impl.AggregateMetricClauseImpl <em>Aggregate Metric Clause</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.impl.AggregateMetricClauseImpl
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getAggregateMetricClause()
   * @generated
   */
  int AGGREGATE_METRIC_CLAUSE = 29;

  /**
   * The feature id for the '<em><b>Function</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int AGGREGATE_METRIC_CLAUSE__FUNCTION = METRIC_CLAUSE_TYPE_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Metrics</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int AGGREGATE_METRIC_CLAUSE__METRICS = METRIC_CLAUSE_TYPE_FEATURE_COUNT + 1;

  /**
   * The feature id for the '<em><b>Properties</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int AGGREGATE_METRIC_CLAUSE__PROPERTIES = METRIC_CLAUSE_TYPE_FEATURE_COUNT + 2;

  /**
   * The number of structural features of the '<em>Aggregate Metric Clause</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int AGGREGATE_METRIC_CLAUSE_FEATURE_COUNT = METRIC_CLAUSE_TYPE_FEATURE_COUNT + 3;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.impl.MetricClausesImpl <em>Metric Clauses</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.impl.MetricClausesImpl
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getMetricClauses()
   * @generated
   */
  int METRIC_CLAUSES = 30;

  /**
   * The feature id for the '<em><b>Metrics</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int METRIC_CLAUSES__METRICS = 0;

  /**
   * The number of structural features of the '<em>Metric Clauses</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int METRIC_CLAUSES_FEATURE_COUNT = 1;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.impl.MetricStarClauseImpl <em>Metric Star Clause</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.impl.MetricStarClauseImpl
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getMetricStarClause()
   * @generated
   */
  int METRIC_STAR_CLAUSE = 31;

  /**
   * The feature id for the '<em><b>Metric Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int METRIC_STAR_CLAUSE__METRIC_NAME = 0;

  /**
   * The number of structural features of the '<em>Metric Star Clause</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int METRIC_STAR_CLAUSE_FEATURE_COUNT = 1;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.impl.MetricReferenceImpl <em>Metric Reference</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.impl.MetricReferenceImpl
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getMetricReference()
   * @generated
   */
  int METRIC_REFERENCE = 32;

  /**
   * The feature id for the '<em><b>Entity Reference</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int METRIC_REFERENCE__ENTITY_REFERENCE = 0;

  /**
   * The feature id for the '<em><b>Separator</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int METRIC_REFERENCE__SEPARATOR = 1;

  /**
   * The feature id for the '<em><b>Metric Reference</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int METRIC_REFERENCE__METRIC_REFERENCE = 2;

  /**
   * The feature id for the '<em><b>Separatorv</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int METRIC_REFERENCE__SEPARATORV = 3;

  /**
   * The feature id for the '<em><b>Stat Type Reference</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int METRIC_REFERENCE__STAT_TYPE_REFERENCE = 4;

  /**
   * The number of structural features of the '<em>Metric Reference</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int METRIC_REFERENCE_FEATURE_COUNT = 5;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.impl.ForClauseImpl <em>For Clause</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.impl.ForClauseImpl
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getForClause()
   * @generated
   */
  int FOR_CLAUSE = 33;

  /**
   * The feature id for the '<em><b>Mode</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FOR_CLAUSE__MODE = 0;

  /**
   * The feature id for the '<em><b>Entity Reference Clause</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FOR_CLAUSE__ENTITY_REFERENCE_CLAUSE = 1;

  /**
   * The number of structural features of the '<em>For Clause</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FOR_CLAUSE_FEATURE_COUNT = 2;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.impl.EntityReferenceClauseImpl <em>Entity Reference Clause</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.impl.EntityReferenceClauseImpl
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getEntityReferenceClause()
   * @generated
   */
  int ENTITY_REFERENCE_CLAUSE = 34;

  /**
   * The feature id for the '<em><b>Entity References</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ENTITY_REFERENCE_CLAUSE__ENTITY_REFERENCES = 0;

  /**
   * The number of structural features of the '<em>Entity Reference Clause</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ENTITY_REFERENCE_CLAUSE_FEATURE_COUNT = 1;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.impl.EntityReferenceImpl <em>Entity Reference</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.impl.EntityReferenceImpl
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getEntityReference()
   * @generated
   */
  int ENTITY_REFERENCE = 35;

  /**
   * The feature id for the '<em><b>Type</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ENTITY_REFERENCE__TYPE = 0;

  /**
   * The feature id for the '<em><b>Identifier</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ENTITY_REFERENCE__IDENTIFIER = 1;

  /**
   * The feature id for the '<em><b>Alias</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ENTITY_REFERENCE__ALIAS = 2;

  /**
   * The number of structural features of the '<em>Entity Reference</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ENTITY_REFERENCE_FEATURE_COUNT = 3;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.impl.AliasClauseImpl <em>Alias Clause</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.impl.AliasClauseImpl
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getAliasClause()
   * @generated
   */
  int ALIAS_CLAUSE = 36;

  /**
   * The feature id for the '<em><b>Mode</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ALIAS_CLAUSE__MODE = 0;

  /**
   * The feature id for the '<em><b>Alias</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ALIAS_CLAUSE__ALIAS = 1;

  /**
   * The number of structural features of the '<em>Alias Clause</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ALIAS_CLAUSE_FEATURE_COUNT = 2;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.impl.UsingClauseImpl <em>Using Clause</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.impl.UsingClauseImpl
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getUsingClause()
   * @generated
   */
  int USING_CLAUSE = 37;

  /**
   * The feature id for the '<em><b>Mode</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int USING_CLAUSE__MODE = 0;

  /**
   * The feature id for the '<em><b>Model Reference</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int USING_CLAUSE__MODEL_REFERENCE = 1;

  /**
   * The number of structural features of the '<em>Using Clause</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int USING_CLAUSE_FEATURE_COUNT = 2;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.impl.WithClauseImpl <em>With Clause</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.impl.WithClauseImpl
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getWithClause()
   * @generated
   */
  int WITH_CLAUSE = 38;

  /**
   * The feature id for the '<em><b>Mode</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int WITH_CLAUSE__MODE = 0;

  /**
   * The feature id for the '<em><b>Model Reference</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int WITH_CLAUSE__MODEL_REFERENCE = 1;

  /**
   * The number of structural features of the '<em>With Clause</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int WITH_CLAUSE_FEATURE_COUNT = 2;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.impl.ModelReferenceClauseImpl <em>Model Reference Clause</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.impl.ModelReferenceClauseImpl
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getModelReferenceClause()
   * @generated
   */
  int MODEL_REFERENCE_CLAUSE = 39;

  /**
   * The feature id for the '<em><b>Family</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MODEL_REFERENCE_CLAUSE__FAMILY = 0;

  /**
   * The feature id for the '<em><b>Model</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MODEL_REFERENCE_CLAUSE__MODEL = 1;

  /**
   * The number of structural features of the '<em>Model Reference Clause</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MODEL_REFERENCE_CLAUSE_FEATURE_COUNT = 2;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.impl.ModelFamilyImpl <em>Model Family</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.impl.ModelFamilyImpl
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getModelFamily()
   * @generated
   */
  int MODEL_FAMILY = 40;

  /**
   * The feature id for the '<em><b>Family</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MODEL_FAMILY__FAMILY = 0;

  /**
   * The number of structural features of the '<em>Model Family</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MODEL_FAMILY_FEATURE_COUNT = 1;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.impl.ModelLocationImpl <em>Model Location</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.impl.ModelLocationImpl
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getModelLocation()
   * @generated
   */
  int MODEL_LOCATION = 41;

  /**
   * The feature id for the '<em><b>Location</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MODEL_LOCATION__LOCATION = 0;

  /**
   * The number of structural features of the '<em>Model Location</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MODEL_LOCATION_FEATURE_COUNT = 1;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.impl.FilterClauseImpl <em>Filter Clause</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.impl.FilterClauseImpl
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getFilterClause()
   * @generated
   */
  int FILTER_CLAUSE = 42;

  /**
   * The feature id for the '<em><b>Mode</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FILTER_CLAUSE__MODE = 0;

  /**
   * The feature id for the '<em><b>Filter Conditions</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FILTER_CLAUSE__FILTER_CONDITIONS = 1;

  /**
   * The feature id for the '<em><b>Filter Conjunctions</b></em>' attribute list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FILTER_CLAUSE__FILTER_CONJUNCTIONS = 2;

  /**
   * The number of structural features of the '<em>Filter Clause</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FILTER_CLAUSE_FEATURE_COUNT = 3;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.impl.FilterConditionClauseImpl <em>Filter Condition Clause</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.impl.FilterConditionClauseImpl
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getFilterConditionClause()
   * @generated
   */
  int FILTER_CONDITION_CLAUSE = 43;

  /**
   * The feature id for the '<em><b>Mode</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FILTER_CONDITION_CLAUSE__MODE = 0;

  /**
   * The feature id for the '<em><b>Condition</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FILTER_CONDITION_CLAUSE__CONDITION = 1;

  /**
   * The feature id for the '<em><b>Value</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FILTER_CONDITION_CLAUSE__VALUE = 2;

  /**
   * The number of structural features of the '<em>Filter Condition Clause</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FILTER_CONDITION_CLAUSE_FEATURE_COUNT = 3;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.impl.FilterConditionValueImpl <em>Filter Condition Value</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.impl.FilterConditionValueImpl
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getFilterConditionValue()
   * @generated
   */
  int FILTER_CONDITION_VALUE = 44;

  /**
   * The feature id for the '<em><b>Value</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FILTER_CONDITION_VALUE__VALUE = 0;

  /**
   * The number of structural features of the '<em>Filter Condition Value</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FILTER_CONDITION_VALUE_FEATURE_COUNT = 1;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.impl.ObserveClauseImpl <em>Observe Clause</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.impl.ObserveClauseImpl
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getObserveClause()
   * @generated
   */
  int OBSERVE_CLAUSE = 45;

  /**
   * The feature id for the '<em><b>Mode</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int OBSERVE_CLAUSE__MODE = 0;

  /**
   * The feature id for the '<em><b>Observation</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int OBSERVE_CLAUSE__OBSERVATION = 1;

  /**
   * The feature id for the '<em><b>Sample Clause</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int OBSERVE_CLAUSE__SAMPLE_CLAUSE = 2;

  /**
   * The number of structural features of the '<em>Observe Clause</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int OBSERVE_CLAUSE_FEATURE_COUNT = 3;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.impl.ObservationClauseImpl <em>Observation Clause</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.impl.ObservationClauseImpl
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getObservationClause()
   * @generated
   */
  int OBSERVATION_CLAUSE = 46;

  /**
   * The number of structural features of the '<em>Observation Clause</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int OBSERVATION_CLAUSE_FEATURE_COUNT = 0;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.impl.SampleClauseImpl <em>Sample Clause</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.impl.SampleClauseImpl
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getSampleClause()
   * @generated
   */
  int SAMPLE_CLAUSE = 47;

  /**
   * The feature id for the '<em><b>Mode</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SAMPLE_CLAUSE__MODE = 0;

  /**
   * The feature id for the '<em><b>Duration Clause</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SAMPLE_CLAUSE__DURATION_CLAUSE = 1;

  /**
   * The number of structural features of the '<em>Sample Clause</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SAMPLE_CLAUSE_FEATURE_COUNT = 2;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.impl.ConnectorTimeUnitClauseImpl <em>Connector Time Unit Clause</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.impl.ConnectorTimeUnitClauseImpl
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getConnectorTimeUnitClause()
   * @generated
   */
  int CONNECTOR_TIME_UNIT_CLAUSE = 48;

  /**
   * The feature id for the '<em><b>Count</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONNECTOR_TIME_UNIT_CLAUSE__COUNT = OBSERVATION_CLAUSE_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Time Indicator</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONNECTOR_TIME_UNIT_CLAUSE__TIME_INDICATOR = OBSERVATION_CLAUSE_FEATURE_COUNT + 1;

  /**
   * The number of structural features of the '<em>Connector Time Unit Clause</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONNECTOR_TIME_UNIT_CLAUSE_FEATURE_COUNT = OBSERVATION_CLAUSE_FEATURE_COUNT + 2;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.impl.ConnectorInstanceReferenceClauseImpl <em>Connector Instance Reference Clause</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.impl.ConnectorInstanceReferenceClauseImpl
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getConnectorInstanceReferenceClause()
   * @generated
   */
  int CONNECTOR_INSTANCE_REFERENCE_CLAUSE = 49;

  /**
   * The feature id for the '<em><b>Type</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONNECTOR_INSTANCE_REFERENCE_CLAUSE__TYPE = OBSERVATION_CLAUSE_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Identifier</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONNECTOR_INSTANCE_REFERENCE_CLAUSE__IDENTIFIER = OBSERVATION_CLAUSE_FEATURE_COUNT + 1;

  /**
   * The number of structural features of the '<em>Connector Instance Reference Clause</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONNECTOR_INSTANCE_REFERENCE_CLAUSE_FEATURE_COUNT = OBSERVATION_CLAUSE_FEATURE_COUNT + 2;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.impl.ObserveRelativeClauseImpl <em>Observe Relative Clause</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.impl.ObserveRelativeClauseImpl
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getObserveRelativeClause()
   * @generated
   */
  int OBSERVE_RELATIVE_CLAUSE = 50;

  /**
   * The feature id for the '<em><b>Direction</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int OBSERVE_RELATIVE_CLAUSE__DIRECTION = OBSERVATION_CLAUSE_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Time Target</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int OBSERVE_RELATIVE_CLAUSE__TIME_TARGET = OBSERVATION_CLAUSE_FEATURE_COUNT + 1;

  /**
   * The number of structural features of the '<em>Observe Relative Clause</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int OBSERVE_RELATIVE_CLAUSE_FEATURE_COUNT = OBSERVATION_CLAUSE_FEATURE_COUNT + 2;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.impl.ObserveBetweenClauseImpl <em>Observe Between Clause</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.impl.ObserveBetweenClauseImpl
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getObserveBetweenClause()
   * @generated
   */
  int OBSERVE_BETWEEN_CLAUSE = 51;

  /**
   * The feature id for the '<em><b>Mode1</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int OBSERVE_BETWEEN_CLAUSE__MODE1 = OBSERVATION_CLAUSE_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Starting Time</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int OBSERVE_BETWEEN_CLAUSE__STARTING_TIME = OBSERVATION_CLAUSE_FEATURE_COUNT + 1;

  /**
   * The feature id for the '<em><b>Mode2</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int OBSERVE_BETWEEN_CLAUSE__MODE2 = OBSERVATION_CLAUSE_FEATURE_COUNT + 2;

  /**
   * The feature id for the '<em><b>Ending Time</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int OBSERVE_BETWEEN_CLAUSE__ENDING_TIME = OBSERVATION_CLAUSE_FEATURE_COUNT + 3;

  /**
   * The number of structural features of the '<em>Observe Between Clause</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int OBSERVE_BETWEEN_CLAUSE_FEATURE_COUNT = OBSERVATION_CLAUSE_FEATURE_COUNT + 4;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.impl.BetweenTimeClauseImpl <em>Between Time Clause</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.impl.BetweenTimeClauseImpl
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getBetweenTimeClause()
   * @generated
   */
  int BETWEEN_TIME_CLAUSE = 53;

  /**
   * The number of structural features of the '<em>Between Time Clause</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int BETWEEN_TIME_CLAUSE_FEATURE_COUNT = 0;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.impl.RelativeTimeWithSignClauseImpl <em>Relative Time With Sign Clause</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.impl.RelativeTimeWithSignClauseImpl
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getRelativeTimeWithSignClause()
   * @generated
   */
  int RELATIVE_TIME_WITH_SIGN_CLAUSE = 52;

  /**
   * The feature id for the '<em><b>Sign</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int RELATIVE_TIME_WITH_SIGN_CLAUSE__SIGN = BETWEEN_TIME_CLAUSE_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Time Clause</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int RELATIVE_TIME_WITH_SIGN_CLAUSE__TIME_CLAUSE = BETWEEN_TIME_CLAUSE_FEATURE_COUNT + 1;

  /**
   * The number of structural features of the '<em>Relative Time With Sign Clause</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int RELATIVE_TIME_WITH_SIGN_CLAUSE_FEATURE_COUNT = BETWEEN_TIME_CLAUSE_FEATURE_COUNT + 2;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.impl.TimeClauseImpl <em>Time Clause</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.impl.TimeClauseImpl
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getTimeClause()
   * @generated
   */
  int TIME_CLAUSE = 54;

  /**
   * The number of structural features of the '<em>Time Clause</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int TIME_CLAUSE_FEATURE_COUNT = 0;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.impl.AbsoluteTimeClauseImpl <em>Absolute Time Clause</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.impl.AbsoluteTimeClauseImpl
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getAbsoluteTimeClause()
   * @generated
   */
  int ABSOLUTE_TIME_CLAUSE = 55;

  /**
   * The feature id for the '<em><b>Time Spec</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ABSOLUTE_TIME_CLAUSE__TIME_SPEC = BETWEEN_TIME_CLAUSE_FEATURE_COUNT + 0;

  /**
   * The number of structural features of the '<em>Absolute Time Clause</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ABSOLUTE_TIME_CLAUSE_FEATURE_COUNT = BETWEEN_TIME_CLAUSE_FEATURE_COUNT + 1;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.impl.RelativeTimeClauseImpl <em>Relative Time Clause</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.impl.RelativeTimeClauseImpl
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getRelativeTimeClause()
   * @generated
   */
  int RELATIVE_TIME_CLAUSE = 56;

  /**
   * The feature id for the '<em><b>Duration Clause</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int RELATIVE_TIME_CLAUSE__DURATION_CLAUSE = TIME_CLAUSE_FEATURE_COUNT + 0;

  /**
   * The number of structural features of the '<em>Relative Time Clause</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int RELATIVE_TIME_CLAUSE_FEATURE_COUNT = TIME_CLAUSE_FEATURE_COUNT + 1;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.impl.RelativeTimeDurationClauseImpl <em>Relative Time Duration Clause</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.impl.RelativeTimeDurationClauseImpl
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getRelativeTimeDurationClause()
   * @generated
   */
  int RELATIVE_TIME_DURATION_CLAUSE = 57;

  /**
   * The feature id for the '<em><b>Duration</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int RELATIVE_TIME_DURATION_CLAUSE__DURATION = 0;

  /**
   * The feature id for the '<em><b>Time Modifier</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int RELATIVE_TIME_DURATION_CLAUSE__TIME_MODIFIER = 1;

  /**
   * The number of structural features of the '<em>Relative Time Duration Clause</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int RELATIVE_TIME_DURATION_CLAUSE_FEATURE_COUNT = 2;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.impl.WhatIfQueryImpl <em>What If Query</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.impl.WhatIfQueryImpl
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getWhatIfQuery()
   * @generated
   */
  int WHAT_IF_QUERY = 58;

  /**
   * The feature id for the '<em><b>What If Variation</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int WHAT_IF_QUERY__WHAT_IF_VARIATION = 0;

  /**
   * The feature id for the '<em><b>Metric Reference Clauses</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int WHAT_IF_QUERY__METRIC_REFERENCE_CLAUSES = 1;

  /**
   * The feature id for the '<em><b>For Clause</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int WHAT_IF_QUERY__FOR_CLAUSE = 2;

  /**
   * The feature id for the '<em><b>Filtering Clause</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int WHAT_IF_QUERY__FILTERING_CLAUSE = 3;

  /**
   * The feature id for the '<em><b>Delta Clause</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int WHAT_IF_QUERY__DELTA_CLAUSE = 4;

  /**
   * The feature id for the '<em><b>Using Clause</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int WHAT_IF_QUERY__USING_CLAUSE = 5;

  /**
   * The number of structural features of the '<em>What If Query</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int WHAT_IF_QUERY_FEATURE_COUNT = 6;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.impl.WhatIfVariationImpl <em>What If Variation</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.impl.WhatIfVariationImpl
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getWhatIfVariation()
   * @generated
   */
  int WHAT_IF_VARIATION = 59;

  /**
   * The feature id for the '<em><b>What If Variation Clause</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int WHAT_IF_VARIATION__WHAT_IF_VARIATION_CLAUSE = 0;

  /**
   * The number of structural features of the '<em>What If Variation</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int WHAT_IF_VARIATION_FEATURE_COUNT = 1;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.impl.FilteringClauseImpl <em>Filtering Clause</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.impl.FilteringClauseImpl
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getFilteringClause()
   * @generated
   */
  int FILTERING_CLAUSE = 60;

  /**
   * The feature id for the '<em><b>Filterung Rule</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FILTERING_CLAUSE__FILTERUNG_RULE = 0;

  /**
   * The feature id for the '<em><b>Filtering Strategy</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FILTERING_CLAUSE__FILTERING_STRATEGY = 1;

  /**
   * The number of structural features of the '<em>Filtering Clause</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FILTERING_CLAUSE_FEATURE_COUNT = 2;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.impl.FilteringStrategyImpl <em>Filtering Strategy</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.impl.FilteringStrategyImpl
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getFilteringStrategy()
   * @generated
   */
  int FILTERING_STRATEGY = 61;

  /**
   * The feature id for the '<em><b>Filtering Strategy</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FILTERING_STRATEGY__FILTERING_STRATEGY = 0;

  /**
   * The number of structural features of the '<em>Filtering Strategy</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FILTERING_STRATEGY_FEATURE_COUNT = 1;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.impl.FilterigRuleImpl <em>Filterig Rule</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.impl.FilterigRuleImpl
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getFilterigRule()
   * @generated
   */
  int FILTERIG_RULE = 62;

  /**
   * The feature id for the '<em><b>Filtering Value</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FILTERIG_RULE__FILTERING_VALUE = 0;

  /**
   * The feature id for the '<em><b>Modifier</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FILTERIG_RULE__MODIFIER = 1;

  /**
   * The number of structural features of the '<em>Filterig Rule</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FILTERIG_RULE_FEATURE_COUNT = 2;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.impl.WhatIfVariationClauseImpl <em>What If Variation Clause</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.impl.WhatIfVariationClauseImpl
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getWhatIfVariationClause()
   * @generated
   */
  int WHAT_IF_VARIATION_CLAUSE = 63;

  /**
   * The feature id for the '<em><b>Variation Point</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int WHAT_IF_VARIATION_CLAUSE__VARIATION_POINT = 0;

  /**
   * The feature id for the '<em><b>Values</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int WHAT_IF_VARIATION_CLAUSE__VALUES = 1;

  /**
   * The number of structural features of the '<em>What If Variation Clause</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int WHAT_IF_VARIATION_CLAUSE_FEATURE_COUNT = 2;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.impl.WhatIfValueVariationClauseImpl <em>What If Value Variation Clause</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.impl.WhatIfValueVariationClauseImpl
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getWhatIfValueVariationClause()
   * @generated
   */
  int WHAT_IF_VALUE_VARIATION_CLAUSE = 64;

  /**
   * The feature id for the '<em><b>Dof Variation Clause</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int WHAT_IF_VALUE_VARIATION_CLAUSE__DOF_VARIATION_CLAUSE = 0;

  /**
   * The feature id for the '<em><b>Multiple Arithmethic Clause</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int WHAT_IF_VALUE_VARIATION_CLAUSE__MULTIPLE_ARITHMETHIC_CLAUSE = 1;

  /**
   * The number of structural features of the '<em>What If Value Variation Clause</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int WHAT_IF_VALUE_VARIATION_CLAUSE_FEATURE_COUNT = 2;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.impl.MultipleArithmeticClauseImpl <em>Multiple Arithmetic Clause</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.impl.MultipleArithmeticClauseImpl
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getMultipleArithmeticClause()
   * @generated
   */
  int MULTIPLE_ARITHMETIC_CLAUSE = 65;

  /**
   * The feature id for the '<em><b>Multi Clause</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MULTIPLE_ARITHMETIC_CLAUSE__MULTI_CLAUSE = 0;

  /**
   * The number of structural features of the '<em>Multiple Arithmetic Clause</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MULTIPLE_ARITHMETIC_CLAUSE_FEATURE_COUNT = 1;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.impl.ArithmeticClauseImpl <em>Arithmetic Clause</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.impl.ArithmeticClauseImpl
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getArithmeticClause()
   * @generated
   */
  int ARITHMETIC_CLAUSE = 66;

  /**
   * The feature id for the '<em><b>Mode</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARITHMETIC_CLAUSE__MODE = 0;

  /**
   * The feature id for the '<em><b>Value</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARITHMETIC_CLAUSE__VALUE = 1;

  /**
   * The number of structural features of the '<em>Arithmetic Clause</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ARITHMETIC_CLAUSE_FEATURE_COUNT = 2;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.impl.VariableValueImpl <em>Variable Value</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.impl.VariableValueImpl
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getVariableValue()
   * @generated
   */
  int VARIABLE_VALUE = 67;

  /**
   * The feature id for the '<em><b>Int Value</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VARIABLE_VALUE__INT_VALUE = 0;

  /**
   * The feature id for the '<em><b>Double Value</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VARIABLE_VALUE__DOUBLE_VALUE = 1;

  /**
   * The number of structural features of the '<em>Variable Value</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int VARIABLE_VALUE_FEATURE_COUNT = 2;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.FilterConjunction <em>Filter Conjunction</em>}' enum.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.FilterConjunction
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getFilterConjunction()
   * @generated
   */
  int FILTER_CONJUNCTION = 68;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.FilterConditionType <em>Filter Condition Type</em>}' enum.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.FilterConditionType
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getFilterConditionType()
   * @generated
   */
  int FILTER_CONDITION_TYPE = 69;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.ObserveRelativeDirectionType <em>Observe Relative Direction Type</em>}' enum.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.ObserveRelativeDirectionType
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getObserveRelativeDirectionType()
   * @generated
   */
  int OBSERVE_RELATIVE_DIRECTION_TYPE = 70;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.RelativeTimeSignType <em>Relative Time Sign Type</em>}' enum.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.RelativeTimeSignType
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getRelativeTimeSignType()
   * @generated
   */
  int RELATIVE_TIME_SIGN_TYPE = 71;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.TimeModifierType <em>Time Modifier Type</em>}' enum.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.TimeModifierType
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getTimeModifierType()
   * @generated
   */
  int TIME_MODIFIER_TYPE = 72;

  /**
   * The meta object id for the '{@link tools.descartes.dql.lang.descartesQL.StatisticalAggregateType <em>Statistical Aggregate Type</em>}' enum.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tools.descartes.dql.lang.descartesQL.StatisticalAggregateType
   * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getStatisticalAggregateType()
   * @generated
   */
  int STATISTICAL_AGGREGATE_TYPE = 73;


  /**
   * Returns the meta object for class '{@link tools.descartes.dql.lang.descartesQL.DescartesQL <em>Descartes QL</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Descartes QL</em>'.
   * @see tools.descartes.dql.lang.descartesQL.DescartesQL
   * @generated
   */
  EClass getDescartesQL();

  /**
   * Returns the meta object for the containment reference '{@link tools.descartes.dql.lang.descartesQL.DescartesQL#getQuery <em>Query</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Query</em>'.
   * @see tools.descartes.dql.lang.descartesQL.DescartesQL#getQuery()
   * @see #getDescartesQL()
   * @generated
   */
  EReference getDescartesQL_Query();

  /**
   * Returns the meta object for class '{@link tools.descartes.dql.lang.descartesQL.ModelStructureQuery <em>Model Structure Query</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Model Structure Query</em>'.
   * @see tools.descartes.dql.lang.descartesQL.ModelStructureQuery
   * @generated
   */
  EClass getModelStructureQuery();

  /**
   * Returns the meta object for class '{@link tools.descartes.dql.lang.descartesQL.PerformanceMetricsQuery <em>Performance Metrics Query</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Performance Metrics Query</em>'.
   * @see tools.descartes.dql.lang.descartesQL.PerformanceMetricsQuery
   * @generated
   */
  EClass getPerformanceMetricsQuery();

  /**
   * Returns the meta object for class '{@link tools.descartes.dql.lang.descartesQL.PerformanceIssueQuery <em>Performance Issue Query</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Performance Issue Query</em>'.
   * @see tools.descartes.dql.lang.descartesQL.PerformanceIssueQuery
   * @generated
   */
  EClass getPerformanceIssueQuery();

  /**
   * Returns the meta object for class '{@link tools.descartes.dql.lang.descartesQL.ConnectorCapabilityQuery <em>Connector Capability Query</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Connector Capability Query</em>'.
   * @see tools.descartes.dql.lang.descartesQL.ConnectorCapabilityQuery
   * @generated
   */
  EClass getConnectorCapabilityQuery();

  /**
   * Returns the meta object for class '{@link tools.descartes.dql.lang.descartesQL.ListQuery <em>List Query</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>List Query</em>'.
   * @see tools.descartes.dql.lang.descartesQL.ListQuery
   * @generated
   */
  EClass getListQuery();

  /**
   * Returns the meta object for the containment reference '{@link tools.descartes.dql.lang.descartesQL.ListQuery#getQueryType <em>Query Type</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Query Type</em>'.
   * @see tools.descartes.dql.lang.descartesQL.ListQuery#getQueryType()
   * @see #getListQuery()
   * @generated
   */
  EReference getListQuery_QueryType();

  /**
   * Returns the meta object for the containment reference '{@link tools.descartes.dql.lang.descartesQL.ListQuery#getFilterClause <em>Filter Clause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Filter Clause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.ListQuery#getFilterClause()
   * @see #getListQuery()
   * @generated
   */
  EReference getListQuery_FilterClause();

  /**
   * Returns the meta object for the containment reference '{@link tools.descartes.dql.lang.descartesQL.ListQuery#getUsingClause <em>Using Clause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Using Clause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.ListQuery#getUsingClause()
   * @see #getListQuery()
   * @generated
   */
  EReference getListQuery_UsingClause();

  /**
   * Returns the meta object for class '{@link tools.descartes.dql.lang.descartesQL.GetQuery <em>Get Query</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Get Query</em>'.
   * @see tools.descartes.dql.lang.descartesQL.GetQuery
   * @generated
   */
  EClass getGetQuery();

  /**
   * Returns the meta object for the containment reference '{@link tools.descartes.dql.lang.descartesQL.GetQuery#getQueryTape <em>Query Tape</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Query Tape</em>'.
   * @see tools.descartes.dql.lang.descartesQL.GetQuery#getQueryTape()
   * @see #getGetQuery()
   * @generated
   */
  EReference getGetQuery_QueryTape();

  /**
   * Returns the meta object for the containment reference '{@link tools.descartes.dql.lang.descartesQL.GetQuery#getUsingClause <em>Using Clause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Using Clause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.GetQuery#getUsingClause()
   * @see #getGetQuery()
   * @generated
   */
  EReference getGetQuery_UsingClause();

  /**
   * Returns the meta object for class '{@link tools.descartes.dql.lang.descartesQL.GetConstraintsQuery <em>Get Constraints Query</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Get Constraints Query</em>'.
   * @see tools.descartes.dql.lang.descartesQL.GetConstraintsQuery
   * @generated
   */
  EClass getGetConstraintsQuery();

  /**
   * Returns the meta object for the attribute '{@link tools.descartes.dql.lang.descartesQL.GetConstraintsQuery#getMode <em>Mode</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Mode</em>'.
   * @see tools.descartes.dql.lang.descartesQL.GetConstraintsQuery#getMode()
   * @see #getGetConstraintsQuery()
   * @generated
   */
  EAttribute getGetConstraintsQuery_Mode();

  /**
   * Returns the meta object for class '{@link tools.descartes.dql.lang.descartesQL.GetExplorationStrategiesQuery <em>Get Exploration Strategies Query</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Get Exploration Strategies Query</em>'.
   * @see tools.descartes.dql.lang.descartesQL.GetExplorationStrategiesQuery
   * @generated
   */
  EClass getGetExplorationStrategiesQuery();

  /**
   * Returns the meta object for the attribute '{@link tools.descartes.dql.lang.descartesQL.GetExplorationStrategiesQuery#getMode <em>Mode</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Mode</em>'.
   * @see tools.descartes.dql.lang.descartesQL.GetExplorationStrategiesQuery#getMode()
   * @see #getGetExplorationStrategiesQuery()
   * @generated
   */
  EAttribute getGetExplorationStrategiesQuery_Mode();

  /**
   * Returns the meta object for class '{@link tools.descartes.dql.lang.descartesQL.GetTimeUnitsQuery <em>Get Time Units Query</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Get Time Units Query</em>'.
   * @see tools.descartes.dql.lang.descartesQL.GetTimeUnitsQuery
   * @generated
   */
  EClass getGetTimeUnitsQuery();

  /**
   * Returns the meta object for the attribute '{@link tools.descartes.dql.lang.descartesQL.GetTimeUnitsQuery#getMode <em>Mode</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Mode</em>'.
   * @see tools.descartes.dql.lang.descartesQL.GetTimeUnitsQuery#getMode()
   * @see #getGetTimeUnitsQuery()
   * @generated
   */
  EAttribute getGetTimeUnitsQuery_Mode();

  /**
   * Returns the meta object for class '{@link tools.descartes.dql.lang.descartesQL.ListDoFQuery <em>List Do FQuery</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>List Do FQuery</em>'.
   * @see tools.descartes.dql.lang.descartesQL.ListDoFQuery
   * @generated
   */
  EClass getListDoFQuery();

  /**
   * Returns the meta object for the attribute '{@link tools.descartes.dql.lang.descartesQL.ListDoFQuery#getMode <em>Mode</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Mode</em>'.
   * @see tools.descartes.dql.lang.descartesQL.ListDoFQuery#getMode()
   * @see #getListDoFQuery()
   * @generated
   */
  EAttribute getListDoFQuery_Mode();

  /**
   * Returns the meta object for the containment reference '{@link tools.descartes.dql.lang.descartesQL.ListDoFQuery#getWithClause <em>With Clause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>With Clause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.ListDoFQuery#getWithClause()
   * @see #getListDoFQuery()
   * @generated
   */
  EReference getListDoFQuery_WithClause();

  /**
   * Returns the meta object for class '{@link tools.descartes.dql.lang.descartesQL.ListEntitiesQuery <em>List Entities Query</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>List Entities Query</em>'.
   * @see tools.descartes.dql.lang.descartesQL.ListEntitiesQuery
   * @generated
   */
  EClass getListEntitiesQuery();

  /**
   * Returns the meta object for the attribute '{@link tools.descartes.dql.lang.descartesQL.ListEntitiesQuery#getMode <em>Mode</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Mode</em>'.
   * @see tools.descartes.dql.lang.descartesQL.ListEntitiesQuery#getMode()
   * @see #getListEntitiesQuery()
   * @generated
   */
  EAttribute getListEntitiesQuery_Mode();

  /**
   * Returns the meta object for class '{@link tools.descartes.dql.lang.descartesQL.ListMetricsQuery <em>List Metrics Query</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>List Metrics Query</em>'.
   * @see tools.descartes.dql.lang.descartesQL.ListMetricsQuery
   * @generated
   */
  EClass getListMetricsQuery();

  /**
   * Returns the meta object for the attribute '{@link tools.descartes.dql.lang.descartesQL.ListMetricsQuery#getMode <em>Mode</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Mode</em>'.
   * @see tools.descartes.dql.lang.descartesQL.ListMetricsQuery#getMode()
   * @see #getListMetricsQuery()
   * @generated
   */
  EAttribute getListMetricsQuery_Mode();

  /**
   * Returns the meta object for the containment reference '{@link tools.descartes.dql.lang.descartesQL.ListMetricsQuery#getEntityReferenceClause <em>Entity Reference Clause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Entity Reference Clause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.ListMetricsQuery#getEntityReferenceClause()
   * @see #getListMetricsQuery()
   * @generated
   */
  EReference getListMetricsQuery_EntityReferenceClause();

  /**
   * Returns the meta object for class '{@link tools.descartes.dql.lang.descartesQL.SelectQuery <em>Select Query</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Select Query</em>'.
   * @see tools.descartes.dql.lang.descartesQL.SelectQuery
   * @generated
   */
  EClass getSelectQuery();

  /**
   * Returns the meta object for the containment reference '{@link tools.descartes.dql.lang.descartesQL.SelectQuery#getMetricReferenceClauses <em>Metric Reference Clauses</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Metric Reference Clauses</em>'.
   * @see tools.descartes.dql.lang.descartesQL.SelectQuery#getMetricReferenceClauses()
   * @see #getSelectQuery()
   * @generated
   */
  EReference getSelectQuery_MetricReferenceClauses();

  /**
   * Returns the meta object for the containment reference '{@link tools.descartes.dql.lang.descartesQL.SelectQuery#getConstraintClause <em>Constraint Clause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Constraint Clause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.SelectQuery#getConstraintClause()
   * @see #getSelectQuery()
   * @generated
   */
  EReference getSelectQuery_ConstraintClause();

  /**
   * Returns the meta object for the containment reference '{@link tools.descartes.dql.lang.descartesQL.SelectQuery#getDofClause <em>Dof Clause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Dof Clause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.SelectQuery#getDofClause()
   * @see #getSelectQuery()
   * @generated
   */
  EReference getSelectQuery_DofClause();

  /**
   * Returns the meta object for the containment reference '{@link tools.descartes.dql.lang.descartesQL.SelectQuery#getForClause <em>For Clause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>For Clause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.SelectQuery#getForClause()
   * @see #getSelectQuery()
   * @generated
   */
  EReference getSelectQuery_ForClause();

  /**
   * Returns the meta object for the containment reference '{@link tools.descartes.dql.lang.descartesQL.SelectQuery#getUsingClause <em>Using Clause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Using Clause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.SelectQuery#getUsingClause()
   * @see #getSelectQuery()
   * @generated
   */
  EReference getSelectQuery_UsingClause();

  /**
   * Returns the meta object for the containment reference '{@link tools.descartes.dql.lang.descartesQL.SelectQuery#getObserveClause <em>Observe Clause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Observe Clause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.SelectQuery#getObserveClause()
   * @see #getSelectQuery()
   * @generated
   */
  EReference getSelectQuery_ObserveClause();

  /**
   * Returns the meta object for class '{@link tools.descartes.dql.lang.descartesQL.MetricReferenceClauses <em>Metric Reference Clauses</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Metric Reference Clauses</em>'.
   * @see tools.descartes.dql.lang.descartesQL.MetricReferenceClauses
   * @generated
   */
  EClass getMetricReferenceClauses();

  /**
   * Returns the meta object for the containment reference list '{@link tools.descartes.dql.lang.descartesQL.MetricReferenceClauses#getMetricClauseTypes <em>Metric Clause Types</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Metric Clause Types</em>'.
   * @see tools.descartes.dql.lang.descartesQL.MetricReferenceClauses#getMetricClauseTypes()
   * @see #getMetricReferenceClauses()
   * @generated
   */
  EReference getMetricReferenceClauses_MetricClauseTypes();

  /**
   * Returns the meta object for class '{@link tools.descartes.dql.lang.descartesQL.MetricClauseType <em>Metric Clause Type</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Metric Clause Type</em>'.
   * @see tools.descartes.dql.lang.descartesQL.MetricClauseType
   * @generated
   */
  EClass getMetricClauseType();

  /**
   * Returns the meta object for class '{@link tools.descartes.dql.lang.descartesQL.DetectQuery <em>Detect Query</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Detect Query</em>'.
   * @see tools.descartes.dql.lang.descartesQL.DetectQuery
   * @generated
   */
  EClass getDetectQuery();

  /**
   * Returns the meta object for the containment reference '{@link tools.descartes.dql.lang.descartesQL.DetectQuery#getQueryType <em>Query Type</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Query Type</em>'.
   * @see tools.descartes.dql.lang.descartesQL.DetectQuery#getQueryType()
   * @see #getDetectQuery()
   * @generated
   */
  EReference getDetectQuery_QueryType();

  /**
   * Returns the meta object for class '{@link tools.descartes.dql.lang.descartesQL.DetectBottlenecksQuery <em>Detect Bottlenecks Query</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Detect Bottlenecks Query</em>'.
   * @see tools.descartes.dql.lang.descartesQL.DetectBottlenecksQuery
   * @generated
   */
  EClass getDetectBottlenecksQuery();

  /**
   * Returns the meta object for the containment reference '{@link tools.descartes.dql.lang.descartesQL.DetectBottlenecksQuery#getDofClause <em>Dof Clause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Dof Clause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.DetectBottlenecksQuery#getDofClause()
   * @see #getDetectBottlenecksQuery()
   * @generated
   */
  EReference getDetectBottlenecksQuery_DofClause();

  /**
   * Returns the meta object for the containment reference '{@link tools.descartes.dql.lang.descartesQL.DetectBottlenecksQuery#getUsingClause <em>Using Clause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Using Clause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.DetectBottlenecksQuery#getUsingClause()
   * @see #getDetectBottlenecksQuery()
   * @generated
   */
  EReference getDetectBottlenecksQuery_UsingClause();

  /**
   * Returns the meta object for class '{@link tools.descartes.dql.lang.descartesQL.ConstraintClause <em>Constraint Clause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Constraint Clause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.ConstraintClause
   * @generated
   */
  EClass getConstraintClause();

  /**
   * Returns the meta object for the attribute '{@link tools.descartes.dql.lang.descartesQL.ConstraintClause#getType <em>Type</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Type</em>'.
   * @see tools.descartes.dql.lang.descartesQL.ConstraintClause#getType()
   * @see #getConstraintClause()
   * @generated
   */
  EAttribute getConstraintClause_Type();

  /**
   * Returns the meta object for class '{@link tools.descartes.dql.lang.descartesQL.DoFClause <em>Do FClause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Do FClause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.DoFClause
   * @generated
   */
  EClass getDoFClause();

  /**
   * Returns the meta object for the attribute '{@link tools.descartes.dql.lang.descartesQL.DoFClause#getMode <em>Mode</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Mode</em>'.
   * @see tools.descartes.dql.lang.descartesQL.DoFClause#getMode()
   * @see #getDoFClause()
   * @generated
   */
  EAttribute getDoFClause_Mode();

  /**
   * Returns the meta object for the containment reference '{@link tools.descartes.dql.lang.descartesQL.DoFClause#getVaryingClause <em>Varying Clause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Varying Clause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.DoFClause#getVaryingClause()
   * @see #getDoFClause()
   * @generated
   */
  EReference getDoFClause_VaryingClause();

  /**
   * Returns the meta object for the containment reference '{@link tools.descartes.dql.lang.descartesQL.DoFClause#getExplorationStrategy <em>Exploration Strategy</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Exploration Strategy</em>'.
   * @see tools.descartes.dql.lang.descartesQL.DoFClause#getExplorationStrategy()
   * @see #getDoFClause()
   * @generated
   */
  EReference getDoFClause_ExplorationStrategy();

  /**
   * Returns the meta object for the containment reference '{@link tools.descartes.dql.lang.descartesQL.DoFClause#getConstraintClause <em>Constraint Clause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Constraint Clause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.DoFClause#getConstraintClause()
   * @see #getDoFClause()
   * @generated
   */
  EReference getDoFClause_ConstraintClause();

  /**
   * Returns the meta object for the containment reference '{@link tools.descartes.dql.lang.descartesQL.DoFClause#getWithClause <em>With Clause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>With Clause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.DoFClause#getWithClause()
   * @see #getDoFClause()
   * @generated
   */
  EReference getDoFClause_WithClause();

  /**
   * Returns the meta object for class '{@link tools.descartes.dql.lang.descartesQL.ExplorationStrategyClause <em>Exploration Strategy Clause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Exploration Strategy Clause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.ExplorationStrategyClause
   * @generated
   */
  EClass getExplorationStrategyClause();

  /**
   * Returns the meta object for the attribute '{@link tools.descartes.dql.lang.descartesQL.ExplorationStrategyClause#getMode <em>Mode</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Mode</em>'.
   * @see tools.descartes.dql.lang.descartesQL.ExplorationStrategyClause#getMode()
   * @see #getExplorationStrategyClause()
   * @generated
   */
  EAttribute getExplorationStrategyClause_Mode();

  /**
   * Returns the meta object for the attribute '{@link tools.descartes.dql.lang.descartesQL.ExplorationStrategyClause#getName <em>Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Name</em>'.
   * @see tools.descartes.dql.lang.descartesQL.ExplorationStrategyClause#getName()
   * @see #getExplorationStrategyClause()
   * @generated
   */
  EAttribute getExplorationStrategyClause_Name();

  /**
   * Returns the meta object for the containment reference '{@link tools.descartes.dql.lang.descartesQL.ExplorationStrategyClause#getParameterClause <em>Parameter Clause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Parameter Clause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.ExplorationStrategyClause#getParameterClause()
   * @see #getExplorationStrategyClause()
   * @generated
   */
  EReference getExplorationStrategyClause_ParameterClause();

  /**
   * Returns the meta object for class '{@link tools.descartes.dql.lang.descartesQL.ConfigurationPropertiesClause <em>Configuration Properties Clause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Configuration Properties Clause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.ConfigurationPropertiesClause
   * @generated
   */
  EClass getConfigurationPropertiesClause();

  /**
   * Returns the meta object for the attribute '{@link tools.descartes.dql.lang.descartesQL.ConfigurationPropertiesClause#getMode1 <em>Mode1</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Mode1</em>'.
   * @see tools.descartes.dql.lang.descartesQL.ConfigurationPropertiesClause#getMode1()
   * @see #getConfigurationPropertiesClause()
   * @generated
   */
  EAttribute getConfigurationPropertiesClause_Mode1();

  /**
   * Returns the meta object for the containment reference list '{@link tools.descartes.dql.lang.descartesQL.ConfigurationPropertiesClause#getProperties <em>Properties</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Properties</em>'.
   * @see tools.descartes.dql.lang.descartesQL.ConfigurationPropertiesClause#getProperties()
   * @see #getConfigurationPropertiesClause()
   * @generated
   */
  EReference getConfigurationPropertiesClause_Properties();

  /**
   * Returns the meta object for the attribute '{@link tools.descartes.dql.lang.descartesQL.ConfigurationPropertiesClause#getMode2 <em>Mode2</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Mode2</em>'.
   * @see tools.descartes.dql.lang.descartesQL.ConfigurationPropertiesClause#getMode2()
   * @see #getConfigurationPropertiesClause()
   * @generated
   */
  EAttribute getConfigurationPropertiesClause_Mode2();

  /**
   * Returns the meta object for class '{@link tools.descartes.dql.lang.descartesQL.ConfigurationPropertyClause <em>Configuration Property Clause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Configuration Property Clause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.ConfigurationPropertyClause
   * @generated
   */
  EClass getConfigurationPropertyClause();

  /**
   * Returns the meta object for the attribute list '{@link tools.descartes.dql.lang.descartesQL.ConfigurationPropertyClause#getKey <em>Key</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute list '<em>Key</em>'.
   * @see tools.descartes.dql.lang.descartesQL.ConfigurationPropertyClause#getKey()
   * @see #getConfigurationPropertyClause()
   * @generated
   */
  EAttribute getConfigurationPropertyClause_Key();

  /**
   * Returns the meta object for the attribute '{@link tools.descartes.dql.lang.descartesQL.ConfigurationPropertyClause#getValue <em>Value</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Value</em>'.
   * @see tools.descartes.dql.lang.descartesQL.ConfigurationPropertyClause#getValue()
   * @see #getConfigurationPropertyClause()
   * @generated
   */
  EAttribute getConfigurationPropertyClause_Value();

  /**
   * Returns the meta object for class '{@link tools.descartes.dql.lang.descartesQL.DoFVariationClause <em>Do FVariation Clause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Do FVariation Clause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.DoFVariationClause
   * @generated
   */
  EClass getDoFVariationClause();

  /**
   * Returns the meta object for the attribute '{@link tools.descartes.dql.lang.descartesQL.DoFVariationClause#getMode1 <em>Mode1</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Mode1</em>'.
   * @see tools.descartes.dql.lang.descartesQL.DoFVariationClause#getMode1()
   * @see #getDoFVariationClause()
   * @generated
   */
  EAttribute getDoFVariationClause_Mode1();

  /**
   * Returns the meta object for the containment reference '{@link tools.descartes.dql.lang.descartesQL.DoFVariationClause#getVariation <em>Variation</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Variation</em>'.
   * @see tools.descartes.dql.lang.descartesQL.DoFVariationClause#getVariation()
   * @see #getDoFVariationClause()
   * @generated
   */
  EReference getDoFVariationClause_Variation();

  /**
   * Returns the meta object for the attribute '{@link tools.descartes.dql.lang.descartesQL.DoFVariationClause#getMode2 <em>Mode2</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Mode2</em>'.
   * @see tools.descartes.dql.lang.descartesQL.DoFVariationClause#getMode2()
   * @see #getDoFVariationClause()
   * @generated
   */
  EAttribute getDoFVariationClause_Mode2();

  /**
   * Returns the meta object for class '{@link tools.descartes.dql.lang.descartesQL.ValueVariationClause <em>Value Variation Clause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Value Variation Clause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.ValueVariationClause
   * @generated
   */
  EClass getValueVariationClause();

  /**
   * Returns the meta object for the attribute list '{@link tools.descartes.dql.lang.descartesQL.ValueVariationClause#getValue <em>Value</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute list '<em>Value</em>'.
   * @see tools.descartes.dql.lang.descartesQL.ValueVariationClause#getValue()
   * @see #getValueVariationClause()
   * @generated
   */
  EAttribute getValueVariationClause_Value();

  /**
   * Returns the meta object for class '{@link tools.descartes.dql.lang.descartesQL.IntervalVariationClause <em>Interval Variation Clause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Interval Variation Clause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.IntervalVariationClause
   * @generated
   */
  EClass getIntervalVariationClause();

  /**
   * Returns the meta object for the attribute '{@link tools.descartes.dql.lang.descartesQL.IntervalVariationClause#getStart <em>Start</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Start</em>'.
   * @see tools.descartes.dql.lang.descartesQL.IntervalVariationClause#getStart()
   * @see #getIntervalVariationClause()
   * @generated
   */
  EAttribute getIntervalVariationClause_Start();

  /**
   * Returns the meta object for the attribute '{@link tools.descartes.dql.lang.descartesQL.IntervalVariationClause#getEnd <em>End</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>End</em>'.
   * @see tools.descartes.dql.lang.descartesQL.IntervalVariationClause#getEnd()
   * @see #getIntervalVariationClause()
   * @generated
   */
  EAttribute getIntervalVariationClause_End();

  /**
   * Returns the meta object for the attribute '{@link tools.descartes.dql.lang.descartesQL.IntervalVariationClause#getStep <em>Step</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Step</em>'.
   * @see tools.descartes.dql.lang.descartesQL.IntervalVariationClause#getStep()
   * @see #getIntervalVariationClause()
   * @generated
   */
  EAttribute getIntervalVariationClause_Step();

  /**
   * Returns the meta object for class '{@link tools.descartes.dql.lang.descartesQL.VaryingClause <em>Varying Clause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Varying Clause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.VaryingClause
   * @generated
   */
  EClass getVaryingClause();

  /**
   * Returns the meta object for the attribute '{@link tools.descartes.dql.lang.descartesQL.VaryingClause#getMode <em>Mode</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Mode</em>'.
   * @see tools.descartes.dql.lang.descartesQL.VaryingClause#getMode()
   * @see #getVaryingClause()
   * @generated
   */
  EAttribute getVaryingClause_Mode();

  /**
   * Returns the meta object for the containment reference list '{@link tools.descartes.dql.lang.descartesQL.VaryingClause#getDofReferences <em>Dof References</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Dof References</em>'.
   * @see tools.descartes.dql.lang.descartesQL.VaryingClause#getDofReferences()
   * @see #getVaryingClause()
   * @generated
   */
  EReference getVaryingClause_DofReferences();

  /**
   * Returns the meta object for class '{@link tools.descartes.dql.lang.descartesQL.DoFReference <em>Do FReference</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Do FReference</em>'.
   * @see tools.descartes.dql.lang.descartesQL.DoFReference
   * @generated
   */
  EClass getDoFReference();

  /**
   * Returns the meta object for the attribute '{@link tools.descartes.dql.lang.descartesQL.DoFReference#getDoFIdentifier <em>Do FIdentifier</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Do FIdentifier</em>'.
   * @see tools.descartes.dql.lang.descartesQL.DoFReference#getDoFIdentifier()
   * @see #getDoFReference()
   * @generated
   */
  EAttribute getDoFReference_DoFIdentifier();

  /**
   * Returns the meta object for the containment reference '{@link tools.descartes.dql.lang.descartesQL.DoFReference#getDoFAliasClause <em>Do FAlias Clause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Do FAlias Clause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.DoFReference#getDoFAliasClause()
   * @see #getDoFReference()
   * @generated
   */
  EReference getDoFReference_DoFAliasClause();

  /**
   * Returns the meta object for the containment reference '{@link tools.descartes.dql.lang.descartesQL.DoFReference#getDoFVariationClause <em>Do FVariation Clause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Do FVariation Clause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.DoFReference#getDoFVariationClause()
   * @see #getDoFReference()
   * @generated
   */
  EReference getDoFReference_DoFVariationClause();

  /**
   * Returns the meta object for class '{@link tools.descartes.dql.lang.descartesQL.MetricClause <em>Metric Clause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Metric Clause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.MetricClause
   * @generated
   */
  EClass getMetricClause();

  /**
   * Returns the meta object for the containment reference '{@link tools.descartes.dql.lang.descartesQL.MetricClause#getMetricReference <em>Metric Reference</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Metric Reference</em>'.
   * @see tools.descartes.dql.lang.descartesQL.MetricClause#getMetricReference()
   * @see #getMetricClause()
   * @generated
   */
  EReference getMetricClause_MetricReference();

  /**
   * Returns the meta object for class '{@link tools.descartes.dql.lang.descartesQL.AggregateMetricClause <em>Aggregate Metric Clause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Aggregate Metric Clause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.AggregateMetricClause
   * @generated
   */
  EClass getAggregateMetricClause();

  /**
   * Returns the meta object for the attribute '{@link tools.descartes.dql.lang.descartesQL.AggregateMetricClause#getFunction <em>Function</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Function</em>'.
   * @see tools.descartes.dql.lang.descartesQL.AggregateMetricClause#getFunction()
   * @see #getAggregateMetricClause()
   * @generated
   */
  EAttribute getAggregateMetricClause_Function();

  /**
   * Returns the meta object for the containment reference '{@link tools.descartes.dql.lang.descartesQL.AggregateMetricClause#getMetrics <em>Metrics</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Metrics</em>'.
   * @see tools.descartes.dql.lang.descartesQL.AggregateMetricClause#getMetrics()
   * @see #getAggregateMetricClause()
   * @generated
   */
  EReference getAggregateMetricClause_Metrics();

  /**
   * Returns the meta object for the containment reference '{@link tools.descartes.dql.lang.descartesQL.AggregateMetricClause#getProperties <em>Properties</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Properties</em>'.
   * @see tools.descartes.dql.lang.descartesQL.AggregateMetricClause#getProperties()
   * @see #getAggregateMetricClause()
   * @generated
   */
  EReference getAggregateMetricClause_Properties();

  /**
   * Returns the meta object for class '{@link tools.descartes.dql.lang.descartesQL.MetricClauses <em>Metric Clauses</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Metric Clauses</em>'.
   * @see tools.descartes.dql.lang.descartesQL.MetricClauses
   * @generated
   */
  EClass getMetricClauses();

  /**
   * Returns the meta object for the containment reference list '{@link tools.descartes.dql.lang.descartesQL.MetricClauses#getMetrics <em>Metrics</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Metrics</em>'.
   * @see tools.descartes.dql.lang.descartesQL.MetricClauses#getMetrics()
   * @see #getMetricClauses()
   * @generated
   */
  EReference getMetricClauses_Metrics();

  /**
   * Returns the meta object for class '{@link tools.descartes.dql.lang.descartesQL.MetricStarClause <em>Metric Star Clause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Metric Star Clause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.MetricStarClause
   * @generated
   */
  EClass getMetricStarClause();

  /**
   * Returns the meta object for the attribute '{@link tools.descartes.dql.lang.descartesQL.MetricStarClause#getMetricName <em>Metric Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Metric Name</em>'.
   * @see tools.descartes.dql.lang.descartesQL.MetricStarClause#getMetricName()
   * @see #getMetricStarClause()
   * @generated
   */
  EAttribute getMetricStarClause_MetricName();

  /**
   * Returns the meta object for class '{@link tools.descartes.dql.lang.descartesQL.MetricReference <em>Metric Reference</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Metric Reference</em>'.
   * @see tools.descartes.dql.lang.descartesQL.MetricReference
   * @generated
   */
  EClass getMetricReference();

  /**
   * Returns the meta object for the attribute '{@link tools.descartes.dql.lang.descartesQL.MetricReference#getEntityReference <em>Entity Reference</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Entity Reference</em>'.
   * @see tools.descartes.dql.lang.descartesQL.MetricReference#getEntityReference()
   * @see #getMetricReference()
   * @generated
   */
  EAttribute getMetricReference_EntityReference();

  /**
   * Returns the meta object for the attribute '{@link tools.descartes.dql.lang.descartesQL.MetricReference#getSeparator <em>Separator</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Separator</em>'.
   * @see tools.descartes.dql.lang.descartesQL.MetricReference#getSeparator()
   * @see #getMetricReference()
   * @generated
   */
  EAttribute getMetricReference_Separator();

  /**
   * Returns the meta object for the attribute '{@link tools.descartes.dql.lang.descartesQL.MetricReference#getMetricReference <em>Metric Reference</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Metric Reference</em>'.
   * @see tools.descartes.dql.lang.descartesQL.MetricReference#getMetricReference()
   * @see #getMetricReference()
   * @generated
   */
  EAttribute getMetricReference_MetricReference();

  /**
   * Returns the meta object for the attribute '{@link tools.descartes.dql.lang.descartesQL.MetricReference#getSeparatorv <em>Separatorv</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Separatorv</em>'.
   * @see tools.descartes.dql.lang.descartesQL.MetricReference#getSeparatorv()
   * @see #getMetricReference()
   * @generated
   */
  EAttribute getMetricReference_Separatorv();

  /**
   * Returns the meta object for the attribute '{@link tools.descartes.dql.lang.descartesQL.MetricReference#getStatTypeReference <em>Stat Type Reference</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Stat Type Reference</em>'.
   * @see tools.descartes.dql.lang.descartesQL.MetricReference#getStatTypeReference()
   * @see #getMetricReference()
   * @generated
   */
  EAttribute getMetricReference_StatTypeReference();

  /**
   * Returns the meta object for class '{@link tools.descartes.dql.lang.descartesQL.ForClause <em>For Clause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>For Clause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.ForClause
   * @generated
   */
  EClass getForClause();

  /**
   * Returns the meta object for the attribute '{@link tools.descartes.dql.lang.descartesQL.ForClause#getMode <em>Mode</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Mode</em>'.
   * @see tools.descartes.dql.lang.descartesQL.ForClause#getMode()
   * @see #getForClause()
   * @generated
   */
  EAttribute getForClause_Mode();

  /**
   * Returns the meta object for the containment reference '{@link tools.descartes.dql.lang.descartesQL.ForClause#getEntityReferenceClause <em>Entity Reference Clause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Entity Reference Clause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.ForClause#getEntityReferenceClause()
   * @see #getForClause()
   * @generated
   */
  EReference getForClause_EntityReferenceClause();

  /**
   * Returns the meta object for class '{@link tools.descartes.dql.lang.descartesQL.EntityReferenceClause <em>Entity Reference Clause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Entity Reference Clause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.EntityReferenceClause
   * @generated
   */
  EClass getEntityReferenceClause();

  /**
   * Returns the meta object for the containment reference list '{@link tools.descartes.dql.lang.descartesQL.EntityReferenceClause#getEntityReferences <em>Entity References</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Entity References</em>'.
   * @see tools.descartes.dql.lang.descartesQL.EntityReferenceClause#getEntityReferences()
   * @see #getEntityReferenceClause()
   * @generated
   */
  EReference getEntityReferenceClause_EntityReferences();

  /**
   * Returns the meta object for class '{@link tools.descartes.dql.lang.descartesQL.EntityReference <em>Entity Reference</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Entity Reference</em>'.
   * @see tools.descartes.dql.lang.descartesQL.EntityReference
   * @generated
   */
  EClass getEntityReference();

  /**
   * Returns the meta object for the attribute '{@link tools.descartes.dql.lang.descartesQL.EntityReference#getType <em>Type</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Type</em>'.
   * @see tools.descartes.dql.lang.descartesQL.EntityReference#getType()
   * @see #getEntityReference()
   * @generated
   */
  EAttribute getEntityReference_Type();

  /**
   * Returns the meta object for the attribute '{@link tools.descartes.dql.lang.descartesQL.EntityReference#getIdentifier <em>Identifier</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Identifier</em>'.
   * @see tools.descartes.dql.lang.descartesQL.EntityReference#getIdentifier()
   * @see #getEntityReference()
   * @generated
   */
  EAttribute getEntityReference_Identifier();

  /**
   * Returns the meta object for the containment reference '{@link tools.descartes.dql.lang.descartesQL.EntityReference#getAlias <em>Alias</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Alias</em>'.
   * @see tools.descartes.dql.lang.descartesQL.EntityReference#getAlias()
   * @see #getEntityReference()
   * @generated
   */
  EReference getEntityReference_Alias();

  /**
   * Returns the meta object for class '{@link tools.descartes.dql.lang.descartesQL.AliasClause <em>Alias Clause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Alias Clause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.AliasClause
   * @generated
   */
  EClass getAliasClause();

  /**
   * Returns the meta object for the attribute '{@link tools.descartes.dql.lang.descartesQL.AliasClause#getMode <em>Mode</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Mode</em>'.
   * @see tools.descartes.dql.lang.descartesQL.AliasClause#getMode()
   * @see #getAliasClause()
   * @generated
   */
  EAttribute getAliasClause_Mode();

  /**
   * Returns the meta object for the attribute '{@link tools.descartes.dql.lang.descartesQL.AliasClause#getAlias <em>Alias</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Alias</em>'.
   * @see tools.descartes.dql.lang.descartesQL.AliasClause#getAlias()
   * @see #getAliasClause()
   * @generated
   */
  EAttribute getAliasClause_Alias();

  /**
   * Returns the meta object for class '{@link tools.descartes.dql.lang.descartesQL.UsingClause <em>Using Clause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Using Clause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.UsingClause
   * @generated
   */
  EClass getUsingClause();

  /**
   * Returns the meta object for the attribute '{@link tools.descartes.dql.lang.descartesQL.UsingClause#getMode <em>Mode</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Mode</em>'.
   * @see tools.descartes.dql.lang.descartesQL.UsingClause#getMode()
   * @see #getUsingClause()
   * @generated
   */
  EAttribute getUsingClause_Mode();

  /**
   * Returns the meta object for the containment reference '{@link tools.descartes.dql.lang.descartesQL.UsingClause#getModelReference <em>Model Reference</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Model Reference</em>'.
   * @see tools.descartes.dql.lang.descartesQL.UsingClause#getModelReference()
   * @see #getUsingClause()
   * @generated
   */
  EReference getUsingClause_ModelReference();

  /**
   * Returns the meta object for class '{@link tools.descartes.dql.lang.descartesQL.WithClause <em>With Clause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>With Clause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.WithClause
   * @generated
   */
  EClass getWithClause();

  /**
   * Returns the meta object for the attribute '{@link tools.descartes.dql.lang.descartesQL.WithClause#getMode <em>Mode</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Mode</em>'.
   * @see tools.descartes.dql.lang.descartesQL.WithClause#getMode()
   * @see #getWithClause()
   * @generated
   */
  EAttribute getWithClause_Mode();

  /**
   * Returns the meta object for the containment reference '{@link tools.descartes.dql.lang.descartesQL.WithClause#getModelReference <em>Model Reference</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Model Reference</em>'.
   * @see tools.descartes.dql.lang.descartesQL.WithClause#getModelReference()
   * @see #getWithClause()
   * @generated
   */
  EReference getWithClause_ModelReference();

  /**
   * Returns the meta object for class '{@link tools.descartes.dql.lang.descartesQL.ModelReferenceClause <em>Model Reference Clause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Model Reference Clause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.ModelReferenceClause
   * @generated
   */
  EClass getModelReferenceClause();

  /**
   * Returns the meta object for the containment reference '{@link tools.descartes.dql.lang.descartesQL.ModelReferenceClause#getFamily <em>Family</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Family</em>'.
   * @see tools.descartes.dql.lang.descartesQL.ModelReferenceClause#getFamily()
   * @see #getModelReferenceClause()
   * @generated
   */
  EReference getModelReferenceClause_Family();

  /**
   * Returns the meta object for the containment reference '{@link tools.descartes.dql.lang.descartesQL.ModelReferenceClause#getModel <em>Model</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Model</em>'.
   * @see tools.descartes.dql.lang.descartesQL.ModelReferenceClause#getModel()
   * @see #getModelReferenceClause()
   * @generated
   */
  EReference getModelReferenceClause_Model();

  /**
   * Returns the meta object for class '{@link tools.descartes.dql.lang.descartesQL.ModelFamily <em>Model Family</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Model Family</em>'.
   * @see tools.descartes.dql.lang.descartesQL.ModelFamily
   * @generated
   */
  EClass getModelFamily();

  /**
   * Returns the meta object for the attribute '{@link tools.descartes.dql.lang.descartesQL.ModelFamily#getFamily <em>Family</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Family</em>'.
   * @see tools.descartes.dql.lang.descartesQL.ModelFamily#getFamily()
   * @see #getModelFamily()
   * @generated
   */
  EAttribute getModelFamily_Family();

  /**
   * Returns the meta object for class '{@link tools.descartes.dql.lang.descartesQL.ModelLocation <em>Model Location</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Model Location</em>'.
   * @see tools.descartes.dql.lang.descartesQL.ModelLocation
   * @generated
   */
  EClass getModelLocation();

  /**
   * Returns the meta object for the attribute '{@link tools.descartes.dql.lang.descartesQL.ModelLocation#getLocation <em>Location</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Location</em>'.
   * @see tools.descartes.dql.lang.descartesQL.ModelLocation#getLocation()
   * @see #getModelLocation()
   * @generated
   */
  EAttribute getModelLocation_Location();

  /**
   * Returns the meta object for class '{@link tools.descartes.dql.lang.descartesQL.FilterClause <em>Filter Clause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Filter Clause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.FilterClause
   * @generated
   */
  EClass getFilterClause();

  /**
   * Returns the meta object for the attribute '{@link tools.descartes.dql.lang.descartesQL.FilterClause#getMode <em>Mode</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Mode</em>'.
   * @see tools.descartes.dql.lang.descartesQL.FilterClause#getMode()
   * @see #getFilterClause()
   * @generated
   */
  EAttribute getFilterClause_Mode();

  /**
   * Returns the meta object for the containment reference list '{@link tools.descartes.dql.lang.descartesQL.FilterClause#getFilterConditions <em>Filter Conditions</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Filter Conditions</em>'.
   * @see tools.descartes.dql.lang.descartesQL.FilterClause#getFilterConditions()
   * @see #getFilterClause()
   * @generated
   */
  EReference getFilterClause_FilterConditions();

  /**
   * Returns the meta object for the attribute list '{@link tools.descartes.dql.lang.descartesQL.FilterClause#getFilterConjunctions <em>Filter Conjunctions</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute list '<em>Filter Conjunctions</em>'.
   * @see tools.descartes.dql.lang.descartesQL.FilterClause#getFilterConjunctions()
   * @see #getFilterClause()
   * @generated
   */
  EAttribute getFilterClause_FilterConjunctions();

  /**
   * Returns the meta object for class '{@link tools.descartes.dql.lang.descartesQL.FilterConditionClause <em>Filter Condition Clause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Filter Condition Clause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.FilterConditionClause
   * @generated
   */
  EClass getFilterConditionClause();

  /**
   * Returns the meta object for the attribute '{@link tools.descartes.dql.lang.descartesQL.FilterConditionClause#getMode <em>Mode</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Mode</em>'.
   * @see tools.descartes.dql.lang.descartesQL.FilterConditionClause#getMode()
   * @see #getFilterConditionClause()
   * @generated
   */
  EAttribute getFilterConditionClause_Mode();

  /**
   * Returns the meta object for the attribute '{@link tools.descartes.dql.lang.descartesQL.FilterConditionClause#getCondition <em>Condition</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Condition</em>'.
   * @see tools.descartes.dql.lang.descartesQL.FilterConditionClause#getCondition()
   * @see #getFilterConditionClause()
   * @generated
   */
  EAttribute getFilterConditionClause_Condition();

  /**
   * Returns the meta object for the containment reference '{@link tools.descartes.dql.lang.descartesQL.FilterConditionClause#getValue <em>Value</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Value</em>'.
   * @see tools.descartes.dql.lang.descartesQL.FilterConditionClause#getValue()
   * @see #getFilterConditionClause()
   * @generated
   */
  EReference getFilterConditionClause_Value();

  /**
   * Returns the meta object for class '{@link tools.descartes.dql.lang.descartesQL.FilterConditionValue <em>Filter Condition Value</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Filter Condition Value</em>'.
   * @see tools.descartes.dql.lang.descartesQL.FilterConditionValue
   * @generated
   */
  EClass getFilterConditionValue();

  /**
   * Returns the meta object for the attribute '{@link tools.descartes.dql.lang.descartesQL.FilterConditionValue#getValue <em>Value</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Value</em>'.
   * @see tools.descartes.dql.lang.descartesQL.FilterConditionValue#getValue()
   * @see #getFilterConditionValue()
   * @generated
   */
  EAttribute getFilterConditionValue_Value();

  /**
   * Returns the meta object for class '{@link tools.descartes.dql.lang.descartesQL.ObserveClause <em>Observe Clause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Observe Clause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.ObserveClause
   * @generated
   */
  EClass getObserveClause();

  /**
   * Returns the meta object for the attribute '{@link tools.descartes.dql.lang.descartesQL.ObserveClause#getMode <em>Mode</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Mode</em>'.
   * @see tools.descartes.dql.lang.descartesQL.ObserveClause#getMode()
   * @see #getObserveClause()
   * @generated
   */
  EAttribute getObserveClause_Mode();

  /**
   * Returns the meta object for the containment reference '{@link tools.descartes.dql.lang.descartesQL.ObserveClause#getObservation <em>Observation</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Observation</em>'.
   * @see tools.descartes.dql.lang.descartesQL.ObserveClause#getObservation()
   * @see #getObserveClause()
   * @generated
   */
  EReference getObserveClause_Observation();

  /**
   * Returns the meta object for the containment reference '{@link tools.descartes.dql.lang.descartesQL.ObserveClause#getSampleClause <em>Sample Clause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Sample Clause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.ObserveClause#getSampleClause()
   * @see #getObserveClause()
   * @generated
   */
  EReference getObserveClause_SampleClause();

  /**
   * Returns the meta object for class '{@link tools.descartes.dql.lang.descartesQL.ObservationClause <em>Observation Clause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Observation Clause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.ObservationClause
   * @generated
   */
  EClass getObservationClause();

  /**
   * Returns the meta object for class '{@link tools.descartes.dql.lang.descartesQL.SampleClause <em>Sample Clause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Sample Clause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.SampleClause
   * @generated
   */
  EClass getSampleClause();

  /**
   * Returns the meta object for the attribute '{@link tools.descartes.dql.lang.descartesQL.SampleClause#getMode <em>Mode</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Mode</em>'.
   * @see tools.descartes.dql.lang.descartesQL.SampleClause#getMode()
   * @see #getSampleClause()
   * @generated
   */
  EAttribute getSampleClause_Mode();

  /**
   * Returns the meta object for the containment reference list '{@link tools.descartes.dql.lang.descartesQL.SampleClause#getDurationClause <em>Duration Clause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Duration Clause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.SampleClause#getDurationClause()
   * @see #getSampleClause()
   * @generated
   */
  EReference getSampleClause_DurationClause();

  /**
   * Returns the meta object for class '{@link tools.descartes.dql.lang.descartesQL.ConnectorTimeUnitClause <em>Connector Time Unit Clause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Connector Time Unit Clause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.ConnectorTimeUnitClause
   * @generated
   */
  EClass getConnectorTimeUnitClause();

  /**
   * Returns the meta object for the attribute '{@link tools.descartes.dql.lang.descartesQL.ConnectorTimeUnitClause#getCount <em>Count</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Count</em>'.
   * @see tools.descartes.dql.lang.descartesQL.ConnectorTimeUnitClause#getCount()
   * @see #getConnectorTimeUnitClause()
   * @generated
   */
  EAttribute getConnectorTimeUnitClause_Count();

  /**
   * Returns the meta object for the attribute '{@link tools.descartes.dql.lang.descartesQL.ConnectorTimeUnitClause#getTimeIndicator <em>Time Indicator</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Time Indicator</em>'.
   * @see tools.descartes.dql.lang.descartesQL.ConnectorTimeUnitClause#getTimeIndicator()
   * @see #getConnectorTimeUnitClause()
   * @generated
   */
  EAttribute getConnectorTimeUnitClause_TimeIndicator();

  /**
   * Returns the meta object for class '{@link tools.descartes.dql.lang.descartesQL.ConnectorInstanceReferenceClause <em>Connector Instance Reference Clause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Connector Instance Reference Clause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.ConnectorInstanceReferenceClause
   * @generated
   */
  EClass getConnectorInstanceReferenceClause();

  /**
   * Returns the meta object for the attribute '{@link tools.descartes.dql.lang.descartesQL.ConnectorInstanceReferenceClause#getType <em>Type</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Type</em>'.
   * @see tools.descartes.dql.lang.descartesQL.ConnectorInstanceReferenceClause#getType()
   * @see #getConnectorInstanceReferenceClause()
   * @generated
   */
  EAttribute getConnectorInstanceReferenceClause_Type();

  /**
   * Returns the meta object for the attribute '{@link tools.descartes.dql.lang.descartesQL.ConnectorInstanceReferenceClause#getIdentifier <em>Identifier</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Identifier</em>'.
   * @see tools.descartes.dql.lang.descartesQL.ConnectorInstanceReferenceClause#getIdentifier()
   * @see #getConnectorInstanceReferenceClause()
   * @generated
   */
  EAttribute getConnectorInstanceReferenceClause_Identifier();

  /**
   * Returns the meta object for class '{@link tools.descartes.dql.lang.descartesQL.ObserveRelativeClause <em>Observe Relative Clause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Observe Relative Clause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.ObserveRelativeClause
   * @generated
   */
  EClass getObserveRelativeClause();

  /**
   * Returns the meta object for the attribute '{@link tools.descartes.dql.lang.descartesQL.ObserveRelativeClause#getDirection <em>Direction</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Direction</em>'.
   * @see tools.descartes.dql.lang.descartesQL.ObserveRelativeClause#getDirection()
   * @see #getObserveRelativeClause()
   * @generated
   */
  EAttribute getObserveRelativeClause_Direction();

  /**
   * Returns the meta object for the containment reference '{@link tools.descartes.dql.lang.descartesQL.ObserveRelativeClause#getTimeTarget <em>Time Target</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Time Target</em>'.
   * @see tools.descartes.dql.lang.descartesQL.ObserveRelativeClause#getTimeTarget()
   * @see #getObserveRelativeClause()
   * @generated
   */
  EReference getObserveRelativeClause_TimeTarget();

  /**
   * Returns the meta object for class '{@link tools.descartes.dql.lang.descartesQL.ObserveBetweenClause <em>Observe Between Clause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Observe Between Clause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.ObserveBetweenClause
   * @generated
   */
  EClass getObserveBetweenClause();

  /**
   * Returns the meta object for the attribute '{@link tools.descartes.dql.lang.descartesQL.ObserveBetweenClause#getMode1 <em>Mode1</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Mode1</em>'.
   * @see tools.descartes.dql.lang.descartesQL.ObserveBetweenClause#getMode1()
   * @see #getObserveBetweenClause()
   * @generated
   */
  EAttribute getObserveBetweenClause_Mode1();

  /**
   * Returns the meta object for the containment reference '{@link tools.descartes.dql.lang.descartesQL.ObserveBetweenClause#getStartingTime <em>Starting Time</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Starting Time</em>'.
   * @see tools.descartes.dql.lang.descartesQL.ObserveBetweenClause#getStartingTime()
   * @see #getObserveBetweenClause()
   * @generated
   */
  EReference getObserveBetweenClause_StartingTime();

  /**
   * Returns the meta object for the attribute '{@link tools.descartes.dql.lang.descartesQL.ObserveBetweenClause#getMode2 <em>Mode2</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Mode2</em>'.
   * @see tools.descartes.dql.lang.descartesQL.ObserveBetweenClause#getMode2()
   * @see #getObserveBetweenClause()
   * @generated
   */
  EAttribute getObserveBetweenClause_Mode2();

  /**
   * Returns the meta object for the containment reference '{@link tools.descartes.dql.lang.descartesQL.ObserveBetweenClause#getEndingTime <em>Ending Time</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Ending Time</em>'.
   * @see tools.descartes.dql.lang.descartesQL.ObserveBetweenClause#getEndingTime()
   * @see #getObserveBetweenClause()
   * @generated
   */
  EReference getObserveBetweenClause_EndingTime();

  /**
   * Returns the meta object for class '{@link tools.descartes.dql.lang.descartesQL.RelativeTimeWithSignClause <em>Relative Time With Sign Clause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Relative Time With Sign Clause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.RelativeTimeWithSignClause
   * @generated
   */
  EClass getRelativeTimeWithSignClause();

  /**
   * Returns the meta object for the attribute '{@link tools.descartes.dql.lang.descartesQL.RelativeTimeWithSignClause#getSign <em>Sign</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Sign</em>'.
   * @see tools.descartes.dql.lang.descartesQL.RelativeTimeWithSignClause#getSign()
   * @see #getRelativeTimeWithSignClause()
   * @generated
   */
  EAttribute getRelativeTimeWithSignClause_Sign();

  /**
   * Returns the meta object for the containment reference '{@link tools.descartes.dql.lang.descartesQL.RelativeTimeWithSignClause#getTimeClause <em>Time Clause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Time Clause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.RelativeTimeWithSignClause#getTimeClause()
   * @see #getRelativeTimeWithSignClause()
   * @generated
   */
  EReference getRelativeTimeWithSignClause_TimeClause();

  /**
   * Returns the meta object for class '{@link tools.descartes.dql.lang.descartesQL.BetweenTimeClause <em>Between Time Clause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Between Time Clause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.BetweenTimeClause
   * @generated
   */
  EClass getBetweenTimeClause();

  /**
   * Returns the meta object for class '{@link tools.descartes.dql.lang.descartesQL.TimeClause <em>Time Clause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Time Clause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.TimeClause
   * @generated
   */
  EClass getTimeClause();

  /**
   * Returns the meta object for class '{@link tools.descartes.dql.lang.descartesQL.AbsoluteTimeClause <em>Absolute Time Clause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Absolute Time Clause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.AbsoluteTimeClause
   * @generated
   */
  EClass getAbsoluteTimeClause();

  /**
   * Returns the meta object for the attribute '{@link tools.descartes.dql.lang.descartesQL.AbsoluteTimeClause#getTimeSpec <em>Time Spec</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Time Spec</em>'.
   * @see tools.descartes.dql.lang.descartesQL.AbsoluteTimeClause#getTimeSpec()
   * @see #getAbsoluteTimeClause()
   * @generated
   */
  EAttribute getAbsoluteTimeClause_TimeSpec();

  /**
   * Returns the meta object for class '{@link tools.descartes.dql.lang.descartesQL.RelativeTimeClause <em>Relative Time Clause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Relative Time Clause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.RelativeTimeClause
   * @generated
   */
  EClass getRelativeTimeClause();

  /**
   * Returns the meta object for the containment reference list '{@link tools.descartes.dql.lang.descartesQL.RelativeTimeClause#getDurationClause <em>Duration Clause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Duration Clause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.RelativeTimeClause#getDurationClause()
   * @see #getRelativeTimeClause()
   * @generated
   */
  EReference getRelativeTimeClause_DurationClause();

  /**
   * Returns the meta object for class '{@link tools.descartes.dql.lang.descartesQL.RelativeTimeDurationClause <em>Relative Time Duration Clause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Relative Time Duration Clause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.RelativeTimeDurationClause
   * @generated
   */
  EClass getRelativeTimeDurationClause();

  /**
   * Returns the meta object for the attribute '{@link tools.descartes.dql.lang.descartesQL.RelativeTimeDurationClause#getDuration <em>Duration</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Duration</em>'.
   * @see tools.descartes.dql.lang.descartesQL.RelativeTimeDurationClause#getDuration()
   * @see #getRelativeTimeDurationClause()
   * @generated
   */
  EAttribute getRelativeTimeDurationClause_Duration();

  /**
   * Returns the meta object for the attribute '{@link tools.descartes.dql.lang.descartesQL.RelativeTimeDurationClause#getTimeModifier <em>Time Modifier</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Time Modifier</em>'.
   * @see tools.descartes.dql.lang.descartesQL.RelativeTimeDurationClause#getTimeModifier()
   * @see #getRelativeTimeDurationClause()
   * @generated
   */
  EAttribute getRelativeTimeDurationClause_TimeModifier();

  /**
   * Returns the meta object for class '{@link tools.descartes.dql.lang.descartesQL.WhatIfQuery <em>What If Query</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>What If Query</em>'.
   * @see tools.descartes.dql.lang.descartesQL.WhatIfQuery
   * @generated
   */
  EClass getWhatIfQuery();

  /**
   * Returns the meta object for the containment reference '{@link tools.descartes.dql.lang.descartesQL.WhatIfQuery#getWhatIfVariation <em>What If Variation</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>What If Variation</em>'.
   * @see tools.descartes.dql.lang.descartesQL.WhatIfQuery#getWhatIfVariation()
   * @see #getWhatIfQuery()
   * @generated
   */
  EReference getWhatIfQuery_WhatIfVariation();

  /**
   * Returns the meta object for the containment reference '{@link tools.descartes.dql.lang.descartesQL.WhatIfQuery#getMetricReferenceClauses <em>Metric Reference Clauses</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Metric Reference Clauses</em>'.
   * @see tools.descartes.dql.lang.descartesQL.WhatIfQuery#getMetricReferenceClauses()
   * @see #getWhatIfQuery()
   * @generated
   */
  EReference getWhatIfQuery_MetricReferenceClauses();

  /**
   * Returns the meta object for the containment reference '{@link tools.descartes.dql.lang.descartesQL.WhatIfQuery#getForClause <em>For Clause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>For Clause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.WhatIfQuery#getForClause()
   * @see #getWhatIfQuery()
   * @generated
   */
  EReference getWhatIfQuery_ForClause();

  /**
   * Returns the meta object for the containment reference '{@link tools.descartes.dql.lang.descartesQL.WhatIfQuery#getFilteringClause <em>Filtering Clause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Filtering Clause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.WhatIfQuery#getFilteringClause()
   * @see #getWhatIfQuery()
   * @generated
   */
  EReference getWhatIfQuery_FilteringClause();

  /**
   * Returns the meta object for the attribute '{@link tools.descartes.dql.lang.descartesQL.WhatIfQuery#getDeltaClause <em>Delta Clause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Delta Clause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.WhatIfQuery#getDeltaClause()
   * @see #getWhatIfQuery()
   * @generated
   */
  EAttribute getWhatIfQuery_DeltaClause();

  /**
   * Returns the meta object for the containment reference '{@link tools.descartes.dql.lang.descartesQL.WhatIfQuery#getUsingClause <em>Using Clause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Using Clause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.WhatIfQuery#getUsingClause()
   * @see #getWhatIfQuery()
   * @generated
   */
  EReference getWhatIfQuery_UsingClause();

  /**
   * Returns the meta object for class '{@link tools.descartes.dql.lang.descartesQL.WhatIfVariation <em>What If Variation</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>What If Variation</em>'.
   * @see tools.descartes.dql.lang.descartesQL.WhatIfVariation
   * @generated
   */
  EClass getWhatIfVariation();

  /**
   * Returns the meta object for the containment reference list '{@link tools.descartes.dql.lang.descartesQL.WhatIfVariation#getWhatIfVariationClause <em>What If Variation Clause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>What If Variation Clause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.WhatIfVariation#getWhatIfVariationClause()
   * @see #getWhatIfVariation()
   * @generated
   */
  EReference getWhatIfVariation_WhatIfVariationClause();

  /**
   * Returns the meta object for class '{@link tools.descartes.dql.lang.descartesQL.FilteringClause <em>Filtering Clause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Filtering Clause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.FilteringClause
   * @generated
   */
  EClass getFilteringClause();

  /**
   * Returns the meta object for the containment reference '{@link tools.descartes.dql.lang.descartesQL.FilteringClause#getFilterungRule <em>Filterung Rule</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Filterung Rule</em>'.
   * @see tools.descartes.dql.lang.descartesQL.FilteringClause#getFilterungRule()
   * @see #getFilteringClause()
   * @generated
   */
  EReference getFilteringClause_FilterungRule();

  /**
   * Returns the meta object for the containment reference '{@link tools.descartes.dql.lang.descartesQL.FilteringClause#getFilteringStrategy <em>Filtering Strategy</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Filtering Strategy</em>'.
   * @see tools.descartes.dql.lang.descartesQL.FilteringClause#getFilteringStrategy()
   * @see #getFilteringClause()
   * @generated
   */
  EReference getFilteringClause_FilteringStrategy();

  /**
   * Returns the meta object for class '{@link tools.descartes.dql.lang.descartesQL.FilteringStrategy <em>Filtering Strategy</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Filtering Strategy</em>'.
   * @see tools.descartes.dql.lang.descartesQL.FilteringStrategy
   * @generated
   */
  EClass getFilteringStrategy();

  /**
   * Returns the meta object for the attribute '{@link tools.descartes.dql.lang.descartesQL.FilteringStrategy#getFilteringStrategy <em>Filtering Strategy</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Filtering Strategy</em>'.
   * @see tools.descartes.dql.lang.descartesQL.FilteringStrategy#getFilteringStrategy()
   * @see #getFilteringStrategy()
   * @generated
   */
  EAttribute getFilteringStrategy_FilteringStrategy();

  /**
   * Returns the meta object for class '{@link tools.descartes.dql.lang.descartesQL.FilterigRule <em>Filterig Rule</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Filterig Rule</em>'.
   * @see tools.descartes.dql.lang.descartesQL.FilterigRule
   * @generated
   */
  EClass getFilterigRule();

  /**
   * Returns the meta object for the containment reference '{@link tools.descartes.dql.lang.descartesQL.FilterigRule#getFilteringValue <em>Filtering Value</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Filtering Value</em>'.
   * @see tools.descartes.dql.lang.descartesQL.FilterigRule#getFilteringValue()
   * @see #getFilterigRule()
   * @generated
   */
  EReference getFilterigRule_FilteringValue();

  /**
   * Returns the meta object for the attribute '{@link tools.descartes.dql.lang.descartesQL.FilterigRule#getModifier <em>Modifier</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Modifier</em>'.
   * @see tools.descartes.dql.lang.descartesQL.FilterigRule#getModifier()
   * @see #getFilterigRule()
   * @generated
   */
  EAttribute getFilterigRule_Modifier();

  /**
   * Returns the meta object for class '{@link tools.descartes.dql.lang.descartesQL.WhatIfVariationClause <em>What If Variation Clause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>What If Variation Clause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.WhatIfVariationClause
   * @generated
   */
  EClass getWhatIfVariationClause();

  /**
   * Returns the meta object for the attribute '{@link tools.descartes.dql.lang.descartesQL.WhatIfVariationClause#getVariationPoint <em>Variation Point</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Variation Point</em>'.
   * @see tools.descartes.dql.lang.descartesQL.WhatIfVariationClause#getVariationPoint()
   * @see #getWhatIfVariationClause()
   * @generated
   */
  EAttribute getWhatIfVariationClause_VariationPoint();

  /**
   * Returns the meta object for the containment reference '{@link tools.descartes.dql.lang.descartesQL.WhatIfVariationClause#getValues <em>Values</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Values</em>'.
   * @see tools.descartes.dql.lang.descartesQL.WhatIfVariationClause#getValues()
   * @see #getWhatIfVariationClause()
   * @generated
   */
  EReference getWhatIfVariationClause_Values();

  /**
   * Returns the meta object for class '{@link tools.descartes.dql.lang.descartesQL.WhatIfValueVariationClause <em>What If Value Variation Clause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>What If Value Variation Clause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.WhatIfValueVariationClause
   * @generated
   */
  EClass getWhatIfValueVariationClause();

  /**
   * Returns the meta object for the containment reference '{@link tools.descartes.dql.lang.descartesQL.WhatIfValueVariationClause#getDofVariationClause <em>Dof Variation Clause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Dof Variation Clause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.WhatIfValueVariationClause#getDofVariationClause()
   * @see #getWhatIfValueVariationClause()
   * @generated
   */
  EReference getWhatIfValueVariationClause_DofVariationClause();

  /**
   * Returns the meta object for the containment reference '{@link tools.descartes.dql.lang.descartesQL.WhatIfValueVariationClause#getMultipleArithmethicClause <em>Multiple Arithmethic Clause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Multiple Arithmethic Clause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.WhatIfValueVariationClause#getMultipleArithmethicClause()
   * @see #getWhatIfValueVariationClause()
   * @generated
   */
  EReference getWhatIfValueVariationClause_MultipleArithmethicClause();

  /**
   * Returns the meta object for class '{@link tools.descartes.dql.lang.descartesQL.MultipleArithmeticClause <em>Multiple Arithmetic Clause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Multiple Arithmetic Clause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.MultipleArithmeticClause
   * @generated
   */
  EClass getMultipleArithmeticClause();

  /**
   * Returns the meta object for the containment reference list '{@link tools.descartes.dql.lang.descartesQL.MultipleArithmeticClause#getMultiClause <em>Multi Clause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Multi Clause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.MultipleArithmeticClause#getMultiClause()
   * @see #getMultipleArithmeticClause()
   * @generated
   */
  EReference getMultipleArithmeticClause_MultiClause();

  /**
   * Returns the meta object for class '{@link tools.descartes.dql.lang.descartesQL.ArithmeticClause <em>Arithmetic Clause</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Arithmetic Clause</em>'.
   * @see tools.descartes.dql.lang.descartesQL.ArithmeticClause
   * @generated
   */
  EClass getArithmeticClause();

  /**
   * Returns the meta object for the attribute '{@link tools.descartes.dql.lang.descartesQL.ArithmeticClause#getMode <em>Mode</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Mode</em>'.
   * @see tools.descartes.dql.lang.descartesQL.ArithmeticClause#getMode()
   * @see #getArithmeticClause()
   * @generated
   */
  EAttribute getArithmeticClause_Mode();

  /**
   * Returns the meta object for the containment reference '{@link tools.descartes.dql.lang.descartesQL.ArithmeticClause#getValue <em>Value</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Value</em>'.
   * @see tools.descartes.dql.lang.descartesQL.ArithmeticClause#getValue()
   * @see #getArithmeticClause()
   * @generated
   */
  EReference getArithmeticClause_Value();

  /**
   * Returns the meta object for class '{@link tools.descartes.dql.lang.descartesQL.VariableValue <em>Variable Value</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Variable Value</em>'.
   * @see tools.descartes.dql.lang.descartesQL.VariableValue
   * @generated
   */
  EClass getVariableValue();

  /**
   * Returns the meta object for the attribute '{@link tools.descartes.dql.lang.descartesQL.VariableValue#getIntValue <em>Int Value</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Int Value</em>'.
   * @see tools.descartes.dql.lang.descartesQL.VariableValue#getIntValue()
   * @see #getVariableValue()
   * @generated
   */
  EAttribute getVariableValue_IntValue();

  /**
   * Returns the meta object for the attribute '{@link tools.descartes.dql.lang.descartesQL.VariableValue#getDoubleValue <em>Double Value</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Double Value</em>'.
   * @see tools.descartes.dql.lang.descartesQL.VariableValue#getDoubleValue()
   * @see #getVariableValue()
   * @generated
   */
  EAttribute getVariableValue_DoubleValue();

  /**
   * Returns the meta object for enum '{@link tools.descartes.dql.lang.descartesQL.FilterConjunction <em>Filter Conjunction</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for enum '<em>Filter Conjunction</em>'.
   * @see tools.descartes.dql.lang.descartesQL.FilterConjunction
   * @generated
   */
  EEnum getFilterConjunction();

  /**
   * Returns the meta object for enum '{@link tools.descartes.dql.lang.descartesQL.FilterConditionType <em>Filter Condition Type</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for enum '<em>Filter Condition Type</em>'.
   * @see tools.descartes.dql.lang.descartesQL.FilterConditionType
   * @generated
   */
  EEnum getFilterConditionType();

  /**
   * Returns the meta object for enum '{@link tools.descartes.dql.lang.descartesQL.ObserveRelativeDirectionType <em>Observe Relative Direction Type</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for enum '<em>Observe Relative Direction Type</em>'.
   * @see tools.descartes.dql.lang.descartesQL.ObserveRelativeDirectionType
   * @generated
   */
  EEnum getObserveRelativeDirectionType();

  /**
   * Returns the meta object for enum '{@link tools.descartes.dql.lang.descartesQL.RelativeTimeSignType <em>Relative Time Sign Type</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for enum '<em>Relative Time Sign Type</em>'.
   * @see tools.descartes.dql.lang.descartesQL.RelativeTimeSignType
   * @generated
   */
  EEnum getRelativeTimeSignType();

  /**
   * Returns the meta object for enum '{@link tools.descartes.dql.lang.descartesQL.TimeModifierType <em>Time Modifier Type</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for enum '<em>Time Modifier Type</em>'.
   * @see tools.descartes.dql.lang.descartesQL.TimeModifierType
   * @generated
   */
  EEnum getTimeModifierType();

  /**
   * Returns the meta object for enum '{@link tools.descartes.dql.lang.descartesQL.StatisticalAggregateType <em>Statistical Aggregate Type</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for enum '<em>Statistical Aggregate Type</em>'.
   * @see tools.descartes.dql.lang.descartesQL.StatisticalAggregateType
   * @generated
   */
  EEnum getStatisticalAggregateType();

  /**
   * Returns the factory that creates the instances of the model.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the factory that creates the instances of the model.
   * @generated
   */
  DescartesQLFactory getDescartesQLFactory();

  /**
   * <!-- begin-user-doc -->
   * Defines literals for the meta objects that represent
   * <ul>
   *   <li>each class,</li>
   *   <li>each feature of each class,</li>
   *   <li>each enum,</li>
   *   <li>and each data type</li>
   * </ul>
   * <!-- end-user-doc -->
   * @generated
   */
  interface Literals
  {
    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.impl.DescartesQLImpl <em>Descartes QL</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLImpl
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getDescartesQL()
     * @generated
     */
    EClass DESCARTES_QL = eINSTANCE.getDescartesQL();

    /**
     * The meta object literal for the '<em><b>Query</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference DESCARTES_QL__QUERY = eINSTANCE.getDescartesQL_Query();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.impl.ModelStructureQueryImpl <em>Model Structure Query</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.impl.ModelStructureQueryImpl
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getModelStructureQuery()
     * @generated
     */
    EClass MODEL_STRUCTURE_QUERY = eINSTANCE.getModelStructureQuery();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.impl.PerformanceMetricsQueryImpl <em>Performance Metrics Query</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.impl.PerformanceMetricsQueryImpl
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getPerformanceMetricsQuery()
     * @generated
     */
    EClass PERFORMANCE_METRICS_QUERY = eINSTANCE.getPerformanceMetricsQuery();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.impl.PerformanceIssueQueryImpl <em>Performance Issue Query</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.impl.PerformanceIssueQueryImpl
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getPerformanceIssueQuery()
     * @generated
     */
    EClass PERFORMANCE_ISSUE_QUERY = eINSTANCE.getPerformanceIssueQuery();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.impl.ConnectorCapabilityQueryImpl <em>Connector Capability Query</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.impl.ConnectorCapabilityQueryImpl
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getConnectorCapabilityQuery()
     * @generated
     */
    EClass CONNECTOR_CAPABILITY_QUERY = eINSTANCE.getConnectorCapabilityQuery();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.impl.ListQueryImpl <em>List Query</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.impl.ListQueryImpl
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getListQuery()
     * @generated
     */
    EClass LIST_QUERY = eINSTANCE.getListQuery();

    /**
     * The meta object literal for the '<em><b>Query Type</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference LIST_QUERY__QUERY_TYPE = eINSTANCE.getListQuery_QueryType();

    /**
     * The meta object literal for the '<em><b>Filter Clause</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference LIST_QUERY__FILTER_CLAUSE = eINSTANCE.getListQuery_FilterClause();

    /**
     * The meta object literal for the '<em><b>Using Clause</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference LIST_QUERY__USING_CLAUSE = eINSTANCE.getListQuery_UsingClause();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.impl.GetQueryImpl <em>Get Query</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.impl.GetQueryImpl
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getGetQuery()
     * @generated
     */
    EClass GET_QUERY = eINSTANCE.getGetQuery();

    /**
     * The meta object literal for the '<em><b>Query Tape</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference GET_QUERY__QUERY_TAPE = eINSTANCE.getGetQuery_QueryTape();

    /**
     * The meta object literal for the '<em><b>Using Clause</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference GET_QUERY__USING_CLAUSE = eINSTANCE.getGetQuery_UsingClause();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.impl.GetConstraintsQueryImpl <em>Get Constraints Query</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.impl.GetConstraintsQueryImpl
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getGetConstraintsQuery()
     * @generated
     */
    EClass GET_CONSTRAINTS_QUERY = eINSTANCE.getGetConstraintsQuery();

    /**
     * The meta object literal for the '<em><b>Mode</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute GET_CONSTRAINTS_QUERY__MODE = eINSTANCE.getGetConstraintsQuery_Mode();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.impl.GetExplorationStrategiesQueryImpl <em>Get Exploration Strategies Query</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.impl.GetExplorationStrategiesQueryImpl
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getGetExplorationStrategiesQuery()
     * @generated
     */
    EClass GET_EXPLORATION_STRATEGIES_QUERY = eINSTANCE.getGetExplorationStrategiesQuery();

    /**
     * The meta object literal for the '<em><b>Mode</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute GET_EXPLORATION_STRATEGIES_QUERY__MODE = eINSTANCE.getGetExplorationStrategiesQuery_Mode();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.impl.GetTimeUnitsQueryImpl <em>Get Time Units Query</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.impl.GetTimeUnitsQueryImpl
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getGetTimeUnitsQuery()
     * @generated
     */
    EClass GET_TIME_UNITS_QUERY = eINSTANCE.getGetTimeUnitsQuery();

    /**
     * The meta object literal for the '<em><b>Mode</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute GET_TIME_UNITS_QUERY__MODE = eINSTANCE.getGetTimeUnitsQuery_Mode();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.impl.ListDoFQueryImpl <em>List Do FQuery</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.impl.ListDoFQueryImpl
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getListDoFQuery()
     * @generated
     */
    EClass LIST_DO_FQUERY = eINSTANCE.getListDoFQuery();

    /**
     * The meta object literal for the '<em><b>Mode</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute LIST_DO_FQUERY__MODE = eINSTANCE.getListDoFQuery_Mode();

    /**
     * The meta object literal for the '<em><b>With Clause</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference LIST_DO_FQUERY__WITH_CLAUSE = eINSTANCE.getListDoFQuery_WithClause();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.impl.ListEntitiesQueryImpl <em>List Entities Query</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.impl.ListEntitiesQueryImpl
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getListEntitiesQuery()
     * @generated
     */
    EClass LIST_ENTITIES_QUERY = eINSTANCE.getListEntitiesQuery();

    /**
     * The meta object literal for the '<em><b>Mode</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute LIST_ENTITIES_QUERY__MODE = eINSTANCE.getListEntitiesQuery_Mode();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.impl.ListMetricsQueryImpl <em>List Metrics Query</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.impl.ListMetricsQueryImpl
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getListMetricsQuery()
     * @generated
     */
    EClass LIST_METRICS_QUERY = eINSTANCE.getListMetricsQuery();

    /**
     * The meta object literal for the '<em><b>Mode</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute LIST_METRICS_QUERY__MODE = eINSTANCE.getListMetricsQuery_Mode();

    /**
     * The meta object literal for the '<em><b>Entity Reference Clause</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference LIST_METRICS_QUERY__ENTITY_REFERENCE_CLAUSE = eINSTANCE.getListMetricsQuery_EntityReferenceClause();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.impl.SelectQueryImpl <em>Select Query</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.impl.SelectQueryImpl
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getSelectQuery()
     * @generated
     */
    EClass SELECT_QUERY = eINSTANCE.getSelectQuery();

    /**
     * The meta object literal for the '<em><b>Metric Reference Clauses</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference SELECT_QUERY__METRIC_REFERENCE_CLAUSES = eINSTANCE.getSelectQuery_MetricReferenceClauses();

    /**
     * The meta object literal for the '<em><b>Constraint Clause</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference SELECT_QUERY__CONSTRAINT_CLAUSE = eINSTANCE.getSelectQuery_ConstraintClause();

    /**
     * The meta object literal for the '<em><b>Dof Clause</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference SELECT_QUERY__DOF_CLAUSE = eINSTANCE.getSelectQuery_DofClause();

    /**
     * The meta object literal for the '<em><b>For Clause</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference SELECT_QUERY__FOR_CLAUSE = eINSTANCE.getSelectQuery_ForClause();

    /**
     * The meta object literal for the '<em><b>Using Clause</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference SELECT_QUERY__USING_CLAUSE = eINSTANCE.getSelectQuery_UsingClause();

    /**
     * The meta object literal for the '<em><b>Observe Clause</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference SELECT_QUERY__OBSERVE_CLAUSE = eINSTANCE.getSelectQuery_ObserveClause();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.impl.MetricReferenceClausesImpl <em>Metric Reference Clauses</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.impl.MetricReferenceClausesImpl
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getMetricReferenceClauses()
     * @generated
     */
    EClass METRIC_REFERENCE_CLAUSES = eINSTANCE.getMetricReferenceClauses();

    /**
     * The meta object literal for the '<em><b>Metric Clause Types</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference METRIC_REFERENCE_CLAUSES__METRIC_CLAUSE_TYPES = eINSTANCE.getMetricReferenceClauses_MetricClauseTypes();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.impl.MetricClauseTypeImpl <em>Metric Clause Type</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.impl.MetricClauseTypeImpl
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getMetricClauseType()
     * @generated
     */
    EClass METRIC_CLAUSE_TYPE = eINSTANCE.getMetricClauseType();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.impl.DetectQueryImpl <em>Detect Query</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.impl.DetectQueryImpl
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getDetectQuery()
     * @generated
     */
    EClass DETECT_QUERY = eINSTANCE.getDetectQuery();

    /**
     * The meta object literal for the '<em><b>Query Type</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference DETECT_QUERY__QUERY_TYPE = eINSTANCE.getDetectQuery_QueryType();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.impl.DetectBottlenecksQueryImpl <em>Detect Bottlenecks Query</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.impl.DetectBottlenecksQueryImpl
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getDetectBottlenecksQuery()
     * @generated
     */
    EClass DETECT_BOTTLENECKS_QUERY = eINSTANCE.getDetectBottlenecksQuery();

    /**
     * The meta object literal for the '<em><b>Dof Clause</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference DETECT_BOTTLENECKS_QUERY__DOF_CLAUSE = eINSTANCE.getDetectBottlenecksQuery_DofClause();

    /**
     * The meta object literal for the '<em><b>Using Clause</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference DETECT_BOTTLENECKS_QUERY__USING_CLAUSE = eINSTANCE.getDetectBottlenecksQuery_UsingClause();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.impl.ConstraintClauseImpl <em>Constraint Clause</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.impl.ConstraintClauseImpl
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getConstraintClause()
     * @generated
     */
    EClass CONSTRAINT_CLAUSE = eINSTANCE.getConstraintClause();

    /**
     * The meta object literal for the '<em><b>Type</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute CONSTRAINT_CLAUSE__TYPE = eINSTANCE.getConstraintClause_Type();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.impl.DoFClauseImpl <em>Do FClause</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.impl.DoFClauseImpl
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getDoFClause()
     * @generated
     */
    EClass DO_FCLAUSE = eINSTANCE.getDoFClause();

    /**
     * The meta object literal for the '<em><b>Mode</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute DO_FCLAUSE__MODE = eINSTANCE.getDoFClause_Mode();

    /**
     * The meta object literal for the '<em><b>Varying Clause</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference DO_FCLAUSE__VARYING_CLAUSE = eINSTANCE.getDoFClause_VaryingClause();

    /**
     * The meta object literal for the '<em><b>Exploration Strategy</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference DO_FCLAUSE__EXPLORATION_STRATEGY = eINSTANCE.getDoFClause_ExplorationStrategy();

    /**
     * The meta object literal for the '<em><b>Constraint Clause</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference DO_FCLAUSE__CONSTRAINT_CLAUSE = eINSTANCE.getDoFClause_ConstraintClause();

    /**
     * The meta object literal for the '<em><b>With Clause</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference DO_FCLAUSE__WITH_CLAUSE = eINSTANCE.getDoFClause_WithClause();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.impl.ExplorationStrategyClauseImpl <em>Exploration Strategy Clause</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.impl.ExplorationStrategyClauseImpl
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getExplorationStrategyClause()
     * @generated
     */
    EClass EXPLORATION_STRATEGY_CLAUSE = eINSTANCE.getExplorationStrategyClause();

    /**
     * The meta object literal for the '<em><b>Mode</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute EXPLORATION_STRATEGY_CLAUSE__MODE = eINSTANCE.getExplorationStrategyClause_Mode();

    /**
     * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute EXPLORATION_STRATEGY_CLAUSE__NAME = eINSTANCE.getExplorationStrategyClause_Name();

    /**
     * The meta object literal for the '<em><b>Parameter Clause</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference EXPLORATION_STRATEGY_CLAUSE__PARAMETER_CLAUSE = eINSTANCE.getExplorationStrategyClause_ParameterClause();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.impl.ConfigurationPropertiesClauseImpl <em>Configuration Properties Clause</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.impl.ConfigurationPropertiesClauseImpl
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getConfigurationPropertiesClause()
     * @generated
     */
    EClass CONFIGURATION_PROPERTIES_CLAUSE = eINSTANCE.getConfigurationPropertiesClause();

    /**
     * The meta object literal for the '<em><b>Mode1</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute CONFIGURATION_PROPERTIES_CLAUSE__MODE1 = eINSTANCE.getConfigurationPropertiesClause_Mode1();

    /**
     * The meta object literal for the '<em><b>Properties</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference CONFIGURATION_PROPERTIES_CLAUSE__PROPERTIES = eINSTANCE.getConfigurationPropertiesClause_Properties();

    /**
     * The meta object literal for the '<em><b>Mode2</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute CONFIGURATION_PROPERTIES_CLAUSE__MODE2 = eINSTANCE.getConfigurationPropertiesClause_Mode2();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.impl.ConfigurationPropertyClauseImpl <em>Configuration Property Clause</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.impl.ConfigurationPropertyClauseImpl
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getConfigurationPropertyClause()
     * @generated
     */
    EClass CONFIGURATION_PROPERTY_CLAUSE = eINSTANCE.getConfigurationPropertyClause();

    /**
     * The meta object literal for the '<em><b>Key</b></em>' attribute list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute CONFIGURATION_PROPERTY_CLAUSE__KEY = eINSTANCE.getConfigurationPropertyClause_Key();

    /**
     * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute CONFIGURATION_PROPERTY_CLAUSE__VALUE = eINSTANCE.getConfigurationPropertyClause_Value();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.impl.DoFVariationClauseImpl <em>Do FVariation Clause</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.impl.DoFVariationClauseImpl
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getDoFVariationClause()
     * @generated
     */
    EClass DO_FVARIATION_CLAUSE = eINSTANCE.getDoFVariationClause();

    /**
     * The meta object literal for the '<em><b>Mode1</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute DO_FVARIATION_CLAUSE__MODE1 = eINSTANCE.getDoFVariationClause_Mode1();

    /**
     * The meta object literal for the '<em><b>Variation</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference DO_FVARIATION_CLAUSE__VARIATION = eINSTANCE.getDoFVariationClause_Variation();

    /**
     * The meta object literal for the '<em><b>Mode2</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute DO_FVARIATION_CLAUSE__MODE2 = eINSTANCE.getDoFVariationClause_Mode2();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.impl.ValueVariationClauseImpl <em>Value Variation Clause</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.impl.ValueVariationClauseImpl
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getValueVariationClause()
     * @generated
     */
    EClass VALUE_VARIATION_CLAUSE = eINSTANCE.getValueVariationClause();

    /**
     * The meta object literal for the '<em><b>Value</b></em>' attribute list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute VALUE_VARIATION_CLAUSE__VALUE = eINSTANCE.getValueVariationClause_Value();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.impl.IntervalVariationClauseImpl <em>Interval Variation Clause</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.impl.IntervalVariationClauseImpl
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getIntervalVariationClause()
     * @generated
     */
    EClass INTERVAL_VARIATION_CLAUSE = eINSTANCE.getIntervalVariationClause();

    /**
     * The meta object literal for the '<em><b>Start</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute INTERVAL_VARIATION_CLAUSE__START = eINSTANCE.getIntervalVariationClause_Start();

    /**
     * The meta object literal for the '<em><b>End</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute INTERVAL_VARIATION_CLAUSE__END = eINSTANCE.getIntervalVariationClause_End();

    /**
     * The meta object literal for the '<em><b>Step</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute INTERVAL_VARIATION_CLAUSE__STEP = eINSTANCE.getIntervalVariationClause_Step();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.impl.VaryingClauseImpl <em>Varying Clause</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.impl.VaryingClauseImpl
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getVaryingClause()
     * @generated
     */
    EClass VARYING_CLAUSE = eINSTANCE.getVaryingClause();

    /**
     * The meta object literal for the '<em><b>Mode</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute VARYING_CLAUSE__MODE = eINSTANCE.getVaryingClause_Mode();

    /**
     * The meta object literal for the '<em><b>Dof References</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference VARYING_CLAUSE__DOF_REFERENCES = eINSTANCE.getVaryingClause_DofReferences();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.impl.DoFReferenceImpl <em>Do FReference</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.impl.DoFReferenceImpl
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getDoFReference()
     * @generated
     */
    EClass DO_FREFERENCE = eINSTANCE.getDoFReference();

    /**
     * The meta object literal for the '<em><b>Do FIdentifier</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute DO_FREFERENCE__DO_FIDENTIFIER = eINSTANCE.getDoFReference_DoFIdentifier();

    /**
     * The meta object literal for the '<em><b>Do FAlias Clause</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference DO_FREFERENCE__DO_FALIAS_CLAUSE = eINSTANCE.getDoFReference_DoFAliasClause();

    /**
     * The meta object literal for the '<em><b>Do FVariation Clause</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference DO_FREFERENCE__DO_FVARIATION_CLAUSE = eINSTANCE.getDoFReference_DoFVariationClause();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.impl.MetricClauseImpl <em>Metric Clause</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.impl.MetricClauseImpl
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getMetricClause()
     * @generated
     */
    EClass METRIC_CLAUSE = eINSTANCE.getMetricClause();

    /**
     * The meta object literal for the '<em><b>Metric Reference</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference METRIC_CLAUSE__METRIC_REFERENCE = eINSTANCE.getMetricClause_MetricReference();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.impl.AggregateMetricClauseImpl <em>Aggregate Metric Clause</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.impl.AggregateMetricClauseImpl
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getAggregateMetricClause()
     * @generated
     */
    EClass AGGREGATE_METRIC_CLAUSE = eINSTANCE.getAggregateMetricClause();

    /**
     * The meta object literal for the '<em><b>Function</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute AGGREGATE_METRIC_CLAUSE__FUNCTION = eINSTANCE.getAggregateMetricClause_Function();

    /**
     * The meta object literal for the '<em><b>Metrics</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference AGGREGATE_METRIC_CLAUSE__METRICS = eINSTANCE.getAggregateMetricClause_Metrics();

    /**
     * The meta object literal for the '<em><b>Properties</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference AGGREGATE_METRIC_CLAUSE__PROPERTIES = eINSTANCE.getAggregateMetricClause_Properties();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.impl.MetricClausesImpl <em>Metric Clauses</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.impl.MetricClausesImpl
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getMetricClauses()
     * @generated
     */
    EClass METRIC_CLAUSES = eINSTANCE.getMetricClauses();

    /**
     * The meta object literal for the '<em><b>Metrics</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference METRIC_CLAUSES__METRICS = eINSTANCE.getMetricClauses_Metrics();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.impl.MetricStarClauseImpl <em>Metric Star Clause</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.impl.MetricStarClauseImpl
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getMetricStarClause()
     * @generated
     */
    EClass METRIC_STAR_CLAUSE = eINSTANCE.getMetricStarClause();

    /**
     * The meta object literal for the '<em><b>Metric Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute METRIC_STAR_CLAUSE__METRIC_NAME = eINSTANCE.getMetricStarClause_MetricName();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.impl.MetricReferenceImpl <em>Metric Reference</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.impl.MetricReferenceImpl
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getMetricReference()
     * @generated
     */
    EClass METRIC_REFERENCE = eINSTANCE.getMetricReference();

    /**
     * The meta object literal for the '<em><b>Entity Reference</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute METRIC_REFERENCE__ENTITY_REFERENCE = eINSTANCE.getMetricReference_EntityReference();

    /**
     * The meta object literal for the '<em><b>Separator</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute METRIC_REFERENCE__SEPARATOR = eINSTANCE.getMetricReference_Separator();

    /**
     * The meta object literal for the '<em><b>Metric Reference</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute METRIC_REFERENCE__METRIC_REFERENCE = eINSTANCE.getMetricReference_MetricReference();

    /**
     * The meta object literal for the '<em><b>Separatorv</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute METRIC_REFERENCE__SEPARATORV = eINSTANCE.getMetricReference_Separatorv();

    /**
     * The meta object literal for the '<em><b>Stat Type Reference</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute METRIC_REFERENCE__STAT_TYPE_REFERENCE = eINSTANCE.getMetricReference_StatTypeReference();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.impl.ForClauseImpl <em>For Clause</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.impl.ForClauseImpl
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getForClause()
     * @generated
     */
    EClass FOR_CLAUSE = eINSTANCE.getForClause();

    /**
     * The meta object literal for the '<em><b>Mode</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute FOR_CLAUSE__MODE = eINSTANCE.getForClause_Mode();

    /**
     * The meta object literal for the '<em><b>Entity Reference Clause</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference FOR_CLAUSE__ENTITY_REFERENCE_CLAUSE = eINSTANCE.getForClause_EntityReferenceClause();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.impl.EntityReferenceClauseImpl <em>Entity Reference Clause</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.impl.EntityReferenceClauseImpl
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getEntityReferenceClause()
     * @generated
     */
    EClass ENTITY_REFERENCE_CLAUSE = eINSTANCE.getEntityReferenceClause();

    /**
     * The meta object literal for the '<em><b>Entity References</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference ENTITY_REFERENCE_CLAUSE__ENTITY_REFERENCES = eINSTANCE.getEntityReferenceClause_EntityReferences();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.impl.EntityReferenceImpl <em>Entity Reference</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.impl.EntityReferenceImpl
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getEntityReference()
     * @generated
     */
    EClass ENTITY_REFERENCE = eINSTANCE.getEntityReference();

    /**
     * The meta object literal for the '<em><b>Type</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute ENTITY_REFERENCE__TYPE = eINSTANCE.getEntityReference_Type();

    /**
     * The meta object literal for the '<em><b>Identifier</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute ENTITY_REFERENCE__IDENTIFIER = eINSTANCE.getEntityReference_Identifier();

    /**
     * The meta object literal for the '<em><b>Alias</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference ENTITY_REFERENCE__ALIAS = eINSTANCE.getEntityReference_Alias();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.impl.AliasClauseImpl <em>Alias Clause</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.impl.AliasClauseImpl
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getAliasClause()
     * @generated
     */
    EClass ALIAS_CLAUSE = eINSTANCE.getAliasClause();

    /**
     * The meta object literal for the '<em><b>Mode</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute ALIAS_CLAUSE__MODE = eINSTANCE.getAliasClause_Mode();

    /**
     * The meta object literal for the '<em><b>Alias</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute ALIAS_CLAUSE__ALIAS = eINSTANCE.getAliasClause_Alias();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.impl.UsingClauseImpl <em>Using Clause</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.impl.UsingClauseImpl
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getUsingClause()
     * @generated
     */
    EClass USING_CLAUSE = eINSTANCE.getUsingClause();

    /**
     * The meta object literal for the '<em><b>Mode</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute USING_CLAUSE__MODE = eINSTANCE.getUsingClause_Mode();

    /**
     * The meta object literal for the '<em><b>Model Reference</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference USING_CLAUSE__MODEL_REFERENCE = eINSTANCE.getUsingClause_ModelReference();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.impl.WithClauseImpl <em>With Clause</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.impl.WithClauseImpl
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getWithClause()
     * @generated
     */
    EClass WITH_CLAUSE = eINSTANCE.getWithClause();

    /**
     * The meta object literal for the '<em><b>Mode</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute WITH_CLAUSE__MODE = eINSTANCE.getWithClause_Mode();

    /**
     * The meta object literal for the '<em><b>Model Reference</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference WITH_CLAUSE__MODEL_REFERENCE = eINSTANCE.getWithClause_ModelReference();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.impl.ModelReferenceClauseImpl <em>Model Reference Clause</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.impl.ModelReferenceClauseImpl
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getModelReferenceClause()
     * @generated
     */
    EClass MODEL_REFERENCE_CLAUSE = eINSTANCE.getModelReferenceClause();

    /**
     * The meta object literal for the '<em><b>Family</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference MODEL_REFERENCE_CLAUSE__FAMILY = eINSTANCE.getModelReferenceClause_Family();

    /**
     * The meta object literal for the '<em><b>Model</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference MODEL_REFERENCE_CLAUSE__MODEL = eINSTANCE.getModelReferenceClause_Model();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.impl.ModelFamilyImpl <em>Model Family</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.impl.ModelFamilyImpl
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getModelFamily()
     * @generated
     */
    EClass MODEL_FAMILY = eINSTANCE.getModelFamily();

    /**
     * The meta object literal for the '<em><b>Family</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute MODEL_FAMILY__FAMILY = eINSTANCE.getModelFamily_Family();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.impl.ModelLocationImpl <em>Model Location</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.impl.ModelLocationImpl
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getModelLocation()
     * @generated
     */
    EClass MODEL_LOCATION = eINSTANCE.getModelLocation();

    /**
     * The meta object literal for the '<em><b>Location</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute MODEL_LOCATION__LOCATION = eINSTANCE.getModelLocation_Location();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.impl.FilterClauseImpl <em>Filter Clause</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.impl.FilterClauseImpl
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getFilterClause()
     * @generated
     */
    EClass FILTER_CLAUSE = eINSTANCE.getFilterClause();

    /**
     * The meta object literal for the '<em><b>Mode</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute FILTER_CLAUSE__MODE = eINSTANCE.getFilterClause_Mode();

    /**
     * The meta object literal for the '<em><b>Filter Conditions</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference FILTER_CLAUSE__FILTER_CONDITIONS = eINSTANCE.getFilterClause_FilterConditions();

    /**
     * The meta object literal for the '<em><b>Filter Conjunctions</b></em>' attribute list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute FILTER_CLAUSE__FILTER_CONJUNCTIONS = eINSTANCE.getFilterClause_FilterConjunctions();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.impl.FilterConditionClauseImpl <em>Filter Condition Clause</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.impl.FilterConditionClauseImpl
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getFilterConditionClause()
     * @generated
     */
    EClass FILTER_CONDITION_CLAUSE = eINSTANCE.getFilterConditionClause();

    /**
     * The meta object literal for the '<em><b>Mode</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute FILTER_CONDITION_CLAUSE__MODE = eINSTANCE.getFilterConditionClause_Mode();

    /**
     * The meta object literal for the '<em><b>Condition</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute FILTER_CONDITION_CLAUSE__CONDITION = eINSTANCE.getFilterConditionClause_Condition();

    /**
     * The meta object literal for the '<em><b>Value</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference FILTER_CONDITION_CLAUSE__VALUE = eINSTANCE.getFilterConditionClause_Value();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.impl.FilterConditionValueImpl <em>Filter Condition Value</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.impl.FilterConditionValueImpl
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getFilterConditionValue()
     * @generated
     */
    EClass FILTER_CONDITION_VALUE = eINSTANCE.getFilterConditionValue();

    /**
     * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute FILTER_CONDITION_VALUE__VALUE = eINSTANCE.getFilterConditionValue_Value();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.impl.ObserveClauseImpl <em>Observe Clause</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.impl.ObserveClauseImpl
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getObserveClause()
     * @generated
     */
    EClass OBSERVE_CLAUSE = eINSTANCE.getObserveClause();

    /**
     * The meta object literal for the '<em><b>Mode</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute OBSERVE_CLAUSE__MODE = eINSTANCE.getObserveClause_Mode();

    /**
     * The meta object literal for the '<em><b>Observation</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference OBSERVE_CLAUSE__OBSERVATION = eINSTANCE.getObserveClause_Observation();

    /**
     * The meta object literal for the '<em><b>Sample Clause</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference OBSERVE_CLAUSE__SAMPLE_CLAUSE = eINSTANCE.getObserveClause_SampleClause();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.impl.ObservationClauseImpl <em>Observation Clause</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.impl.ObservationClauseImpl
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getObservationClause()
     * @generated
     */
    EClass OBSERVATION_CLAUSE = eINSTANCE.getObservationClause();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.impl.SampleClauseImpl <em>Sample Clause</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.impl.SampleClauseImpl
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getSampleClause()
     * @generated
     */
    EClass SAMPLE_CLAUSE = eINSTANCE.getSampleClause();

    /**
     * The meta object literal for the '<em><b>Mode</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute SAMPLE_CLAUSE__MODE = eINSTANCE.getSampleClause_Mode();

    /**
     * The meta object literal for the '<em><b>Duration Clause</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference SAMPLE_CLAUSE__DURATION_CLAUSE = eINSTANCE.getSampleClause_DurationClause();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.impl.ConnectorTimeUnitClauseImpl <em>Connector Time Unit Clause</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.impl.ConnectorTimeUnitClauseImpl
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getConnectorTimeUnitClause()
     * @generated
     */
    EClass CONNECTOR_TIME_UNIT_CLAUSE = eINSTANCE.getConnectorTimeUnitClause();

    /**
     * The meta object literal for the '<em><b>Count</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute CONNECTOR_TIME_UNIT_CLAUSE__COUNT = eINSTANCE.getConnectorTimeUnitClause_Count();

    /**
     * The meta object literal for the '<em><b>Time Indicator</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute CONNECTOR_TIME_UNIT_CLAUSE__TIME_INDICATOR = eINSTANCE.getConnectorTimeUnitClause_TimeIndicator();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.impl.ConnectorInstanceReferenceClauseImpl <em>Connector Instance Reference Clause</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.impl.ConnectorInstanceReferenceClauseImpl
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getConnectorInstanceReferenceClause()
     * @generated
     */
    EClass CONNECTOR_INSTANCE_REFERENCE_CLAUSE = eINSTANCE.getConnectorInstanceReferenceClause();

    /**
     * The meta object literal for the '<em><b>Type</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute CONNECTOR_INSTANCE_REFERENCE_CLAUSE__TYPE = eINSTANCE.getConnectorInstanceReferenceClause_Type();

    /**
     * The meta object literal for the '<em><b>Identifier</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute CONNECTOR_INSTANCE_REFERENCE_CLAUSE__IDENTIFIER = eINSTANCE.getConnectorInstanceReferenceClause_Identifier();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.impl.ObserveRelativeClauseImpl <em>Observe Relative Clause</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.impl.ObserveRelativeClauseImpl
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getObserveRelativeClause()
     * @generated
     */
    EClass OBSERVE_RELATIVE_CLAUSE = eINSTANCE.getObserveRelativeClause();

    /**
     * The meta object literal for the '<em><b>Direction</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute OBSERVE_RELATIVE_CLAUSE__DIRECTION = eINSTANCE.getObserveRelativeClause_Direction();

    /**
     * The meta object literal for the '<em><b>Time Target</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference OBSERVE_RELATIVE_CLAUSE__TIME_TARGET = eINSTANCE.getObserveRelativeClause_TimeTarget();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.impl.ObserveBetweenClauseImpl <em>Observe Between Clause</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.impl.ObserveBetweenClauseImpl
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getObserveBetweenClause()
     * @generated
     */
    EClass OBSERVE_BETWEEN_CLAUSE = eINSTANCE.getObserveBetweenClause();

    /**
     * The meta object literal for the '<em><b>Mode1</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute OBSERVE_BETWEEN_CLAUSE__MODE1 = eINSTANCE.getObserveBetweenClause_Mode1();

    /**
     * The meta object literal for the '<em><b>Starting Time</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference OBSERVE_BETWEEN_CLAUSE__STARTING_TIME = eINSTANCE.getObserveBetweenClause_StartingTime();

    /**
     * The meta object literal for the '<em><b>Mode2</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute OBSERVE_BETWEEN_CLAUSE__MODE2 = eINSTANCE.getObserveBetweenClause_Mode2();

    /**
     * The meta object literal for the '<em><b>Ending Time</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference OBSERVE_BETWEEN_CLAUSE__ENDING_TIME = eINSTANCE.getObserveBetweenClause_EndingTime();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.impl.RelativeTimeWithSignClauseImpl <em>Relative Time With Sign Clause</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.impl.RelativeTimeWithSignClauseImpl
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getRelativeTimeWithSignClause()
     * @generated
     */
    EClass RELATIVE_TIME_WITH_SIGN_CLAUSE = eINSTANCE.getRelativeTimeWithSignClause();

    /**
     * The meta object literal for the '<em><b>Sign</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute RELATIVE_TIME_WITH_SIGN_CLAUSE__SIGN = eINSTANCE.getRelativeTimeWithSignClause_Sign();

    /**
     * The meta object literal for the '<em><b>Time Clause</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference RELATIVE_TIME_WITH_SIGN_CLAUSE__TIME_CLAUSE = eINSTANCE.getRelativeTimeWithSignClause_TimeClause();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.impl.BetweenTimeClauseImpl <em>Between Time Clause</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.impl.BetweenTimeClauseImpl
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getBetweenTimeClause()
     * @generated
     */
    EClass BETWEEN_TIME_CLAUSE = eINSTANCE.getBetweenTimeClause();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.impl.TimeClauseImpl <em>Time Clause</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.impl.TimeClauseImpl
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getTimeClause()
     * @generated
     */
    EClass TIME_CLAUSE = eINSTANCE.getTimeClause();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.impl.AbsoluteTimeClauseImpl <em>Absolute Time Clause</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.impl.AbsoluteTimeClauseImpl
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getAbsoluteTimeClause()
     * @generated
     */
    EClass ABSOLUTE_TIME_CLAUSE = eINSTANCE.getAbsoluteTimeClause();

    /**
     * The meta object literal for the '<em><b>Time Spec</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute ABSOLUTE_TIME_CLAUSE__TIME_SPEC = eINSTANCE.getAbsoluteTimeClause_TimeSpec();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.impl.RelativeTimeClauseImpl <em>Relative Time Clause</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.impl.RelativeTimeClauseImpl
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getRelativeTimeClause()
     * @generated
     */
    EClass RELATIVE_TIME_CLAUSE = eINSTANCE.getRelativeTimeClause();

    /**
     * The meta object literal for the '<em><b>Duration Clause</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference RELATIVE_TIME_CLAUSE__DURATION_CLAUSE = eINSTANCE.getRelativeTimeClause_DurationClause();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.impl.RelativeTimeDurationClauseImpl <em>Relative Time Duration Clause</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.impl.RelativeTimeDurationClauseImpl
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getRelativeTimeDurationClause()
     * @generated
     */
    EClass RELATIVE_TIME_DURATION_CLAUSE = eINSTANCE.getRelativeTimeDurationClause();

    /**
     * The meta object literal for the '<em><b>Duration</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute RELATIVE_TIME_DURATION_CLAUSE__DURATION = eINSTANCE.getRelativeTimeDurationClause_Duration();

    /**
     * The meta object literal for the '<em><b>Time Modifier</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute RELATIVE_TIME_DURATION_CLAUSE__TIME_MODIFIER = eINSTANCE.getRelativeTimeDurationClause_TimeModifier();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.impl.WhatIfQueryImpl <em>What If Query</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.impl.WhatIfQueryImpl
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getWhatIfQuery()
     * @generated
     */
    EClass WHAT_IF_QUERY = eINSTANCE.getWhatIfQuery();

    /**
     * The meta object literal for the '<em><b>What If Variation</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference WHAT_IF_QUERY__WHAT_IF_VARIATION = eINSTANCE.getWhatIfQuery_WhatIfVariation();

    /**
     * The meta object literal for the '<em><b>Metric Reference Clauses</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference WHAT_IF_QUERY__METRIC_REFERENCE_CLAUSES = eINSTANCE.getWhatIfQuery_MetricReferenceClauses();

    /**
     * The meta object literal for the '<em><b>For Clause</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference WHAT_IF_QUERY__FOR_CLAUSE = eINSTANCE.getWhatIfQuery_ForClause();

    /**
     * The meta object literal for the '<em><b>Filtering Clause</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference WHAT_IF_QUERY__FILTERING_CLAUSE = eINSTANCE.getWhatIfQuery_FilteringClause();

    /**
     * The meta object literal for the '<em><b>Delta Clause</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute WHAT_IF_QUERY__DELTA_CLAUSE = eINSTANCE.getWhatIfQuery_DeltaClause();

    /**
     * The meta object literal for the '<em><b>Using Clause</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference WHAT_IF_QUERY__USING_CLAUSE = eINSTANCE.getWhatIfQuery_UsingClause();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.impl.WhatIfVariationImpl <em>What If Variation</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.impl.WhatIfVariationImpl
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getWhatIfVariation()
     * @generated
     */
    EClass WHAT_IF_VARIATION = eINSTANCE.getWhatIfVariation();

    /**
     * The meta object literal for the '<em><b>What If Variation Clause</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference WHAT_IF_VARIATION__WHAT_IF_VARIATION_CLAUSE = eINSTANCE.getWhatIfVariation_WhatIfVariationClause();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.impl.FilteringClauseImpl <em>Filtering Clause</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.impl.FilteringClauseImpl
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getFilteringClause()
     * @generated
     */
    EClass FILTERING_CLAUSE = eINSTANCE.getFilteringClause();

    /**
     * The meta object literal for the '<em><b>Filterung Rule</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference FILTERING_CLAUSE__FILTERUNG_RULE = eINSTANCE.getFilteringClause_FilterungRule();

    /**
     * The meta object literal for the '<em><b>Filtering Strategy</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference FILTERING_CLAUSE__FILTERING_STRATEGY = eINSTANCE.getFilteringClause_FilteringStrategy();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.impl.FilteringStrategyImpl <em>Filtering Strategy</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.impl.FilteringStrategyImpl
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getFilteringStrategy()
     * @generated
     */
    EClass FILTERING_STRATEGY = eINSTANCE.getFilteringStrategy();

    /**
     * The meta object literal for the '<em><b>Filtering Strategy</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute FILTERING_STRATEGY__FILTERING_STRATEGY = eINSTANCE.getFilteringStrategy_FilteringStrategy();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.impl.FilterigRuleImpl <em>Filterig Rule</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.impl.FilterigRuleImpl
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getFilterigRule()
     * @generated
     */
    EClass FILTERIG_RULE = eINSTANCE.getFilterigRule();

    /**
     * The meta object literal for the '<em><b>Filtering Value</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference FILTERIG_RULE__FILTERING_VALUE = eINSTANCE.getFilterigRule_FilteringValue();

    /**
     * The meta object literal for the '<em><b>Modifier</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute FILTERIG_RULE__MODIFIER = eINSTANCE.getFilterigRule_Modifier();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.impl.WhatIfVariationClauseImpl <em>What If Variation Clause</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.impl.WhatIfVariationClauseImpl
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getWhatIfVariationClause()
     * @generated
     */
    EClass WHAT_IF_VARIATION_CLAUSE = eINSTANCE.getWhatIfVariationClause();

    /**
     * The meta object literal for the '<em><b>Variation Point</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute WHAT_IF_VARIATION_CLAUSE__VARIATION_POINT = eINSTANCE.getWhatIfVariationClause_VariationPoint();

    /**
     * The meta object literal for the '<em><b>Values</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference WHAT_IF_VARIATION_CLAUSE__VALUES = eINSTANCE.getWhatIfVariationClause_Values();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.impl.WhatIfValueVariationClauseImpl <em>What If Value Variation Clause</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.impl.WhatIfValueVariationClauseImpl
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getWhatIfValueVariationClause()
     * @generated
     */
    EClass WHAT_IF_VALUE_VARIATION_CLAUSE = eINSTANCE.getWhatIfValueVariationClause();

    /**
     * The meta object literal for the '<em><b>Dof Variation Clause</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference WHAT_IF_VALUE_VARIATION_CLAUSE__DOF_VARIATION_CLAUSE = eINSTANCE.getWhatIfValueVariationClause_DofVariationClause();

    /**
     * The meta object literal for the '<em><b>Multiple Arithmethic Clause</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference WHAT_IF_VALUE_VARIATION_CLAUSE__MULTIPLE_ARITHMETHIC_CLAUSE = eINSTANCE.getWhatIfValueVariationClause_MultipleArithmethicClause();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.impl.MultipleArithmeticClauseImpl <em>Multiple Arithmetic Clause</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.impl.MultipleArithmeticClauseImpl
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getMultipleArithmeticClause()
     * @generated
     */
    EClass MULTIPLE_ARITHMETIC_CLAUSE = eINSTANCE.getMultipleArithmeticClause();

    /**
     * The meta object literal for the '<em><b>Multi Clause</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference MULTIPLE_ARITHMETIC_CLAUSE__MULTI_CLAUSE = eINSTANCE.getMultipleArithmeticClause_MultiClause();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.impl.ArithmeticClauseImpl <em>Arithmetic Clause</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.impl.ArithmeticClauseImpl
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getArithmeticClause()
     * @generated
     */
    EClass ARITHMETIC_CLAUSE = eINSTANCE.getArithmeticClause();

    /**
     * The meta object literal for the '<em><b>Mode</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute ARITHMETIC_CLAUSE__MODE = eINSTANCE.getArithmeticClause_Mode();

    /**
     * The meta object literal for the '<em><b>Value</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference ARITHMETIC_CLAUSE__VALUE = eINSTANCE.getArithmeticClause_Value();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.impl.VariableValueImpl <em>Variable Value</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.impl.VariableValueImpl
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getVariableValue()
     * @generated
     */
    EClass VARIABLE_VALUE = eINSTANCE.getVariableValue();

    /**
     * The meta object literal for the '<em><b>Int Value</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute VARIABLE_VALUE__INT_VALUE = eINSTANCE.getVariableValue_IntValue();

    /**
     * The meta object literal for the '<em><b>Double Value</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute VARIABLE_VALUE__DOUBLE_VALUE = eINSTANCE.getVariableValue_DoubleValue();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.FilterConjunction <em>Filter Conjunction</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.FilterConjunction
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getFilterConjunction()
     * @generated
     */
    EEnum FILTER_CONJUNCTION = eINSTANCE.getFilterConjunction();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.FilterConditionType <em>Filter Condition Type</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.FilterConditionType
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getFilterConditionType()
     * @generated
     */
    EEnum FILTER_CONDITION_TYPE = eINSTANCE.getFilterConditionType();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.ObserveRelativeDirectionType <em>Observe Relative Direction Type</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.ObserveRelativeDirectionType
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getObserveRelativeDirectionType()
     * @generated
     */
    EEnum OBSERVE_RELATIVE_DIRECTION_TYPE = eINSTANCE.getObserveRelativeDirectionType();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.RelativeTimeSignType <em>Relative Time Sign Type</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.RelativeTimeSignType
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getRelativeTimeSignType()
     * @generated
     */
    EEnum RELATIVE_TIME_SIGN_TYPE = eINSTANCE.getRelativeTimeSignType();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.TimeModifierType <em>Time Modifier Type</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.TimeModifierType
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getTimeModifierType()
     * @generated
     */
    EEnum TIME_MODIFIER_TYPE = eINSTANCE.getTimeModifierType();

    /**
     * The meta object literal for the '{@link tools.descartes.dql.lang.descartesQL.StatisticalAggregateType <em>Statistical Aggregate Type</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tools.descartes.dql.lang.descartesQL.StatisticalAggregateType
     * @see tools.descartes.dql.lang.descartesQL.impl.DescartesQLPackageImpl#getStatisticalAggregateType()
     * @generated
     */
    EEnum STATISTICAL_AGGREGATE_TYPE = eINSTANCE.getStatisticalAggregateType();

  }

} //DescartesQLPackage
